/**
 *   AccountInfoDouble
 *       .
 * @param property_id
 *   [in]   .       ENUM_ACCOUNT_INFO_DOUBLE.
 * @return 
 *     double.
 * @note  : 
 *   SymbolInfoDouble,  SymbolInfoString, SymbolInfoInteger, PrintFormat
 * @date : 2010.02.08
 * @see www.mql5.com/ru/docs/account/accountinfodouble
 */
double  AccountInfoDouble(
   int  property_id      //  
   );
/**
 *   AccountInfoInteger
 *       .
 * @param property_id
 *   [in]   .       ENUM_ACCOUNT_INFO_INTEGER.
 * @return 
 *     long.
 * @note : 
 *         bool, int  long.
 * @note  : 
 *     
 * @date : 2011.07.22
 * @see www.mql5.com/ru/docs/account/accountinfointeger
 */
long  AccountInfoInteger(
   int  property_id      //  
   );
/**
 *   AccountInfoString
 *       .
 * @param property_id
 *   [in]   .       ENUM_ACCOUNT_INFO_STRING.
 * @return 
 *     string.
 * @note  : 
 *     
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/account/accountinfostring
 */
string  AccountInfoString(
   int  property_id      //  
   );
/**
 *   ArrayBsearch
 *            .
 *  ~      double
 *  ~      float
 *  ~      long
 *  ~      int
 *  ~      short
 *  ~      char
 * @param array[]
 *   [in]     .
 * @param value
 *   [in]    .
 * @return 
 *      .
 *       ,   
 *       .
 * @note : 
 *        .
 *         ArraySort().
 * @date : 2013.04.22
 * @see www.mql5.com/ru/docs/array/arraybsearch
 */
int  ArrayBsearch(
   const double&    array[],   //  &nbs;&nbsnbsp;
   double           value      //  
   );
/**
 *   ArrayBsearch
 *            .
 *  ~      double
 *  ~      float
 *  ~      long
 *  ~      int
 *  ~      short
 *  ~      char
 * @param array[]
 *   [in]     .
 * @param value
 *   [in]    .
 * @return 
 *      .
 *       ,   
 *       .
 * @note : 
 *        .
 *         ArraySort().
 * @date : 2013.04.22
 * @see www.mql5.com/ru/docs/array/arraybsearch
 */
int  ArrayBsearch(
   const float&    array[],   //   
   float           value      //  
   );
/**
 *   ArrayBsearch
 *            .
 *  ~      double
 *  ~      float
 *  ~      long
 *  ~      int
 *  ~      short
 *  ~      char
 * @param array[]
 *   [in]     .
 * @param value
 *   [in]    .
 * @return 
 *      .
 *       ,   
 *       .
 * @note : 
 *        .
 *         ArraySort().
 * @date : 2013.04.22
 * @see www.mql5.com/ru/docs/array/arraybsearch
 */
int  ArrayBsearch(
   const long&    array[],   //   
   long           value      //  
   );
/**
 *   ArrayBsearch
 *            .
 *  ~      double
 *  ~      float
 *  ~      long
 *  ~      int
 *  ~      short
 *  ~      char
 * @param array[]
 *   [in]     .
 * @param value
 *   [in]    .
 * @return 
 *      .
 *       ,   
 *       .
 * @note : 
 *        .
 *         ArraySort().
 * @date : 2013.04.22
 * @see www.mql5.com/ru/docs/array/arraybsearch
 */
int  ArrayBsearch(
   const int&    array[],   //   
   int           value      //  
   );
/**
 *   ArrayBsearch
 *            .
 *  ~      double
 *  ~      float
 *  ~      long
 *  ~      int
 *  ~      short
 *  ~      char
 * @param array[]
 *   [in]     .
 * @param value
 *   [in]    .
 * @return 
 *      .
 *       ,   
 *       .
 * @note : 
 *        .
 *         ArraySort().
 * @date : 2013.04.22
 * @see www.mql5.com/ru/docs/array/arraybsearch
 */
int  ArrayBsearch(
   const short&    array[],   //   
   short           value      //  
   );
/**
 *   ArrayBsearch
 *            .
 *  ~      double
 *  ~      float
 *  ~      long
 *  ~      int
 *  ~      short
 *  ~      char
 * @param array[]
 *   [in]     .
 * @param value
 *   [in]    .
 * @return 
 *      .
 *       ,   
 *       .
 * @note : 
 *        .
 *         ArraySort().
 * @date : 2013.04.22
 * @see www.mql5.com/ru/docs/array/arraybsearch
 */
int  ArrayBsearch(
   const char&    array[],   //   
   char           value      //  
   );
/**
 *   ArrayCompare
 *         .
 *          
 *     ,     -
 *       ,  , 
 *         .

 * @param array1[]
 *   [in]   .
 * @param array2[]
 *   [in]   .
 * @param start1=0
 *   [in]       ,    .
 *       - 0.
 * @param start2=0
 *   [in]       ,    .
 *       - 0.
 * @param count=WHOLE_ARRAY
 *   [in]   ,   .
 *         ? 
 *        ?   ? 
 *    ??????   (count=WHOLE_ARRAY).
 * @return 
 *   ~ -1,  array1[]  array2[]
 *   ~ 0,  array1[]  array2[] 
 *   ~ 1,  array1[]  array2[]
 *   ~ -2,     -  
 *      ,    start1, start2
 *    count,       .
 *  
 * @note : 
 *            count=WHOLE_ARRAY  ,
 *         ,
 *      0 (    ).
 *         
 *      : -1,    array1[]
 *      array2[]  1   .
 * @date : 2013.01.28
 * @see www.mql5.com/ru/docs/array/arraycompare
 */
int  ArrayCompare(
   const void&  array1[],            //  
   const void&  array2[],            //  
   uint         start1 = 0,            //     
   uint         start2 = 0,            //     
   uint         count = WHOLE_ARRAY    //    
   );
/**
 *   ArrayCopy
 *        .
 * @param dst_array[]
 *   [out]  -.
 * @param src_array[]
 *   [in]  -.
 * @param dst_start=0
 *   [in]      .  ,   - 0.
 * @param src_start=0
 *   [in]      .  ,   - 0.
 * @param count=WHOLE_ARRAY
 *   [in]   ,   .
 *        (count=WHOLE_ARRAY).
 * @return 
 *      .
 * @note : 
 *    count<0  count>src_size-src_start,     .
 *      .   
 *      
 *         .
 *        ,   
 *   .    ,   
 *      
 *      ? ????
 *          
 *    .     
 *     .  ,
 *    ,  ,  .
 *          
 *      .
 * @date : 2013.04.03
 * @see www.mql5.com/ru/docs/array/arraycopy
 */
int  ArrayCopy(
   void&        dst_array[],         //  
   const void&  src_array[],         //  
   int          dst_start = 0,         //      
   int          src_start = 0,         //      
   int          count = WHOLE_ARRAY    //  
   );
/**
 *   ArrayFill
 *       .
 * @param array[]
 *   [out]     (char, uchar, short, ushort, int, uint,
 *   long, ulong, bool, color, datetime, float, double).
 * @param start
 *   [in]     (   ).
 *         .
 * @param count
 *   [in]   ,   .
 * @param value
 *   [in]  ,    ? ??.
 * @return 
 *     .
 * @note : 
 *      ArrayFill()   
 *       ,   
 *        
 *      ArraySetAsSeries()
 *      .  
 *       ArrayFill()
 *    , ,  array[2][4]
 *     array[8],    
 *           
 *     5.  ,  ArrayFill(array, 5, 2,
 *   3.14)   array[2][4]   3.14
 *     array[1][1]  array[1][2].
 * @date : 2013.04.11
 * @see www.mql5.com/ru/docs/array/arrayfill
 */
void  ArrayFill(
   void&  array[],       // 
   uint   start,         // &n&n?  
   uint   count,         //  
   void   value          // ,   
   );
/**
 *   ArrayFree
 *              0. 
 * @param array[]
 *   [in]   .
 * @return 
 *     .
 * @note : 
 *            ArrayFree()
 *      :     
 *          
 *   ,      
 *          
 *    , 
 *        
 *    .    
 *         
 *    ,   ArrayFree()   
 *      ,  
 *      .
 * @date : 2013.04.03
 * @see www.mql5.com/ru/docs/array/arrayfree
 */
void  ArrayFree(
   void&  array[]      // 
   );
/**
 *   ArrayGetAsSeries
 *      .
 * @param array[]
 *   [in]   .
 * @return 
 *    true,       AS_SERIES,
 *           
 *    .      ,
 *         
 *       (     
 *    ).
 * @note : 
 *             ArrayIsSeries().
 *     ,    
 *       OnCalculate(),   
 *        .  
 *        ArraySetAsSeries().
 * @note  : 
 *   , ArraySetAsSeries
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/array/arraygetasseries
 */
bool  ArrayGetAsSeries(
   const void&  array[]    //   
   );
/**
 *   ArrayInitialize
 *       .
 * @param array[]
 *   [out]   ,   .
 * @param value
 *   [in]   ,      .
 * @return 
 *     .
 * @note : 
 *    ArrayResize()          
 *       
 *    .     ,  
 *      
 *       .
 *      ArrayInitialize(array,
 *   init_val)      
 *     ,    .
 *         array 
 *    ArrayResize()    ,   
 *     ,     ,
 *    ,   init_val.
 * @date : 2013.01.22
 * @see www.mql5.com/ru/docs/array/arrayinitialize
 */
void  ArrayInitialize(
   double  array[],     //  
   double  value        // ,   
   );
/**
 *   ArrayIsDynamic
 *   ,    .
 * @param array[]
 *   [in]  ?? .
 * @return 
 *    true,     ,   false.
 * @note  : 
 *       
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/array/arrayisdynamic
 */
bool  ArrayIsDynamic(
   const void&  array[]    //  
   );
/**
 *   ArrayIsSeries
 *   ,    .
 * @param array[]
 *   [in]   .</span.
 * @return 
 *    true,     -,
 *     false. ,   
 *      OnCalculate(),  
 *          
 *    ArrayGetAsSeries().
 * @note  : 
 *       
 * @date : 2013.03.21
 * @see www.mql5.com/ru/docs/array/arrayisseries
 */
bool  ArrayIsSeries(
   const void&  array[]    //  
   );
/**
 *   ArrayMaximum
 *         .
 * @param array[]
 *   [in]   ,    .
 * @param start=0
 *   [in]     .
 * @param count=WHOLE_ARRAY
 *   [in]     .  ,     (count=WHOLE_ARRAY).
 * @return 
 *           .
 *        -1.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/array/arraymaximum
 */
int  ArrayMaximum(
   const void&   array[],             //   
   int           start = 0,             //     
   int           count = WHOLE_ARRAY    //  
   );
/**
 *   ArrayMinimum
 *         .
 * @param array[]
 *   [in]   ,    .
 * @param start=0
 *   [in]     .
 * @param count=WHOLE_ARRAY
 *   [in]     .  ,     (count=WHOLE_ARRAY).
 * @return 
 *           .
 *        -1.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/array/arrayminimum
 */
int  ArrayMinimum(
   const void&   array[],             //   
   int           start = 0,             //     
   int           count = WHOLE_ARRAY    //  
   );
/**
 *   ArrayRange
 *         .
 * @param array[]
 *   [in]   .
 * @param rank_index
 *   [in]   .
 * @return 
 *        
 * @note : 
 *       ,      ,
 *      .
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/array/arrayrange
 */
int  ArrayRange(
   const void&   array[],      //   
   int           rank_index    //  
   );
/**
 *   ArrayResize
 *         
 * @param array[]
 *   [out]     .
 * @param new_size
 *   [in]      .
 * @param reserve_size=0
 *   [in]     .
 * @return 
 *          ,
 *        ;  
 *      -1     .
 * @note : 
 *         .
 *       ,    
 *      ,   
 *       SetIndexBuffer().
 *          
 *       .  
 *       
 *     ,     
 *      .   
 *     ArrayResize    
 *     ,     
 *         .
 *    ,     
 *     ,    
 *     , :   
 *     2  ,    
 *       2000 ,    
 *       1000    i  2000.
 *      ,   2000 
 *         
 *    .
 * @note  : 
 *   ArrayInitialize
 * @date : 2013.03.21
 * @see www.mql5.com/ru/docs/array/arrayresize
 */
int  ArrayResize(
   void&  array[],              // ,   
   int    new_size,             //   
   int    reserve_size = 0        //    ()
   );
/**
 *   ArraySetAsSeries
 *     AS_SERIES    ,
 *        
 *    .
 * @param array[]
 *   [in][out]     .
 * @param flag
 *   [in]    .
 * @return 
 *    true   ,  false.
 * @note : 
 *    AS_SERIES           
 *   (  ,       
 *      ).
 *          ,
 *         
 *       (     
 *    ).
 * @note  : 
 *   , ArrayGetAsSeries
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/array/arraysetasseries
 */
bool  ArraySetAsSeries(
   const void&  array[],    //   
   bool         flag        // true    
   );
/**
 *   ArraySize
 *       . 
 * @param array[]
 *   [in]    .
 * @return 
 *     int.
 * @note : 
 *      ,   ArraySize,
 *     ArrayRange(array,0).
 * @date : 2013.03.22
 * @see www.mql5.com/ru/docs/array/arraysize
 */
int  ArraySize(
   const void&  array[]    //  
   );
/**
 *   ArraySort
 *         -.
 * @param array[]
 *   [in][out]     .
 * @return 
 *    true   ,  false.
 * @note : 
 *   ,   AS_SERIES,   .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/array/arraysort
 */
bool  ArraySort(
   void&  array[]      //   
   );
/**
 *   ChartApplyTemplate
 *       .

 * @param chart_id
 *   [in]   . 0   .
 * @param filename
 *   [in]   ,  .
 * @return 
 *         true,
 *       false.  
 *      ,    GetLastError().
 * @note : 
 *              ,
 *      ,    
 *       . 
 *      MQL5   
 *     , ...( ).
 * @note  : 
 *   
 * @date : 2011.03.04
 * @see www.mql5.com/ru/docs/chart_operations/chartapplytemplate
 */
bool  ChartApplyTemplate(
   long          chart_id,     //  
   const string  filename      //    
   );
/**
 *   ChartClose
 *     .
 * @param chart_id=0
 *   [in]   . 0   .
 * @return 
 *    true   ,  false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/chart_operations/chartclose
 */
bool  ChartClose(
   long  chart_id = 0      //  
   );
/**
 *   ChartFirst
 *        .
 * @return 
 *    .
 *    
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/chart_operations/chartfirst
 */
long  ChartFirst();
/**
 *   ChartGetDouble
 *        .
 *        double.  2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .  
 *         ,
 *       .
 * @param chart_id
 *   [in]   . 0   .
 * @param prop_id
 *   [in]    .
 *          ENUM_CHART_PROPERTY_DOUBLE.
 * @param sub_window
 *   [in]    .        0
 *   (  ).       .
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.
 *         ?  ? true,
 *             double_var,
 *     false.      ,
 *      GetLastError().
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/chart_operations/chartgetdouble
 */
double  ChartGetDouble(
   long  chart_id,          //  
   int   prop_id,           //  
   int   sub_window = 0       //  ,  
   );
/**
 *   ChartGetDouble
 *        .
 *        double.  2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .  
 *         ,
 *       .
 * @param chart_id
 *   [in]   . 0   .
 * @param prop_id
 *   [in]    .
 *          ENUM_CHART_PROPERTY_DOUBLE.
 * @param sub_window
 *   [in]    .        0
 *   (  ).       .
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.
 *         ?  ? true,
 *             double_var,
 *     false.      ,
 *      GetLastError().
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/chart_operations/chartgetdouble
 */
bool  ChartGetDouble(
   long    chart_id,        //  
   int     prop_id,         //  
   int     sub_window,      //  
   double& double_var       //    
   );
/**
 *   ChartGetInteger
 *        .
 *        datetime,intbool.
 *    2  . ~ 1.    .
 *   ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param chart_id
 *   [in]   . 0   .
 * @param prop_id
 *   [in]    .
 *          
 *    ENUM_CHART_PROPERTY_INTEGER.
 * @param sub_window
 *   [in]    .
 *          0 (
 *     ).     
 *     .
 * @param long_var
 *   [out]    long,     .
 * @return 
 *     long.
 *        true,
 *          
 *      long_var,   false. 
 *        , 
 *      GetLastError().
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/chart_operations/chartgetinteger
 */
long  ChartGetInteger(
   long  chart_id,          //  
   int   prop_id,           //  
   int   sub_window = 0       //  ,  
   );
/**
 *   ChartGetInteger
 *        .
 *        datetime,intbool.
 *    2  . ~ 1.    .
 *   ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param chart_id
 *   [in]   . 0   .
 * @param prop_id
 *   [in]    .
 *          
 *    ENUM_CHART_PROPERTY_INTEGER.
 * @param sub_window
 *   [in]    .
 *          0 (
 *     ).     
 *     .
 * @param long_var
 *   [out]    long,     .
 * @return 
 *     long.
 *        true,
 *          
 *      long_var,   false. 
 *        , 
 *      GetLastError().
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/chart_operations/chartgetinteger
 */
bool  ChartGetInteger(
   long    chart_id,        //  
   int     prop_id,         //  
   int     sub_window,      //  
   long&   long_var         //    
   );
/**
 *   ChartGetString
 *        .
 *        string.  2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *          ,
 *       .
 * @param 
 *   chart_id
 *   [in]   . 0   .
 *   prop_id
 *   [in]    .
 *         
 *    ENUM_CHART_PROPERTY_STRING. string_var [out]  
 *     string,    
 *    .
 * @return 
 *     string.
 *        true,
 *          
 *      string_var,   false. 
 *        , 
 *      GetLastError().
 * @note : 
 *    ChartGetString     ,
 *        Comment  ChartSetString.
 * @note  : 
 *   Comment, ChartSetString
 * @date : 2010.02.08
 * @see www.mql5.com/ru/docs/chart_operations/chartgetstring
 */
string  ChartGetString(
   long  chart_id,          //  
   int   prop_id            //  
   );
/**
 *   ChartGetString
 *        .
 *        string.  2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *          ,
 *       .
 * @param 
 *   chart_id
 *   [in]   . 0   .
 *   prop_id
 *   [in]    .
 *         
 *    ENUM_CHART_PROPERTY_STRING. string_var [out]  
 *     string,    
 *    .
 * @return 
 *     string.
 *        true,
 *          
 *      string_var,   false. 
 *        , 
 *      GetLastError().
 * @note : 
 *    ChartGetString     ,
 *        Comment  ChartSetString.
 * @note  : 
 *   Comment, ChartSetString
 * @date : 2010.02.08
 * @see www.mql5.com/ru/docs/chart_operations/chartgetstring
 */
bool  ChartGetString(
   long    chart_id,        //  
   int     prop_id,         //  
   string& string_var       //    
   );
/**
 *   ChartID
 *      .
 * @return 
 *     long.
 * @date : 2010.07.09
 * @see www.mql5.com/ru/docs/chart_operations/chartid
 */
long  ChartID();
/**
 *   ChartIndicatorAdd
 *           .
 *             .
 * @param chart_id
 *   [in]   . 0   .
 * @param sub_window
 *   [in]    . 0    
 *   .      ,  
 *       ,   
 *     ,    CHART_WINDOWS_TOTAL.
 *       
 *    CHART_WINDOWS_TOTAL,      ,
 *      .
 * @param indicator_handle [in]  .
 * @return 
 *    true   ,  false.
 *       ,  
 *     GetLastError().  4114 ,  
 *         
 *    .
 * @note : 
 *         ,
 *          (
 *   ,  iMACD  
 *        #property
 *   indicator_separate_window),     
 *    ,    
 *      .  ,   
 *           
 *         
 *      .    GetLastError() 
 *     ,   . 
 *     ""    
 *     " "     MQL5-.
 * @note  : 
 *   ChartIndicatorDelete(), ChartIndicatorName(), ChartIndicatorsTotal(), iCustom(), IndicatorCreate()
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/chart_operations/chartindicatoradd
 */
bool  ChartIndicatorAdd(
   long  chart_id,                 //  
   int   sub_window,                //  
   int   indicator_handle          //  
   );
/**
 *   ChartIndicatorDelete
 *           .
 * @param chart_id
 *   [in]   . 0   .
 * @param sub_window
 *   [in]    . 0    .
 * @param const indicator_shortname
 *   [in]    ,    
 *   INDICATOR_SHORTNAME  IndicatorSetString(). 
 *        
 *    ChartIndicatorName().
 * @return 
 *    true     ,  false.
 *       ,  
 *     GetLastError().
 * @note : 
 *          
 *      ,    
 *     .     
 *          ,  
 *      .     
 *       ,    
 *      iCustom()  IndicatorCreate().
 *         
 *    ,        ,
 *      .  
 *       ,     
 *        .   
 *       IndicatorRelease().
 *        ,
 *   
 *      IndicatorSetString()IndicatorSetString()
 *      INDICATOR_SHORTNAME.  
 *   ,       
 *    ,      
 *       ChartIndicatorDelete()
 *       .
 * @note  : 
 *   ChartIndicatorAdd(), ChartIndicatorName(),
 *   ChartIndicatorsTotal(), iCustom(), IndicatorCreate(),
 *   IndicatorSetString()
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/chart_operations/chartindicatordelete
 */
bool  ChartIndicatorDelete(
   long           chart_id,              //  
   int            sub_window,             //  
   const string   indicator_shortname    //   
   );
/**
 *   ChartIndicatorGet
 *             .
 * @param chart_id
 *   [in]   . 0   .
 * @param sub_window
 *   [in]    . 0    .
 * @param const indicator_shortname
 *   [in]    ,    
 *   INDICATOR_SHORTNAME  IndicatorSetString(). 
 *        
 *    ChartIndicatorName().
 * @return 
 *         ,
 *    INVALID_HANDLE.     ,
 *      GetLastError().
 * @note : 
 *           ,
 *       IndicatorSetString() 
 *      INDICATOR_SHORTNAME. , 
 *         
 *    ,    
 *      ChartIndicatorGet()  
 *      .    
 *           
 *       IndicatorParameters()
 *        .
 * @note  : 
 *   ChartIndicatorAdd(), ChartIndicatorName(), ChartIndicatorsTotal(), IndicatorParameters()
 * @date : 2012.06.15
 * @see www.mql5.com/ru/docs/chart_operations/chartindicatorget
 */
int  ChartIndicatorGet(
   long           chart_id,              //  
   int            sub_window,             //  
   const string   indicator_shortname    //   
   );
/**
 *   ChartIndicatorName
 *               .
 * @param chart_id
 *   [in]   . 0   .
 * @param sub_window
 *   [in]    . 0    .
 * @param index
 *   [in]      .
 *       ,    
 *         . 
 *         
 *    ChartIndicatorsTotal().
 * @return 
 *     ,     INDICATOR_SHORTNAME
 *    IndicatorSetString().  
 *      ,  
 *     GetLastError().
 * @note : 
 *           ,
 *       
 *     iCustom()  IndicatorCreate().  
 *         ,  
 *            
 *    .     
 *    , 
 *      IndicatorSetString()   
 *    INDICATOR_SHORTNAME.  ,   
 *        ,  
 *        
 *      ChartIndicatorDelete()  
 *       ChartIndicatorDelete()
 *    te()  ? ? ?
 *      .
 * @note  : 
 *   ChartIndicatorAdd(), ChartIndicatorDelete(),
 *   ChartIndicatorsTotal(), iCustom(), IndicatorCreate(),
 *   IndicatorSetString()
 * @date : 2010.12.01
 * @see www.mql5.com/ru/docs/chart_operations/chartindicatorname
 */
string  ChartIndicatorName(
   long  chart_id,      //  
   int   sub_window,     //  
   int   index          //     ,     
   );
/**
 *   ChartIndicatorsTotal
 *      ,     .
 * @param chart_id
 *   [in]   . 0   .
 * @param sub_window
 *   [in]    . 0    .
 * @return 
 *        .
 *       , 
 *    ? ? ????  GetLastError().
 * @note : 
 *         ,
 *      .    
 *        CHART_WINDOWS_TOTAL 
 *    ChartGetInteger().
 * @note  : 
 *   ChartIndicatorAdd(), ChartIndicatorDelete(), ChartIndicatorsTotal(),
 *   iCustom(), IndicatorCreate(), IndicatorSetString()
 * @date : 2010.11.23
 * @see www.mql5.com/ru/docs/chart_operations/chartindicatorstotal
 */
int  ChartIndicatorsTotal(
   long  chart_id,      //  
   int   sub_window     //  
   );
/**
 *   ChartNavigate
 *           
 *     .
 * @param chart_id
 *   [in]   . 0   .
 * @param position
 *   [in]   ,     .
 *         
 *    ENUM_CHART_POSITION.
 * @param shift=0
 *   [in]   ,     .
 *        ( 
 *    ),     
 *    (  ).    , 
 *          .
 * @return 
 *    true   ,  false.
 * @date : 2011.02.03
 * @see www.mql5.com/ru/docs/chart_operations/chartnavigate
 */
bool  ChartNavigate(
   long  chart_id,     //  
   int   position,     // 
   int   shift = 0       //  
   );
/**
 *   ChartNext
 *      ,   . 
 * @param chart_id
 *   [in]   . 0    .
 *   0  "   ".
 * @return 
 *    .    ,   -1.
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/chart_operations/chartnext
 */
long  ChartNext(
   long  chart_id      //  
   );
/**
 *   ChartOpen
 *          .
 * @param symbol
 *   [in]   . NULL o    (   ).
 * @param period
 *   [in]    ().
 *         ENUM_TIMEFRAMES.
 *   0     .
 * @return 
 *    ??      .
 *       0.
 * @note : 
 *              ,
 *     CHARTS_MAX.
 * @date : 2009.11.23
 * @see www.mql5.com/ru/docs/chart_operations/chartopen
 */
long  ChartOpen(
   string           symbol,     //  
   ENUM_TIMEFRAMES  period      // 
   );
/**
 *   ChartPeriod
 *       .
 * @param chart_id=0
 *   [in]   . 0   .
 * @return 
 *     ENUM_TIMEFRAMES.    ,   0.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/chart_operations/chartperiod
 */
ENUM_TIMEFRAMES  ChartPeriod(
   long  chart_id = 0      //  
   );
/**
 *   ChartPriceOnDropped
 *     ,  ,        .
 * @return 
 *     double.
 * @note  : 
 *   ChartXOnDropped, ChartYOnDropped
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/chart_operations/chartpriceondropped
 */
double  ChartPriceOnDropped();
/**
 *   ChartRedraw
 *       .
 * @param chart_id=0
 *   [in]   . 0   .
 * @note : 
 *       .
 * @note  : 
 *   
 * @date : 2009.11.04
 * @see www.mql5.com/ru/docs/chart_operations/chartredraw
 */
void  ChartRedraw(
   long  chart_id = 0      //  
   );
/**
 *   ChartSaveTemplate
 *           .
 * @param chart_id
 *   [in]   . 0   .
 * @param filename
 *   [in]      .
 *    ".tpl"      
 *   ,    .    
 *    __\Profiles\Templates\
 *           
 *     .       ,
 *        .
 * @return 
 *        true,     false.
 *       ,  
 *     GetLastError().
 * @note : 
 *          
 *        , 
 *         .
 * @note  : 
 *   ChartApplyTemplate(), 
 * @date : 2011.12.01
 * @see www.mql5.com/ru/docs/chart_operations/chartsavetemplate
 */
bool  ChartSaveTemplate(
   long          chart_id,     //  
   const string  filename      //     
   );
/**
 *   ChartScreenShot
 *              gif.
 * @param chart_id
 *   [in]   . 0   .
 * @param filename
 *   [in]    .    63 .     \Files.
 * @param width
 *   [in]     
 * @param height
 *   [in]     
 * @param align_mode=ALIGN_RIGHT
 *   [in]     .  
 *   ENUM_ALIGN_MODE. ALIGN_RIGHT    
 *     (  ). ALIGN_LEFT  
 *      .
 * @return 
 *    true   ,  false.
 * @note : 
 *          ,
 *         
 *     ChartNavigate().   
 *     ,   ,   
 *       ,   ,
 *        align_mode.
 * @note  : 
 *   ChartNavigate(), 
 * @date : 2012.07.12
 * @see www.mql5.com/ru/docs/chart_operations/chartscreenshot
 */
bool  ChartScreenShot(
   long             chart_id,                   //  
   string           filename,                   //  
   int              width,                      // 
   int              height,                     // <?<<
   ENUM_ALIGN_MODE  align_mode = ALIGN_RIGHT      //  
   );
/**
 *   ChartSetDouble
 *        .      double.
 * @param chart_id
 *   [in]   . 0   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_CHART_PROPERTY_DOUBLE ( read-only ).
 * @param value
 *   [in]   .
 * @return 
 *    true   ,  false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/chart_operations/chartsetdouble
 */
bool  ChartSetDouble(
   long    chart_id,     //  
   int     prop_id,      //  
   double  value         // 
   );
/**
 *   ChartSetInteger
 *        .
 *       
 *    datetime,int,color,boolchar.
 * @param chart_id
 *   [in]   . 0   .
 * @param prop_id
 *   [in]    .  
 *        
 *    ENUM_CHART_PROPERTY_INTEGER ( read-only ).
 * @param value
 *   [in]   .
 * @return 
 *    true   ,  false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/chart_operations/chartsetinteger
 */
bool  ChartSetInteger(
   long   chart_id,     //  
   int    prop_id,      //  
   long   value         // 
   );
/**
 *   ChartSetString
 *        .
 *        string.
 * @param chart_id
 *   [in]   . 0   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_CHART_PROPERTY_STRING ( read-only ).
 * @param str_value
 *   [in]     .
 *        2045  ( 
 *     ).
 * @return 
 *    true   ,  false.
 * @note : 
 *    ChartSetString          Comment. 
 * @note  : 
 *   Comment, ChartGetString
 * @date : 2010.02.08
 * @see www.mql5.com/ru/docs/chart_operations/chartsetstring
 */
bool  ChartSetString(
   long  chart_id,         //  
   int   prop_id,          //  
   string   str_value      // 
   );
/**
 *   ChartSetSymbolPeriod
 *         .
 *     ,       
 *      .
 * @param chart_id
 *   [in]   . 0   .
 * @param symbol
 *   [in]   . NULL o    (   )
 * @param period
 *   [in]    ().
 *         
 *    ENUM_TIMEFRAMES. 0    .
 * @return 
 *    true   ,  false.
 * @note : 
 *    /     ,
 *      .
 * @note  : 
 *   ChartSymbol, ChartPeriod
 * @date : 2009.11.04
 * @see www.mql5.com/ru/docs/chart_operations/chartsetsymbolperiod
 */
bool  ChartSetSymbolPeriod(
   long             chart_id,     //  
   string           symbol,       //  
   ENUM_TIMEFRAMES  period        // 
   );
/**
 *   ChartSymbol
 *       .
 * @param chart_id=0
 *   [in]   . 0   .
 * @return 
 *      ,    .
 * @note  : 
 *   ChartSetSymbolPeriod
 * @date : 2009.11.04
 * @see www.mql5.com/ru/docs/chart_operations/chartsymbol
 */
string  ChartSymbol(
   long  chart_id = 0      //  
   );
/**
 *   ChartTimeOnDropped
 *     ,  ,
 *          .
 * @return 
 *     datetime.
 * @note  : 
 *   ChartXOnDropped, ChartYOnDropped
 * @date : 2009.11.04
 * @see www.mql5.com/ru/docs/chart_operations/charttimeondropped
 */
datetime  ChartTimeOnDropped();
/**
 *   ChartTimePriceToXY
 *        /     X  Y.
 * @param chart_id
 *   [in]   . 0   .
 * @param sub_window
 *   [in]    . 0    .
 * @param time
 *   [in]     ,    
 *        X.   
 *        /.
 * @param price
 *   [in]      ,    
 *        Y.   
 *        /.
 * @param x
 *   [out]  ,         X.
 * @param y
 *   [out]  ,         Y.
 * @return 
 *    true    ,  false.
 *       ,  
 *     GetLastError().
 * @note  : 
 *   ChartXYToTimePrice()
 * @date : 2012.06.07
 * @see www.mql5.com/ru/docs/chart_operations/charttimepricetoxy
 */
bool  ChartTimePriceToXY(
   long           chart_id,     //  
   int            sub_window,   //  
   datetime       time,         //   
   double         price,        //   
   int&           x,            //  X    
   int&           y             //  Y    
   );
/**
 *   ChartWindowFind
 *     ,    .  2  .
 *   ~ 1.        
 *    " "  (   
 *     )       
 *   . ~ 2.     
 *        ,
 *       .
 * @param chart_id
 *   [in]   . 0   .
 * @param indicator_shortname
 *   [in]    .
 * @return 
 *       .     .     -1.
 * @note : 
 *        ( )    ,
 *      -1.     
 *       ,    
 *      iCustom()  IndicatorCreate().
 *         
 *    ,        
 *      .   
 *      , 
 *      IndicatorSetString()   
 *    INDICATOR_SHORTNAME.  ,   
 *        ,  
 *        
 *      ChartIndicatorDelete()  
 *      .
 * @note  : 
 *   ObjectCreate(), ObjectFind()
 * @date : 2010.11.23
 * @see www.mql5.com/ru/docs/chart_operations/chartwindowfind
 */
int  ChartWindowFind(
   long     chart_id,                  //  
   string   indicator_shortname        //   ,  INDICATOR_SHORTNAME
   );
/**
 *   ChartWindowFind
 *     ,    .  2  .
 *   ~ 1.        
 *    " "  (   
 *     )       
 *   . ~ 2.     
 *        ,
 *       .
 * @param chart_id
 *   [in]   . 0   .
 * @param indicator_shortname
 *   [in]    .
 * @return 
 *       .     .     -1.
 * @note : 
 *        ( )    ,
 *      -1.     
 *       ,    
 *      iCustom()  IndicatorCreate().
 *         
 *    ,        
 *      .   
 *      , 
 *      IndicatorSetString()   
 *    INDICATOR_SHORTNAME.  ,   
 *        ,  
 *        
 *      ChartIndicatorDelete()  
 *      .
 * @note  : 
 *   ObjectCreate(), ObjectFind()
 * @date : 2010.11.23
 * @see www.mql5.com/ru/docs/chart_operations/chartwindowfind
 */
int  ChartWindowFind();
/**
 *   ChartWindowOnDropped
 *      ,        .
 *   0    .
 * @return 
 *     int.
 * @note  : 
 *   ChartPriceOnDropped, ChartTimeOnDropped, ChartXOnDropped, ChartYOnDropped
 * @date : 2009.11.04
 * @see www.mql5.com/ru/docs/chart_operations/chartwindowondropped
 */
int  ChartWindowOnDropped();
/**
 *   ChartXOnDropped
 *       X,  ,        .
 * @return 
 *     X.
 * @note : 
 *    X   .
 * @note  : 
 *   ChartWindowOnDropped, ChartPriceOnDropped, ChartTimeOnDropped
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/chart_operations/chartxondropped
 */
int  ChartXOnDropped();
/**
 *   ChartXYToTimePrice
 *      X  Y      .
 * @param chart_id
 *   [in]   . 0   .
 * @param x
 *   [in]   X.
 * @param y
 *   [in]   Y.
 * @param sub_window
 *   [out]  ,       . 0    .
 * @param time
 *   [out]     ,          X.
 *         
 *    /.
 * @param price
 *   [out]      ,          Y.
 *         
 *    /.
 * @return 
 *    true    ,  false.
 *       ,  
 *     GetLastError().
 * @note  : 
 *   ChartTimePriceToXY()
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/chart_operations/chartxytotimeprice
 */
bool  ChartXYToTimePrice(
   long           chart_id,     //  
   int            x,            //  X  
   int            y,            //  Y  
   int&           sub_window,   //  
   datetime&      time,         //   
   double&        price,        //   
   );
/**
 *   ChartYOnDropped
 *       Y,  ,        .
 * @return 
 *     Y.
 * @note : 
 *    Y   .
 * @note  : 
 *   ChartWindowOnDropped, ChartPriceOnDropped, ChartTimeOnDropped
 * @date : 2009.11.04
 * @see www.mql5.com/ru/docs/chart_operations/chartyondropped
 */
int  ChartYOnDropped();
/**
 *   Digits
 *        ,
 *        
 *    .
 * @return 
 *     _Digits,    
 *      ,
 *        
 *    .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/check/digits
 */
int  Digits();
/**
 *   GetLastError
 *       _LastError.
 * @return 
 *      ,     mql5-.
 * @note : 
 *        _LastError  .
 *      ,  
 *     ResetLastError()
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/check/getlasterror
 */
int  GetLastError();
/**
 *   IsStopped
 *       mql5-.
 * @return 
 *    true,     _StopFlag  ,
 *     0.     
 *    _StopFlag,     
 *    mql5-.       
 *      ,    
 *         3 .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/check/isstopped
 */
bool  IsStopped();
/**
 *   MQL5InfoInteger
 *        mql5-.
 * @param property_id
 *   [in]   .       ENUM_MQL5_INFO_INTEGER.
 * @return 
 *     int.
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/check/mql5infointeger
 */
int  MQL5InfoInteger(
   int  property_id      //  
   );
/**
 *   MQL5InfoString
 *        mql5-.
 * @param property_id
 *   [in]   .       ENUM_MQL5_INFO_STRING.
 * @return 
 *     string.
 * @date : 2010.02.23
 * @see www.mql5.com/ru/docs/check/mql5infostring
 */
string  MQL5InfoString(
   int  property_id      //  
   );
/**
 *   Period
 *       .
 * @return 
 *     _Period,       .
 *        
 *    ENUM_TIMEFRAMES.
 * @note  : 
 *   PeriodSeconds,  ,   , ,  
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/check/period
 */
ENUM_TIMEFRAMES  Period();
/**
 *   Point
 *          .
 * @return 
 *     _Point,          .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/check/point
 */
double  Point();
/**
 *   Symbol
 *       .
 * @return 
 *      _Symbol,       .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/check/symbol
 */
string  Symbol();
/**
 *   TerminalInfoInteger
 *        mql5-.
 * @param property_id
 *   [in]   .       ENUM_TERMINAL_INFO_INTEGER.
 * @return 
 *    ?? ????? int.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/check/terminalinfointeger
 */
int  TerminalInfoInteger(
   int  property_id      //  
   );
/**
 *   TerminalInfoString
 *         mql5-.
 *       string
 * @param property_id
 *   [in]   .       ENUM_TERMINAL_INFO_STRING.
 * @return <
 *     string.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/check/terminalinfostring
 */
string  TerminalInfoString(
   int  property_id      //  
   );
/**
 *   UninitializeReason
 *     .
 * @return 
 *      _UninitReason,
 *        OnDeinit().
 *      ,   .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/check/uninitializereason
 */
int  UninitializeReason();
/**
 *   Alert
 *     ,   .
 * @param argument
 *   [in]   ,  .
 *          
 *        "\n"  "\r\n".
 *        64.
 * @return 
 *     
 * @note : 
 *        Alert().
 *      .   double
 *     8    ,  
 *    float   5    .
 *          
 *       
 *     DoubleToString().   bool 
 *       "true"  "false".    
 *    YYYY.MM.DD HH:MI:SS.      
 *       TimeToString().  
 *    color      R,G,B,   
 *     ,      
 *    .
 * @date : 2010.06.16
 * @see www.mql5.com/ru/docs/common/alert
 */
void  Alert(
   argument,     //  
   ...           //  
   );
/**
 *   CheckPointer
 *        ??.
 * @param anyobject
 *   [in]   .
 * @return 
 *       ENUM_POINTER_TYPE.
 * @note : 
 *         
 *      . 
 *      
 *     CheckPointer   .
 *         : ~
 *     NULL; ~      
 *      delete.   
 *         .
 *   ,   , ,   
 *     .
 * @note  : 
 *    ,   ,    delete
 * @date : 2012.05.07
 * @see www.mql5.com/ru/docs/common/checkpointer
 */
ENUM_POINTER_TYPE  CheckPointer(
   object *anyobject      //  
   );
/**
 *   Comment
 *    ,  ,     .
 * @param ...
 *   [in]    ,  .
 *          
 *        "\n"  "\r\n".
 *        64.  
 *      (  
 *    )    2045  ( 
 *       ).
 * @return 
 *     
 * @note : 
 *        Comment().    .
 *     double     16    ,
 *           
 *          ,   
 *     .   float   5
 *      .   
 *            
 *       DoubleToString(). 
 *     bool     "true"  "false". 
 *       YYYY.MM.DD HH:MI:SS.   
 *        
 *     TimeToString().   color  
 *      R,G,B,     ,
 *         .
 * @note  : 
 *   ChartSetString, ChartGetString
 * @date : 2013.01.14
 * @see www.mql5.com/ru/docs/common/comment
 */
void  Comment(
   argument,     //  
   ...           //  
   );
/**
 *   DebugBreak
 *       .
 * @return 
 *     .
 * @note : 
 *     mql5-     ,
 *        .  
 *         /
 *      .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/common/debugbreak
 */
void  DebugBreak();
/**
 *   ExpertRemove
 *          .
 * @return 
 *     .
 * @note : 
 *           ExpertRemove(),
 *          
 *   . ..,     
 *      ,   OnDeinit()  
 *      .
 * @note  : 
 *    ,   
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/common/expertremove
 */
void  ExpertRemove();
/**
 *   GetPointer
 *     .
 * @param anyobject
 *   [in]    .
 * @return 
 *     .
 * @note : 
 *       .
 *         
 *     .  ,     
 *     new(),  ,  
 *     ,    .
 *        
 *     POINTER_AUTOMATIC,     
 *     delete().    
 *          
 *    POINTER_AUTOMATIC.     
 *         ,    
 *     GetPointer() .  
 *         . 
 *          .
 *         
 *       . 
 *      
 *     CheckPointer()CheckPointer()  
 *    .  ?.  ? 
 *   ? ????     : ~
 *     NULL; ~      
 *      delete.   
 *         .
 *   ,   , ,   
 *         .
 * @note  : 
 *    ,   ,    delete
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/common/getpointer
 */
void*  GetPointer(
   any_class anyobject      //   
   );
/**
 *   GetTickCount
 *    GetTickCount()   ,     .
 * @return 
 *     uint.
 * @note : 
 *        .
 *         ,
 *       49.7    
 *    .
 * @note  : 
 *     
 * @date : 2011.08.10
 * @see www.mql5.com/ru/docs/common/gettickcount
 */
uint  GetTickCount();
/**
 *   MessageBox
 *       ,    .
 *        , 
 *     ?   ,
 *   
 *     ??  ???????? 
 *      .
 * @param text
 *   [in]  ,    .
 * @param caption=NULL
 *   [in]         .
 *      ,     
 *     .
 * @param flags=0
 *   [in]   ,      .
 *          .
 * @return 
 *      ,   -      MessageBox().
 * @note : 
 *        ,
 *        ,   
 *      ?     ?
 *    ?      .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/common/messagebox
 */
int  MessageBox(
   string  text,             //  
   string  caption = NULL,     //  
   int     flags = 0           //     
   );
/**
 *   PeriodSeconds
 *       .
 * @param period=PERIOD_CURRENT
 *   [in]       ENUM_TIMEFRAMES.
 *      ,   
 *       ,   
 *    .
 * @return 
 *       .
 * @note  : 
 *   _Period,   ,   ,  
 * @date : 2009.11.13
 * @see www.mql5.com/ru/docs/common/periodseconds
 */
int  PeriodSeconds(
   ENUM_TIMEFRAMES  period = PERIOD_CURRENT      //  
   );
/**
 *   PlaySound
 *     .
 * @param filename
 *   [in]     .
 * @return 
 *   true     ,   false.
 * @note : 
 *         _\Sounds   .
 *         WAV.
 * @note  : 
 *   
 * @date : 2011.02.15
 * @see www.mql5.com/ru/docs/common/playsound
 */
bool  PlaySound(
   string  filename      //  
   );
/**
 *   Print
 *        .     .
 * @param ...
 *   [in]   ,  .      64.
 * @note : 
 *        Print().    . 
 *     double     16    ,
 *           
 *          ,   
 *     .   float   5
 *      .   
 *            
 *       PrintFormat().  
 *    bool     "true"  "false". 
 *       YYYY.MM.DD HH:MI:SS.   
 *        
 *     TimeToString().   color  
 *      R,G,B,     ,
 *         .
 * @note  : 
 *   DoubleToString, StringFormat
 * @date : 2012.04.11
 * @see www.mql5.com/ru/docs/common/print
 */
void  Print(
   argument,     //  
   ...           //  
   );
/**
 *   PrintFormat
 *            
 *       .<?  
 *     .<? .<.
 * @param format_string
 *   [in]        ,
 *        , 
 *     .
 * @param ...
 *   [in]     ,  .
 *         64,
 *     .
 * @return 
 *   .
 * @note : 
 *   ,         ,
 *     PrintFormat()    printf().
 * @note  : 
 *   StringFormat, DoubleToString, (double,float)
 * @date : 2013.01.22
 * @see www.mql5.com/ru/docs/common/printformat
 */
void  PrintFormat(
   string format_string,   //  
   ...                     //   
   );
/**
 *   ResetLastError
 *       _LastError  .
 * @return 
 *     .
 * @note : 
 *    ,   GetLastError()    _LastError.
 *      ResetLastError()
 *      ,
 *       .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/common/resetlasterror
 */
void  ResetLastError();
/**
 *   ResourceCreate
 *         .    :
 *  ~     
 *  ~      
 * @param resource_name
 *   [in]   . 
 * @param path
 *   [in]     ,    .
 *          "\" (
 *    "\\"),     
 *    __\MQL5\.  
 *      ,   
 *      EX5-,  
 *     .
 * @param data[][]
 *   [in]          .
 * @param img_width
 *   [in]        
 *        .  
 *       data_width.
 * @param img_height
 *   [in]     ?  ? ??
 *            . 
 * @param data_xoffset
 *   [in]          .
 * @param data_yoffset
 *   [in]          .
 * @param data_width
 *   [in]          
 *       .
 *    data_width=0,    img_width.
 *        
 *          data[].
 * @param color_format
 *   [in]       ENUM_COLOR_FORMAT.
 * @return 
 *   true    ,  false.  
 *      ,  
 *     GetLastError().  : ~ 4015
 *    ERR_RESOURCE_NAME_DUPLICATED (
 *         ), ~ 4016
 *    ERR_RESOURCE_NOT_FOUND (  ), ~ 4017
 *    ERR_RESOURCE_UNSUPPOTED_TYPE ( 
 *      ), ~ 4018
 *    ERR_RESOURCE_NAME_IS_TOO_LONG (  
 *    ).
 * @note : 
 *         
 *           , 
 *     ,     ,
 *      .  
 *           ,
 *         
 *    .      BMP  
 *     24  32 ,      
 *    WAV.      16 Mb.
 *    
 *   ENUM_COLOR_FORMAT
 *   
 *   
 *   COLOR_FORMAT_XRGB_NOALPHA
 *    - 
 *   COLOR_FORMAT_ARGB_RAW
 *        (    )  
 *   COLOR_FORMAT_ARGB_NORMALIZE
 *        
 * @note  : 
 *   , ObjectCreate(), ObjectSetString(), OBJPROP_BMPFILE
 * @date : 2012.05.30
 * @see www.mql5.com/ru/docs/common/resourcecreate
 */
bool  ResourceCreate(
   const string      resource_name,       //  
   const string      path                 //    
   );
/**
 *   ResourceCreate
 *         .    :
 *  ~     
 *  ~      
 * @param resource_name
 *   [in]   . 
 * @param path
 *   [in]     ,    .
 *          "\" (
 *    "\\"),     
 *    __\MQL5\.  
 *      ,   
 *      EX5-,  
 *     .
 * @param data[][]
 *   [in]          .
 * @param img_width
 *   [in]        
 *        .  
 *       data_width.
 * @param img_height
 *   [in]     ?  ? ??
 *            . 
 * @param data_xoffset
 *   [in]          .
 * @param data_yoffset
 *   [in]          .
 * @param data_width
 *   [in]          
 *       .
 *    data_width=0,    img_width.
 *        
 *          data[].
 * @param color_format
 *   [in]       ENUM_COLOR_FORMAT.
 * @return 
 *   true    ,  false.  
 *      ,  
 *     GetLastError().  : ~ 4015
 *    ERR_RESOURCE_NAME_DUPLICATED (
 *         ), ~ 4016
 *    ERR_RESOURCE_NOT_FOUND (  ), ~ 4017
 *    ERR_RESOURCE_UNSUPPOTED_TYPE ( 
 *      ), ~ 4018
 *    ERR_RESOURCE_NAME_IS_TOO_LONG (  
 *    ).
 * @note : 
 *         
 *           , 
 *     ,     ,
 *      .  
 *           ,
 *         
 *    .      BMP  
 *     24  32 ,      
 *    WAV.      16 Mb.
 *    
 *   ENUM_COLOR_FORMAT
 *   
 *   
 *   COLOR_FORMAT_XRGB_NOALPHA
 *    - 
 *   COLOR_FORMAT_ARGB_RAW
 *        (    )  
 *   COLOR_FORMAT_ARGB_NORMALIZE
 *        
 * @note  : 
 *   , ObjectCreate(), ObjectSetString(), OBJPROP_BMPFILE
 * @date : 2012.05.30
 * @see www.mql5.com/ru/docs/common/resourcecreate
 */
bool  ResourceCreate(
   const string      resource_name,       //  
   const color&      data[],              //     
   uint              img_width,           //   -
   uint              img_height,          //   -
   uint              data_xoffset,        //         
   uint              data_yoffset,        //         
   uint              data_width,          //       
   ENUM_COLOR_FORMAT color_format         //   
   );
/**
 *   ResourceSave
 *       .
 * @param resource_name
 *   [in]   ,    "::".
 * @param file_name
 *   [in]     MQL5\Files.
 * @return 
 *   true    ,  false.     ,
 *      GetLastError().
 * @note : 
 *          
 *          
 *     .
 * @note  : 
 *   , ObjectCreate(), PlaySound(), ObjectSetString(), OBJPROP_BMPFILE
 * @date : 2012.01.11
 * @see www.mql5.com/ru/docs/common/resourcesave
 */
bool  ResourceSave(
   const string  resource_name,      //  
   const string  file_name          //  
   );
/**
 *   SendFTP
 *      ,       "FTP".
 * @param filename
 *   [in]     .
 * @param ftp_path=NULL
 *   [in]    FTP.    ,   ,   .
 * @return 
 *       false.
 * @note : 
 *         _\MQL5\files
 *     .   ,   
 *       FTP /  .
 * @date : 2013.01.22
 * @see www.mql5.com/ru/docs/common/sendftp
 */
bool  SendFTP(
   string  filename,          //     ftp
   string  ftp_path = NULL      //     ftp-
   );
/**
 *   SendMail
 *       ,       "".
 * @param subject
 *   [in]   .
 * @param some_text
 *   [in]   .
 * @return 
 *   true        ,   false.
 * @note : 
 *        ,        .
 *       ,  
 *     GetLastError().
 * @date : 2010.06.28
 * @see www.mql5.com/ru/docs/common/sendmail
 */
bool  SendMail(
   string  subject,       // 
   string  some_text      //  
   );
/**
 *   SendNotification
 *       ,
 *    MetaQuotes ID      
 *    "".
 * @param text
 *   [in]      .       255 .
 * @return 
 *   true      ,   
 *      false.    
 *      GetLastError()   
 *     : ~ 4515  ERR_NOTIFICATION_SEND_FAILED,
 *   ~ 4516  ERR_NOTIFICATION_WRONG_PARAMETER, ~ 4517
 *    ERR_NOTIFICATION_WRONG_SETTINGS, ~ 4518
 *    ERR_NOTIFICATION_TOO_FREQUENT.
 * @note : 
 *     SendNotification()  
 *      :   2- 
 *        10   . 
 *        ,
 *         .
 * @date : 2012.05.21
 * @see www.mql5.com/ru/docs/common/sendnotification
 */
bool  SendNotification(
   string  text          //  
   );
/**
 *   SetUserError
 *      _LastError  ,
 *    ERR_USER_ERROR_FIRST + user_error
 * @param user_error
 *   [in]   ,  .
 * @return 
 *     . 
 * @note : 
 *    ,        SetUserError(user_error),
 *    GetLastError()  , 
 *    ERR_USER_ERROR_FIRST + user_error.
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/common/setusererror
 */
void  SetUserError(
   ushort user_error,   //  
   );
/**
 *   Sleep
 *         
 *      .
 * @param milliseconds
 *   [in]     .
 * @return 
 *     .
 * @note : 
 *    Sleep()     ,
 *         
 *       .   
 *          0.1
 *   .
 * @date : 2009.12.15
 * @see www.mql5.com/ru/docs/common/sleep
 */
void  Sleep(
   int  milliseconds      // 
   );
/**
 *   TerminalClose
 *        .
 * @param ret_code
 *   [in]   ,       .
 * @return 
 *    true   ,  false.
 * @note : 
 *    TerminalClose()      ,
 *         .  
 *    ,  TerminalClose(),   
 *         
 *    (,       
 *     ).      
 *      return.  ret_code  
 *          
 *           
 *    .
 * @note  : 
 *    ,  ,  
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/common/terminalclose
 */
bool  TerminalClose(
   int ret_code      //    
   );
/**
 *   TesterStatistics
 *       ,    
 * @param statistic_id
 *   [in]        ENUM_STATISTICS.
 * @return 
 *        .
 * @note : 
 *        OnTester()  OnDeinit()  .
 *       .
 * @date : 2011.04.18
 * @see www.mql5.com/ru/docs/common/testerstatistics
 */
double  TesterStatistics(
   ENUM_STATISTICS statistic_id      // 
   );
/**
 *   TesterWithdrawal
 *            .
 *         
 *    .
 * @param money
 *   [in]    ,      (  ).
 * @return 
 *    true   ,  false.
 * @date : 2010.04.27
 * @see www.mql5.com/ru/docs/common/testerwithdrawal
 */
bool  TesterWithdrawal(
   double money      //   
   );
/**
 *   ZeroMemory
 *     ,    .
 * @param variable
 *   [in] [out] ,   ,    (  ). 
 * @return 
 *     .
 * @note : 
 *       ,          NULL.
 *        ,   /,    ,   .
 *    ,     ,   ZeroMemory()   .
 *     ,    const,    .
 *         ZeroMemory()   .
 *    ZeroMemory()         .
 * @date : 2010.03.23
 * @see www.mql5.com/ru/docs/common/zeromemory
 */
void  ZeroMemory(
   void& variable      //  
   );
/**
 *   CharArrayToString
 *         uchar   .
 * @param array[]
 *   [in]    uchar.
 * @param start=0
 *   [in]  ,    .   0.
 * @param count=-1
 *   [in]      .
 *      .   -1,
 *        ,   
 *     0.
 * @param codepage=CP_ACP
 *   [in]    .     
 *     .
 * @return 
 *   .
 * @note  : 
 *     
 * @date : 2010.09.17
 * @see www.mql5.com/ru/docs/convert/chararraytostring
 */
string  CharArrayToString(
   uchar   array[],            // 
   int     start = 0,             //    
   int     count = -1,             //  
   uint    codepage = CP_ACP      //  
   );
/**
 *   CharToString
 *        .
 * @param char_code
 *   [in]    ANSI.
 * @return 
 *   ,   ANSI.
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/convert/chartostring
 */
string  CharToString(
   uchar  char_code      //   
   );
/**
 *   ColorToARGB
 *     color   uint   ARGB- .
 *   ARGB      
 *    ,    
 *      ??? 
 *    CCanvas.
 * @param clr
 *   [in]       color.
 * @param alpha
 *   [in]   -,      ARGB.
 *      0 (  
 *         )
 *    255 (      
 *     ).  
 *        
 *     (1-alpha/255)*100%,     
 *    -,    .
 * @return 
 *       ARGB,      uint
 *       Alfa, Red, Green, Blue
 *   (-, , , ).
 * @note : 
 *            
 *       RGB,    
 *       (Red),  (Green)  
 *    (Blue)  .  
 *      ,   
 *        0  255 ( 0x00  0XFF
 *     ).     
 *       ,   ?  ,
 *          0  255
 *   ( 0x00  0XFF   ).   
 *         ,   
 *    ).         ,
 *         ,   ? ,
 *       ? ?  0xFFFFFF,   
 *         
 *    0xFF.      
 *     ,  ,   
 *     ,     
 *       .   
 *      - (Alpha),
 *         
 *    RGB.   ARGB   . 
 *      ARGB     
 *    ,      
 *         Alpha, Red, Green  Blue.
 *   , ARGB-   80FFFF00     
 *       50.2 %.     0x80,
 *     50.2%   -, 
 *      50.2%    0xFF;     FF
 *         ;
 *     FF       
 *     ;    00  
 *         (   ).
 *            .
 *    -    , 
 *         6   RRGGBB,  
 *        -     
 *          uint.
 *       16-    
 *        '0x'  '#', , 80FFFF00,
 *     0x80FFFF00,  #80FFFF00.
 * @note  : 
 *   , ResourceCreate(), TextOut(),  color,  char, short, int  long
 * @date : 2013.01.25
 * @see www.mql5.com/ru/docs/convert/colortoargb
 */
uint  ColorToARGB(
   color  clr,          //     color
   uchar  alpha = 255     // -,   
   );
/**
 *   ColorToString
 *         "R,G,B".
 * @param color_value
 *   [in]       color.
 * @param color_name
 *   [in]      ,
 *    ,      
 *      .
 * @return 
 *        "R,G,B",
 *    R, G  B     
 *         0  255.
 *      color_name=true,
 *          
 *    .
 * @date : 2010.02.08
 * @see www.mql5.com/ru/docs/convert/colortostring
 */
string  ColorToString(
   color  color_value,     //  
   bool   color_name       //     
   );
/**
 *   DoubleToString
 *        .
 * @param value
 *   [in]     .
 * @param digits
 *   [in]   .   digits 
 *      0  16,    
 *         
 *     .   digits    
 *   -1  -16,      
 *          
 *      .     
 *         8 
 *      .
 * @return 
 *   ,        .
 * @note  : 
 *   NormalizeDouble, StringToDouble
 * @date : 2012.04.18
 * @see www.mql5.com/ru/docs/convert/doubletostring
 */
string  DoubleToString(
   double  value,      // 
   int     digits = 8    // -   
   );
/**
 *   EnumToString
 *          .
 * @param value
 *   [in]     .
 * @return 
 *   ,    .
 *       ,  
 *     GetLastError().
 * @note : 
 *        _LastError
 *     : ~ ERR_INTERNAL_ERROR   
 *     ~ ERR_NOT_ENOUGH_MEMORY
 *       
 *     ~ ERR_INVALID_PARAMETER    
 *      
 * @note  : 
 *   , Input 
 * @date : 2010.12.16
 * @see www.mql5.com/ru/docs/convert/enumtostring
 */
string  EnumToString(
   any_enum  value     //     
   );
/**
 *   IntegerToString
 *              .
 * @param number
 *   [in]    .
 * @param str_len=0
 *   [in]   .       ,
 *      .    
 *     ,     
 *     -.
 * @param fill_symbol=' '
 *   [in]  -.    .
 * @return 
 *   .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/convert/integertostring
 */
string  IntegerToString(
   long    number,              // 
   int     str_len = 0,           //    
   ushort  fill_symbol = ' '      // 
   );
/**
 *   NormalizeDouble
 *          .
 * @param value
 *   [in]    .
 * @param digits
 *   [in]   ,      (0-8).
 * @return 
 *     double   .
 * @note : 
 *     StopLoss, TakeProfit,
 *         , 
 *       ,   
 *      Digits().    ,
 *         
 *     Print()      
 *     ,   . 
 * @note  : 
 *   DoubleToString, (double,float), , 
 * @date : 2012.02.15
 * @see www.mql5.com/ru/docs/convert/normalizedouble
 */
double  NormalizeDouble(
   double  value,      // ???????? 
   int     digits      // -   
   );
/**
 *   ShortArrayToString
 *        .
 * @param array[]
 *   [in]    ushort (  wchar_t).
 * @param start=0
 *   [in]  ,    .   0.
 * @param count=-1
 *   [in]      .
 *      .   -1,
 *        ,   
 *     0.
 * @return 
 *   .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/convert/shortarraytostring
 */
string  ShortArrayToString(
   ushort  array[],      // 
   int     start = 0,      //    
   int     count = -1      //  
   );
/**
 *   ShortToString
 *      (unicode)       .
 * @param symbol_code
 *   [in]   .       ,
 *    ,     
 *     ,  
 *     Unicode.
 * @return 
 *   .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/convert/shorttostring
 */
string  ShortToString(
   ushort  symbol_code      // 
   );
/**
 *   StringFormat
 *        .
 * @param format
 *   [in]  ,   . 
 *      ,     PrintFormat
 * @param ...
 *   [in]  ,  .
 * @return 
 *   .
 * @note  : 
 *   PrintFormat, DoubleToString,ColorToString, TimeToString
 * @date : 2010.05.13
 * @see www.mql5.com/ru/docs/convert/stringformat
 */
string  StringFormat(
   string  format,     //    
   ...     ...         // 
   );
/**
 *   StringToCharArray
 *       unicode  ansi 
 *        uchar.  
 *      .
 * @param text_string
 *   [in]    .
 * @param array[]
 *   [out]    uchar.
 * @param start=0
 *   [in]  ,    .   0.
 * @param count=-1
 *   [in]      .
 *      .   -1,
 *        ,   
 *     0.  0   
 *    -,     
 *           
 *   .       ,
 *        .
 * @param codepage=CP_ACP
 *   [in]    .
 *        
 *     ?  
 *     ??  ? 
 *   ? ????.
 * @return 
 *     .
 * @note  : 
 *     
 * @date : 2010.09.17
 * @see www.mql5.com/ru/docs/convert/stringtochararray
 */
int  StringToCharArray(
   string  text_string,         // -
   uchar&  array[],             // 
   int     start = 0,             //    
   int     count = -1,             //  
   uint    codepage = CP_ACP      //  
   );
/**
 *   StringToColor
 *      "R,G,B"  ,   ,    color.
 * @param color_string
 *   [in]      "R,G,B"       Web-.
 * @return 
 *    .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/convert/stringtocolor
 */
color  StringToColor(
   string  color_string      //   
   );
/**
 *   StringToDouble
 *    ,    ,    double.
 * @param value
 *   [in]  ,    .
 * @return 
 *     double.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/convert/stringtodouble
 */
double  StringToDouble(
   string  value      // 
   );
/**
 *   StringToInteger
 *    ,    ,    int ().
 * @param value
 *   [in]  ,  .
 * @return 
 *     long.
 * @date : 2010.12.20
 * @see www.mql5.com/ru/docs/convert/stringtointeger
 */
long  StringToInteger(
   string  value      // 
   );
/**
 *   StringToShortArray
 *          
 *    ushort.   
 *    .
 * @param text_string
 *   [in]    .
 * @param array[]
 *   [out]    ushort (  wchar_t).
 * @param start=0
 *   [in]  ,    .   0.
 * @param count=-1
 *   [in]     
 *    .   . 
 *     -1,      ,
 *       0.  0  
 *      -,   
 *         
 *       .   
 *       ,   
 *      .
 * @return 
 *     .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/convert/stringtoshortarray
 */
int  StringToShortArray(
   string  text_string,     // -
   ushort& array[],         // 
   int     start = 0,         //    
   int     count = -1         //  
   );
/**
 *   StringToTime
 *    ,   /    "yyyy.mm.dd [hh:mi]",    datetime.
 * @param value
 *   [in]     " yyyy.mm.dd hh:mi ".
 * @return 
 *     datetime,   ,   01.01.1970.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/convert/stringtotime
 */
datetime  StringToTime(
   string  value      // -
   );
/**
 *   TimeToString
 *    ,    ,   01.01.1970,    "yyyy.mm.dd hh:mi".
 * @param value
 *   [in]      00:00 1  1970.
 * @param mode=TIME_DATE|TIME_MINUTES
 *   [in]     .   
 *      : ~ TIME_DATE  
 *      " yyyy.mm.dd " , ~ TIME_MINUTES  
 *      " hh:mm " , ~ TIME_SECONDS  
 *      " hh:mm:ss ".
 * @return 
 *   .
 * @date : 2013.01.29
 * @see www.mql5.com/ru/docs/convert/timetostring
 */
string  TimeToString(
   datetime  value,                           // 
   int       mode = TIME_DATE | TIME_MINUTES      //  
   );
/**
 *   IndicatorSetDouble
 *       .
 *        double.  2
 *    .     
 *   .       
 *    .
 * @param prop_id
 *   [in]    .      
 *    ENUM_CUSTOMIND_PROPERTY_DOUBLE.
 * @param prop_modifier
 *   [in]    .     .
 *       0,     
 *         ( 1 ,
 *       ).
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @note : 
 *     ()
 *      #property   1
 *   (),         0
 *   ().      
 *        ,
 *    . ,   
 *          
 *     : ~ property indicator_level1  50 -
 *    1    , ~
 *   IndicatorSetDouble(INDICATOR_LEVELVALUE, 0, 50) -
 *    0    .
 * @note  : 
 *      ,      ,  
 * @date : 2013.04.16
 * @see www.mql5.com/ru/docs/customind/indicatorsetdouble
 */
bool  IndicatorSetDouble(
   int     prop_id,           // 
   double  prop_value         //  
   );
/**
 *   IndicatorSetDouble
 *       .
 *        double.  2
 *    .     
 *   .       
 *    .
 * @param prop_id
 *   [in]    .      
 *    ENUM_CUSTOMIND_PROPERTY_DOUBLE.
 * @param prop_modifier
 *   [in]    .     .
 *       0,     
 *         ( 1 ,
 *       ).
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @note : 
 *     ()
 *      #property   1
 *   (),         0
 *   ().      
 *        ,
 *    . ,   
 *          
 *     : ~ property indicator_level1  50 -
 *    1    , ~
 *   IndicatorSetDouble(INDICATOR_LEVELVALUE, 0, 50) -
 *    0    .
 * @note  : 
 *      ,      ,  
 * @date : 2013.04.16
 * @see www.mql5.com/ru/docs/customind/indicatorsetdouble
 */
bool  IndicatorSetDouble(
   int     prop_id,           // 
   int     prop_modifier,     // 
   double  prop_value         //  
   );
/**
 *   IndicatorSetInteger
 *       .
 *        int  color.
 *    2  .   
 *     .     
 *      .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_CUSTOMIND_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .     .
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/customind/indicatorsetinteger
 */
bool  IndicatorSetInteger(
   int  prop_id,           // 
   int  prop_value         //  
   );
/**
 *   IndicatorSetInteger
 *       .
 *        int  color.
 *    2  .   
 *     .     
 *      .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_CUSTOMIND_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .     .
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/customind/indicatorsetinteger
 */
bool  IndicatorSetInteger(
   int  prop_id,           // 
   int  prop_modifier,     // 
   int  prop_value         //  
   );
/**
 *   IndicatorSetString
 *       .
 *        string.  2
 *    .     
 *   .       
 *    .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_CUSTOMIND_PROPERTY_STRING.
 * @param prop_modifier
 *   [in]    .     .
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/customind/indicatorsetstring
 */
bool  IndicatorSetString(
   int     prop_id,           // 
   string  prop_value         //  
   );
/**
 *   IndicatorSetString
 *       .
 *        string.  2
 *    .     
 *   .       
 *    .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_CUSTOMIND_PROPERTY_STRING.
 * @param prop_modifier
 *   [in]    .     .
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/customind/indicatorsetstring
 */
bool  IndicatorSetString(
   int     prop_id,           // 
   int     prop_modifier,     // 
   string  prop_value         //  
   );
/**
 *   PlotIndexGetInteger
 *         .
 *       int, color, bool  char.
 *    2  .   
 *      .     
 *      .
 * @param plot_index
 *   [in]    
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_PLOT_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .      .
 * @note : 
 *        
 *     .    
 *      PlotIndexSetInteger  
 *          .
 * @date : 2011.03.18
 * @see www.mql5.com/ru/docs/customind/plotindexgetinteger
 */
int  PlotIndexGetInteger(
   int  plot_index,        //   
   int  prop_id,           <s //  
   );
/**
 *   PlotIndexGetInteger
 *         .
 *       int, color, bool  char.
 *    2  .   
 *      .     
 *      .
 * @param plot_index
 *   [in]    
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_PLOT_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .      .
 * @note : 
 *        
 *     .    
 *      PlotIndexSetInteger  
 *          .
 * @date : 2011.03.18
 * @see www.mql5.com/ru/docs/customind/plotindexgetinteger
 */
int  PlotIndexGetInteger(
   int  plot_index,        //   
   int  prop_id,           //  
   int  prop_modifier      //  
   );
/**
 *   PlotIndexSetDouble
 *         .
 *        double.
 * @param plot_index
 *   [in]    
 * @param prop_id
 *   [in]    . 
 *         
 *    ENUM_PLOT_PROPERTY_DOUBLE.
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/customind/plotindexsetdouble
 */
bool  PlotIndexSetDouble(
   int     plot_index,     //   
   int     prop_id,        //  
   double  prop_value      //  
   );
/**
 *   PlotIndexSetInteger
 *         .
 *        int, char, bool 
 *    color.  2  .   
 *     .     
 *      .
 * @param plot_index
 *   [in]    
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_PLOT_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .      .
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/customind/plotindexsetinteger
 */
bool  PlotIndexSetInteger(
   int  plot_index,       &n //   
   int  prop_id,           //  
   int  prop_value         //  
   );
/**
 *   PlotIndexSetInteger
 *         .
 *        int, char, bool 
 *    color.  2  .   
 *     .     
 *      .
 * @param plot_index
 *   [in]    
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_PLOT_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .      .
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/customind/plotindexsetinteger
 */
bool  PlotIndexSetInteger(
   int  plot_index,        //   
   int  prop_id,           //  
   int  prop_modifier,     //  
   int  prop_value         //  
   );
/**
 *   PlotIndexSetString
 *         .
 *        string.
 * @param plot_index
 *   [in]    
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_PLOT_PROPERTY_STRING.
 * @param prop_value
 *   [in]   .
 * @return 
 *        true,    false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/customind/plotindexsetstring
 */
bool  PlotIndexSetString(
   int     plot_index,     //   
   int     prop_id,        //  
   string  prop_vallue      //  
   );
/**
 *   SetIndexBuffer
 *            double.
 * @param index
 *   [in]    .    0.
 *       , 
 *    #propertyindicator_buffers.
 * @param buffer[] 
 *   [in]  ,     .
 * @param data_type
 *   [in]   ,    .
 *     INDICATOR_DATA ( 
 *    ).    
 *    INDICATOR_COLOR_INDEX,     
 *         
 *    .    64   
 *    #propertyindicator_colorN. 
 *    INDICATOR_CALCULATIONS ,   
 *        
 *        .
 * @return 
 *        true,    false.
 *   ??????
 *       buffer[]
 *         ,   
 *        
 *       .   
 *         ,
 *      ArraySetAsSeries()
 *       SetIndexBuffer().
 *       ,    
 *      ,   
 *       SetIndexBuffer().
 *          
 *       .
 * @note  : 
 *   ,     
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/customind/setindexbuffer
 */
bool  SetIndexBuffer(
   int                    index,         //  
   double                 buffer[],      // 
   ENUM_INDEXBUFFER_TYPE  data_type      //   
   );

/**
 *   StructToTime
 *         MqlDateTime
 *      datetime    .
 * @param dt_struct
 *   [in]     MqlDateTime.
 * @return 
 *     datetime,     01.01.1970.
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/dateandtime/structtotime
 */
datetime  StructToTime(
   MqlDateTime&  dt_struct      //    
   );
/**
 *   TimeCurrent
 *       ,
 *          
 *     " " .   OnTick() 
 *         .
 *      (,    OnInit(),
 *   OnDeinit(), OnTimer()   )    
 *        ,   
 *    " ",   ,  
 *      .  
 *            
 *       .  2 
 *    .
 * @param dt_struct
 *   [out]     MqlDateTime.
 * @return 
 *     datetime
 * @note : 
 *            MqlDateTime,
 *       .
 *          
 *      GetTickCount(),  
 *      .
 * @date : 2011.08.10
 * @see www.mql5.com/ru/docs/dateandtime/timecurrent
 */
datetime  TimeCurrent();
/**
 *   TimeCurrent
 *       ,
 *          
 *     " " .   OnTick() 
 *         .
 *      (,    OnInit(),
 *   OnDeinit(), OnTimer()   )    
 *        ,   
 *    " ",   ,  
 *      .  
 *            
 *       .  2 
 *    .
 * @param dt_struct
 *   [out]     MqlDateTime.
 * @return 
 *     datetime
 * @note : 
 *            MqlDateTime,
 *       .
 *          
 *      GetTickCount(),  
 *      .
 * @date : 2011.08.10
 * @see www.mql5.com/ru/docs/dateandtime/timecurrent
 */
datetime  TimeCurrent(
   MqlDateTime&  dt_struct      //   
   );
/**
 *   TimeDaylightSavings
 *         ,
 *         . 
 *        .
 * @return 
 *         () ,   0.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/dateandtime/timedaylightsavings
 */
int  TimeDaylightSavings();
/**
 *   TimeGMT
 *     GMT,     
 *          
 *    ,     .
 *    2  .    
 *      MqlDateTime
 * @param dt_struct
 *   [out]     MqlDateTime.
 * @return 
 *     datetime
 * @note : 
 *            MqlDateTime,
 *       .
 *          
 *      GetTickCount(),  
 *      .
 * @date : 2011.08.10
 * @see www.mql5.com/ru/docs/dateandtime/timegmt
 */
datetime  TimeGMT();
/**
 *   TimeGMT
 *     GMT,     
 *          
 *    ,     .
 *    2  .    
 *      MqlDateTime
 * @param dt_struct
 *   [out]     MqlDateTime.
 * @return 
 *     datetime
 * @note : 
 *            MqlDateTime,
 *       .
 *          
 *      GetTickCount(),  
 *      .
 * @date : 2011.08.10
 * @see www.mql5.com/ru/docs/dateandtime/timegmt
 */
datetime  TimeGMT(
   MqlDateTime&  dt_struct      //   
   );
/**
 *   TimeGMTOffset
 *        GMT
 *           
 *        .    
 *      .
 * @return 
 *     int,    
 *       GMT  .
 * @date : 2009.12.25
 * @see www.mql5.com/ru/docs/dateandtime/timegmtoffset
 */
int  TimeGMTOffset();
/**
 *   TimeLocal
 *      ,
 *       .  2 
 *    .        MqlDateTime
 * @param dt_struct
 *   [out]     MqlDateTime.
 * @return 
 *     datetime
 * @note : 
 *            MqlDateTime,
 *       .
 *          
 *      GetTickCount(),  
 *      .
 * @date : 2011.08.10
 * @see www.mql5.com/ru/docs/dateandtime/timelocal
 */
datetime  TimeLocal();
/**
 *   TimeLocal
 *      ,
 *       .  2 
 *    .        MqlDateTime
 * @param dt_struct
 *   [out]     MqlDateTime.
 * @return 
 *     datetime
 * @note : 
 *            MqlDateTime,
 *       .
 *          
 *      GetTickCount(),  
 *      .
 * @date : 2011.08.10
 * @see www.mql5.com/ru/docs/dateandtime/timelocal
 */
datetime  TimeLocal(
   MqlDateTime&  dt_struct      //   
   );
/**
 *   TimeToStruct
 *        datetime
 *   (   01.01.1970)    
 *    MqlDateTime.
 * @param dt
 *   [in]     .
 * @param dt_struct
 *   [out]     MqlDateTime.
 * @return 
 *     .
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/dateandtime/timetostruct
 */
void  TimeToStruct(
   datetime      dt,            //   
   MqlDateTime&  dt_struct      //    
   );
/**
 *   TimeTradeServer
 *        .
 *       TimeCurrent(),   
 *           
 *       .  2 
 *    .       
 *    MqlDateTime
 * @param dt_struct
 *   [out]     MqlDateTime.
 * @return 
 *     datetime
 * @note : 
 *            MqlDateTime,
 *       .
 *          
 *      GetTickCount(),  
 *      .
 * @date : 2011.08.10
 * @see www.mql5.com/ru/docs/dateandtime/timetradeserver
 */
datetime  TimeTradeServer();
/**
 *   TimeTradeServer
 *        .
 *       TimeCurrent(),   
 *           
 *       .  2 
 *    .       
 *    MqlDateTime
 * @param dt_struct
 *   [out]     MqlDateTime.
 * @return 
 *     datetime
 * @note : 
 *            MqlDateTime,
 *       .
 *          
 *      GetTickCount(),  
 *      .
 * @date : 2011.08.10
 * @see www.mql5.com/ru/docs/dateandtime/timetradeserver
 */
datetime  TimeTradeServer(
   MqlDateTime&  dt__struct      //   
   );

/**
 *   EventChartCustom
 *        .
 * @param chart_id
 *   [in]   . 0   .
 * @param custom_event_id
 *   [in]    .
 *        
 *    CHARTEVENT_CUSTOM     .
 * @param lparam
 *   [in]     long,   OnChartEvent.
 * @param dparam
 *   [in]     double,   OnChartEvent.
 * @param sparam
 *   [in]     string,   OnChartEvent.
 *       ,  63 ,  
 *    .
 * @return 
 *    true      
 *         .   
 *     false,      GetLastError().
 * @note : 
 *     ,    ,
 *       
 *     OnChartEvent(int event_id, long& lparam, double&
 *   dparam, string& sparam).     
 *      OnChartEvent()  
 *    ,      
 *   .      ,
 *      .
 * @note  : 
 *     ,  ?  ? 
 * @date : 2013.04.03
 * @see www.mql5.com/ru/docs/eventfunctions/eventchartcustom
 */
bool  EventChartCustom(
   long    chart_id,            //  - 
   ushort  custom_event_id,     //  
   long    lparam,              //   long
   double  dparam,              //   double
   string  sparam               //  ?? ???? 
   );
/**
 *   EventKillTimer
 *     ,    
 *          .
 * @return 
 *     .
 * @note : 
 *          OnDeinit()   ,
 *      OnInit()  
 *     EventSetTimer().   
 *      ,    
 *       EventSetTimer().  
 *          ,  
 *       .   
 *    mql5-   ,
 *      ,     
 *    Even5-   ,
 *      ,      Even? 
 *    ,      Even 
 *    Even EvenEventKillTimer().
 * @date : 2010.02.15
 * @see www.mql5.com/ru/docs/eventfunctions/eventkilltimer
 */
void  EventKillTimer();
/**
 *   EventSetMillisecondTimer
 *     ,     
 *       
 *        .
 * @param milliseconds
 *   [in]   ,      .
 * @return 
 *        true,  - false.
 *        
 *     GetLastError().
 * @note : 
 *        , 
 *       ,   
 *       ,     .
 *           1
 *   ,   EventSetTimer().   
 *        1000 .
 *         
 *      ,   
 *        .
 *           
 *       1   10-16 ,
 *        ...
 * @date : 2013.04.11
 * @see www.mql5.com/ru/docs/eventfunctions/eventsetmillisecondtimer
 */
bool  EventSetMillisecondTimer(
   int  milliseconds      //  
   );
/**
 *   EventSetTimer
 *     ,
 *         
 *         
 *    .
 * @param seconds
 *   [in]   ,      .
 * @return 
 *        true,  false.        GetLastError().
 * @note : 
 *   ,       OnInit()
 *      .  ,  
 *    ,   ,  
 *        OnTimer().  
 *          ,  
 *       .   
 *    mql5-   ,
 *      ,     
 *    EventKillTimer().    
 *         . 
 *    mql5-      
 *     ,    
 *     .   
 *       Timer    
 *      ,    Timer  
 *    mql5-  .
 * @date : 2012.05.31
 * @see www.mql5.com/ru/docs/eventfunctions/eventsettimer
 */
bool  EventSetTimer(
   int  seconds      //  
   );
/**
 *   FileClose
 *    ,    FileOpen().
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *     .
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/fileclose
 */
void  FileClose(
   int  file_handle      // handle 
   );
/**
 *   FileCopy
 *             .
 * @param src_file_name
 *   [in]     .
 * @param common_flag
 *   [in]  ,   .
 *    common_flag=FILE_COMMON,      
 *      .    
 *        (, common_flag=0).
 * @param dst_file_name
 *   [in]    .
 * @param mode_flags
 *   [in]   .     2 :
 *   FILE_REWRITE / FILE_COMMON -   
 *   .           
 *    FILE_REWRITE,     ,
 *      false.
 * @return 
 *        false.
 * @note : 
 *        MQL5     .
 *   ,      
 *     MQL5,      
 *    "".    ,  
 *          
 *    FILE_REWRITE    mode_flags.
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filecopy
 */
bool  FileCopy(
   const string  src_file_name,     //   
   int           common_flag,       //  
   const string  dst_file_name,     //   
   int           mode_flags         //   /  
   );
/**
 *   FileDelete
 *          .
 * @param file_name
 *   [in]   .
 * @param common_flag=0
 *   [in]  ,   .
 *    common_flag=FILE_COMMON,      
 *      .    
 *       .
 * @return 
 *        false.
 * @note : 
 *        MQL5   
 *    . ,    
 *       MQL5,   
 *       "".   
 *         (MQL5\files 
 *    MQL5\tester\files   ).   
 *    common_flag=FILE_COMMON,    
 *         .
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filedelete
 */
bool  FileDelete(
   const string  file_name,     //   
   int           common_flag = 0  //   
   );
/**
 *   FileFindClose
 *     .
 * @param search_handle
 *   [in]   ,   FileFindFirst().
 * @return 
 *     .
 * @note : 
 *     ,    .
 * @note  : 
 *   FileFindFirst, FileFindNext
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filefindclose
 */
void  FileFindClose(
   long  search_handle      // handle 
   );
/**
 *   FileFindFirst
 *        
 *        
 *    .
 * @param file_filter
 *   [in]   .      
 *   (   )
 *     \Files,   
 *      .
 * @param returned_filename
 *   [out]   ,     
 *        .
 * @param common_flag
 *   [in]  ,   .
 *    common_flag=FILE_COMMON,      
 *      .    
 *       .
 * @return 
 *      ,   
 *         
 *    FileFindNext(),  INVALID_HANDLE  ,  
 *       ,  
 *   (     ).  
 *         
 *     FileFindClose().
 * @note : 
 *        MQL5  
 *     . ,    
 *       MQL5,   
 *       "".
 * @note  : 
 *   FileFindNext, FileFindClose
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filefindfirst
 */
long  FileFindFirst(
   const string   file_filter,          //  -  
   string&        returned_filename,    //     
   int            common_flag = 0         //   
   );
/**
 *   FileFindNext
 *    ,   FileFindFirst().
 * @param search_handle
 *   [in]   ,   FileFindFirst().
 * @param returned_filename
 *   [out]      .
 * @return 
 *       true,  false.
 * @note  : 
 *   FileFindFirst, FileFindClose
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filefindnext
 */
bool  FileFindNext(
   long      search_handle,         // handle 
   string&   returned_filename      //     
   );
/**
 *   FileFlush
 *       ,     -.
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *     .
 * @note : 
 *         
 *           .
 *           , 
 *      FileFlush().   
 *    ,   ,     ,
 *      ?
 *     FileFlush().    ,
 *     ,     ,
 *      ??   ,
 *      ?  
 *    ??  ??????    
 *    FileClose().    , 
 *        
 *    .    ,   
 *          .
 *    FileFlush()   
 *           .
 * @note  : 
 *   FileClose
 * @date : 2013.03.27
 * @see www.mql5.com/ru/docs/files/fileflush
 */
void  FileFlush(
   int  file_handle      // handle 
   );
/**
 *   FileGetInteger
 *      .  2 
 *    . ~ 1.     . ~ 2.
 *       .
 *
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param file_name
 *   [in]   .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_FILE_PROPERTY_INTEGER.
 *       ,   
 *       : FILE_EXISTS,
 *   FILE_CREATE_DATE, FILE_MODIFY_DATE, FILE_ACCESS_DATE
 *    FILE_SIZE.
 * @param common_folder=false
 *   [in]     .    false,
 *       ,  
 *     ,      
 *         ,
 *           
 *           ?
 *     ?    (FILE_COMMON).
 * @return 
 *    .      -1,
 *        
 *     GetLastError().   
 *         ,    
 *       5018 (ERR_MQL_FILE_IS_DIRECTORY),
 *        .
 * @note : 
 *       .        .
 * @note  : 
 *    ,  
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filegetinteger
 */
long  FileGetInteger(
   int                         file_handle,   //  
   ENUM_FILE_PROPERTY_INTEGER  property_id    //  
   );
/**
 *   FileGetInteger
 *      .  2 
 *    . ~ 1.     . ~ 2.
 *       .
 *
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param file_name
 *   [in]   .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_FILE_PROPERTY_INTEGER.
 *       ,   
 *       : FILE_EXISTS,
 *   FILE_CREATE_DATE, FILE_MODIFY_DATE, FILE_ACCESS_DATE
 *    FILE_SIZE.
 * @param common_folder=false
 *   [in]     .    false,
 *       ,  
 *     ,      
 *         ,
 *           
 *           ?
 *     ?    (FILE_COMMON).
 * @return 
 *    .      -1,
 *        
 *     GetLastError().   
 *         ,    
 *       5018 (ERR_MQL_FILE_IS_DIRECTORY),
 *        .
 * @note : 
 *       .        .
 * @note  : 
 *    ,  
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filegetinteger
 */
long  FileGetInteger(
   const string                file_name,            //  
   ENUM_FILE_PROPERTY_INTEGER  property_id,          //  
   bool                        common_folder = false   //      (false)
   );                                                //       (true)
/**
 *   FileIsEnding
 *        .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *     true  ,    
 *         .
 * @note : 
 *      ,    
 *      .    ,    true,    false.
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/fileisending
 */
bool  FileIsEnding(
   int  file_handle      // handle 
   );
/**
 *   FileIsExist
 *     .
 * @param file_name
 *   [in]    .
 * @param common_flag=0
 *   [in]  ,   .
 *    common_flag=FILE_COMMON,      
 *      .    
 *       .
 * @return 
 *    true,    .
 * @note : 
 *       .
 *       FileIsExist()  false, 
 *     _LastError    5018 -
 *   "  ,  " (  
 *     FileFindFirst).   
 *      MQL5     . 
 *   ,      
 *     MQL5,      
 *    "".  common_flag=FILE_COMMON,
 *            
 *    ,      
 *      (MQL5\Files  MQL5\Tester\Files  
 *    ).
 * @note  : 
 *   FileFindFirst
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/fileisexist
 */
bool  FileIsExist(
   const string  file_name,       //  
   int           common_flag = 0    //  
   );
/**
 *   FileIsLineEnding
 *           .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *    true  ,     txt
 *    csv-    ( CR-LF).
 * @note  : 
 *   FileWriteString
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/fileislineending
 */
bool  FileIsLineEnding(
   int  file_handle      // handle 
   );
/**
 *   FileMove
 *            .
 * @param src_file_name
 *   [in]       /.
 * @param common_flag
 *   [in]  ,   .
 *    common_flag=FILE_COMMON,      
 *      .    
 *        (common_flag=0).
 * @param dst_file_name
 *   [in]    .
 * @param mode_flags
 *   [in]   .    
 *   2 : FILE_REWRITE / FILE_COMMON -  
 *    .         
 *      FILE_REWRITE,     ,
 *      false.
 * @return 
 *        false.
 * @note : 
 *        MQL5 
 *      . ,  
 *         MQL5,
 *         "".
 *      ,   
 *         
 *    FILE_REWRITE    mode_flags.
 * @note  : 
 *   FileIsExist
 * @date : 2013.03.29
 * @see www.mql5.com/ru/docs/files/filemove
 */
bool  FileMove(
   const string  src_file_name,    //     
   int           common_flag,      //  
   const string  dst_file_name,    //   
   int           mode_flags        //   /  
   );
/**
 *   FileOpen
 *           .
 * @param file_name
 *   [in]    ,   .     ,
 *           ,
 *           
 *        ?      .
 * @param open_flags
 *   [in]  ,     .
 * @param delimiter='\t'
 *   [in]  ,      txt  csv-.
 *     csv-   ,   
 *      .   txt-
 *      ,   
 *     .      
 *     0,     .
 * @param codepage=CP_ACP
 *   [in]    .    
 *      .
 * @return 
 *          ,
 *          .
 *       INVALID_HANDLE.
 * @note : 
 *        MQL5
 *       . ,  
 *         MQL5,
 *         "". 
 *          
 *    MQL5\files ( __\MQL5\files
 *     ).    
 *    FILE_COMMON,      
 *       MetaTrader 5.  
 *    " " ...
 * @note  : 
 *     , FileFindFirst, FolderCreate,   
 * @date : 2013.02.12
 * @see www.mql5.com/ru/docs/files/fileopen
 */
int  FileOpen(
   string  file_name,           //  
   int     open_flags,          //  
   short   delimiter = '\t',      // 
   uint    codepage = CP_ACP      //  
   );
/**
 *   FileReadArray
 *      ,  
 *   (   ,   
 *     ),     
 *      .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param array[]
 *   [out]  ,    .
 * @param start=0
 *   [in]       .
 * @param count=WHOLE_ARRAY
 *   [in]     .
 * @return 
 *     .  ,    (count=WHOLE_ARRAY).
 * @note : 
 *           TXT.
 *         .
 * @note  : 
 *   , FileWriteArray
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filereadarray
 */
uint  FileReadArray(
   int    file_handle,               // handle 
   void&  array[],                   //   
   int    start = 0,                   //     
   int    count = WHOLE_ARRAY          //  
   );
/**
 *   FileReadBool
 *       CSV      
 *   (    )   
 *        bool.
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *        "true", "false"
 *        "0"  "1".
 *        true.
 *       .
 * @note  : 
 *    bool, FileWrite
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/filereadbool
 */
bool  FileReadBool(
   int  file_handle      // handle 
   );
/**
 *   FileReadDatetime
 *       CSV    :
 *   "YYYY.MM.DD HH:MI:SS", "YYYY.MM.DD"  "HH:MI:SS" -
 *         datetime.
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *     datetime.
 * @note  : 
 *    datetime, StringToTime, TimeToString, FileWrite
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/filereaddatetime
 */
datetime  FileReadDatetime(
   int  file_handle      // handle 
   );
/**
 *   FileReadDouble
 *          (double)
 *         
 *    .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *     double.
 * @note : 
 *       ,    GetLastError().
 * @note  : 
 *     (double, float), StringToDouble, DoubleToString, FileWriteDouble
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/filereaddouble
 */
double  FileReadDouble(
   int  file_handle      // handle 
   );
/**
 *   FileReadFloat
 *          (float)     .
 * @param file_handle
 *   [in]   ,  FileOpen().
 * @return 
 *     float.
 * @note : 
 *       ,    GetLastError().
 * @note  : 
 *     (double, float), FileReadDouble, FileWriteFloat
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/filereadfloat
 */
float  FileReadFloat(
   int  file_handle      // handle 
   );
/**
 *   FileReadInteger
 *         int,
 *   short  char       .
 *        
 *    .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param size=INT_VALUE
 *   [in]    ( 4 ),   .
 *     : CHAR_VALUE=1,
 *   SHORT_VALUE=2  INT_VALUE=4,   ??
 *   : CHAR_VALUE=1, SHORT_VALUE=2  INT_VALUE=4, 
 *     ? ??????? 
 *        char, short  int.
 * @return 
 *     int.      
 *     ,     ,
 *     .    
 *     int,       
 *     .  
 *        .
 * @note : 
 *      4- ,     .
 *        ,    
 *         
 *     char (1 )   short (2 ). 
 *         ,
 *        .
 * @note  : 
 *   IntegerToString, StringToInteger,  , FileWriteInteger
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/filereadinteger
 */
int  FileReadInteger(
   int  file_handle,        // handle 
   int  size = INT_VALUE      //     
   );
/**
 *   FileReadLong
 *       long (8 )     .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *     long.
 * @note  : 
 *    , FileReadInteger, FileWriteLong
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/filereadlong
 */
long  FileReadLong(
   int  file_handle      // handle 
   );
/**
 *   FileReadNumber
 *       CSV      
 *   (    )   
 *        double.
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *     double.
 * @note  : 
 *   FileWriteString
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/filereadnumber
 */
double  FileReadNumber(
   int  file_handle      // handle 
   );
/**
 *   FileReadString
 *           .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param length=-1
 *   [in]     .
 * @return 
 *    (string).
 * @note : 
 *      bin-     .
 *      txt-     .
 *      txt-      
 *           ?,  
 *           
 *    "\r\n".    csv-   
 *      ,     
 *           
 *     .      FILE_ANSI,
 *        Unicode.
 * @note  : 
 *    string,  , FileWriteInteger
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filereadstring
 */
string  FileReadString(
   int  file_handle,     // handle 
   int  length = -1        //  
   );
/**
 *   FileReadStruct
 *   C      ,
 *      .  
 *        .
 * @param file_handle
 *   [in]      .
 * @param struct_object
 *   [out]    .     ,
 *       .
 * @param size=-1
 *   [in]   ,   .
 *           ,
 *     ,     
 *    .
 * @return 
 *          .
 *          .
 * @note  : 
 *     , FileWriteStruct
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/filereadstruct
 */
uint  FileReadStruct(
   int          file_handle,        // handle 
   const void&  struct_object,      // ,   
   int          size = -1             //    
   );
/**
 *   FileSeek
 *             .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param offset
 *   [in]     ( (? (?    ).
 * @param origin
 *   [in]     .       ENUM_FILE_POSITION.
 * @return 
 *     .
 * @note : 
 *       FileSeek()
 *      (  " "
 *   ),       
 *    .     " " 
 *    (,   ),     
 *          , 
 *     .    
 *          
 *      .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/fileseek
 */
void  FileSeek(
   int                  file_handle,     // handle 
   long                 offset,          //  
   ENUM_FILE_POSITION   origin           //   
   );
/**
 *   FileSize
 *       .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *     int.
 * @note : 
 *       ,    GetLastError().
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filesize
 */
ulong  FileSize(
   int  file_handle      // handle 
   );
/**
 *   FileTell
 *          .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @return 
 *           .
 * @note : 
 *       ,    GetLastError().
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filetell
 */
ulong  FileTell(
   int  file_handle      // handle 
   );
/**
 *   FileWrite
 *        CSV  TXT,     ,     0.         "\r\n".
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param ...
 *   [in]   ,  ,    .         63.
 * @return 
 *     .
 * @note : 
 *          
 *   (.  Print()).   double 
 *       16    , 
 *           
 *          ,   
 *     .   float   5
 *      .   
 *            
 *       DoubleToString().
 *     bool     "true"  "false".
 *     datetime    "YYYY.MM.DD
 *   HH:MI:SS".
 * @note  : 
 *   Comment, Print, StringFormat
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filewrite
 */
uint  FileWrite(
   int  file_handle,     // handle 
   ...                   //   
   );
/**
 *   FileWriteArray
 *       BIN   ,  
 *   (   ,   
 *     ).
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param array[]
 *   [out]    .
 * @param start=0
 *   [in]      (   ).
 * @param count=WHOLE_ARRAY
 *   [in]     (WHOLE_ARRAY ,
 *          start  
 *    ).
 * @return 
 *     .
 * @note : 
 *           TXT.
 *         
 *      "\r\n".      ANSI 
 *    UNICODE,    ansi-, 
 *    .
 * @note  : 
 *   , FileSeek
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/files/filewritearray
 */
uint  FileWriteArray(
   int          file_handle,         // handle 
   const void&  array[],             // 
   int          start = 0,             //    
   int          count = WHOLE_ARRAY    //  
   );
/**
 *   FileWriteDouble
 *         double     .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param value
 *   [in]    double.
 * @return 
 *          
 *   (   sizeof(double)=8).  
 *          .
 * @note  : 
 *     (double, float)
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filewritedouble
 */
uint  FileWriteDouble(
   int     file_handle,     // handle 
   double  value            //   
   );
/**
 *   FileWriteFloat
 *     bin-    float     .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param value
 *   [in]    float.
 * @return 
 *          
 *    (   sizeof(float)=4).  
 *         .
 * @note  : 
 *     (double, float), FileWriteDouble
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filewritefloat
 */
uint  FileWriteFloat(
   int    file_handle,     // handle 
   float  value            //  
   );
/**
 *   FileWriteInteger
 *     bin-    int     .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param value
 *   [in]   .
 * @param size=INT_VALUE
 *   [in]    ( 4 ),  
 *    .   :
 *   CHAR_VALUE=1, SHORT_VALUE=2  INT_VALUE=4,  
 *          char, uchar,
 *   short, ushort, int  uint
 * @return 
 *          .
 *          .
 * @note  : 
 *   IntegerToString, StringToInteger,  
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filewriteinteger
 */
uint  FileWriteInteger(
   int  file_handle,        // handle 
   int  value,              //  
   int  size = INT_VALUE      //   
   );
/**
 *   FileWriteLong
 *     bin-    long     .
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param value
 *   [in]    long.
 * @return 
 *          
 *   (   sizeof(long)=8).  
 *         ..
 * @note  : 
 *    , FileWriteInteger
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filewritelong
 */
uint  FileWriteLong(
   int   file_handle,     // handle 
   long  value            //  
   );
/**
 *   FileWriteString
 *       BIN, CSV  TXT  
 *    string     .
 *        CSV  TXT,   
 *      '\n' (LF)   
 *    '\r' (CR),    '\n'
 *      '\r'.
 * @param file_handle
 *   [in]   ,   FileOpen().
 * @param text_string
 *   [in]  .
 * @param length=-1
 *   [in]   ,   .
 *           BIN.
 *      ,     
 *     0.    ,  
 *    ,       0.
 *      ,   ,  
 *       .
 *      CSV  TXT     
 *     .
 * @return 
 *          .
 *          .
 * @note : 
 *      ,     ,    FILE_UNICODE
 *   (   FILE_ANSI),    
 *     2      .
 *      ,    FILE_ANSI, 
 *          
 *     .
 * @note  : 
 *    string, StringFormat
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filewritestring
 */
uint  FileWriteString(
   int           file_handle,    // handle 
   const string  text_string,    //  
   int           length = -1       //  <
   );
/**
 *   FileWriteStruct
 *     bin-  ,    ,
 *       .
 * @param file_handle
 *   [in]    ??,   FileOpen().
 * @param struct_object
 *   [in]      .
 *       ,  
 *      .
 * @param size=-1
 *   [in]   ,   .
 *           ,
 *     ,     .
 * @return 
 *          .
 *          .
 * @note  : 
 *     
 * @date : 2013.03.20
 * @see www.mql5.com/ru/docs/files/filewritestruct
 */
uint  FileWriteStruct(
   int          file_handle,       // handle 
   const void&  struct_object,     //   
   int          size = -1            //     
   );
/**
 *   FolderClean
 *        . 
 * @param folder_name
 *   [in]   ,      .     .
 * @param common_flag=0
 *   [in] ,   .
 *    common_flag=FILE_COMMON,   
 *         .   
 *         (MQL5\files 
 *    MQL5\tester\files   ).
 * @return 
 *    true   ,  false.
 * @note : 
 *        MQL5     .
 *   ,      
 *     MQL5,      "
 *    ".    ,       
 *      .
 * @note  : 
 *   FileFindFirst, FileFindNext, FileFindClose
 * @date : 2011.11.30
 * @see www.mql5.com/ru/docs/files/folderclean
 */
bool  FolderClean(
   string  folder_name,       //    
   int     common_flag = 0      //  
   );
/**
 *   FolderCreate
 *       Files (    common_flag)
 * @param folder_name
 *   [in]   ,   .     .
 * @param common_flag=0
 *   [in] ,   .
 *    common_flag=FILE_COMMON,   
 *         .   
 *         (MQL5\files 
 *    MQL5\tester\files   ).
 * @return 
 *    true   ,  false.
 * @note : 
 *        MQL5  
 *     . ,    
 *       MQL5,   
 *       "".
 * @note  : 
 *   FileOpen(), FolderClean(), FileCopy()
 * @date : 2011.11.30
 * @see www.mql5.com/ru/docs/files/foldercreate
 */
bool  FolderCreate(
   string  folder_name,       //     
   int     common_flag = 0      //  
   );
/**
 *   FolderDelete
 *     .    ,      .
 * @param folder_name
 *   [in]   ,   .     .
 * @param common_flag=0
 *   [in] ,   .
 *    common_flag=FILE_COMMON,   
 *         .   
 *         (MQL5\files 
 *    MQL5\tester\files   ).
 * @return 
 *    true   ,  false.
 * @note : 
 *        MQL5     .
 *   ,      
 *     MQL5,      
 *    "".       /
 *    ,     ,
 *      .  
 *           
 *        FolderClean().
 * @note  : 
 *   FileOpen(), FolderClean(), FileMove()
 * @date : 2011.11.30
 * @see www.mql5.com/ru/docs/files/folderdelete
 */
bool  FolderDelete(
   string  folder_name,       //     
   int     common_flag = 0      //  
   );

/**
 *   GlobalVariableCheck
 *        .
 * @param name
 *   [in]    .
 * @return 
 *     true,    ,   false.
 * @note : 
 *        
 *   4     ,  
 *     .
 * @note  : 
 *   GlobalVariableTime()
 * @date : 2010.08.16
 * @see www.mql5.com/ru/docs/globals/globalvariablecheck
 */
bool  GlobalVariableCheck(
   string  name      // 
   );
/**
 *   GlobalVariableDel
 *       .
 * @param name
 *   [in]    .
 * @return 
 *        true,  false.
 *       ,  
 *     GetLastError().
 * @note : 
 *         4 
 *      ,  
 *     .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/globals/globalvariabledel
 */
bool  GlobalVariableDel(
   string  name      // 
   );
/**
 *   GlobalVariableGet
 *       
 *     .  2  . ~
 *   1.    . ~ 2.
 *    true  false
 *        .   
 *        
 *        , 
 *       .
 * @param name
 *   [in]    .
 * @param double_var
 *   [out]    double,   ,
 *        .
 * @return 
 *        0   .
 *       ,  
 *     GetLastError().
 * @note : 
 *         4 
 *      ,  
 *     .
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/globals/globalvariableget
 */
double  GlobalVariableGet(
   string  name      // 
   );
/**
 *   GlobalVariableGet
 *       
 *     .  2  . ~
 *   1.    . ~ 2.
 *    true  false
 *        .   
 *        
 *        , 
 *       .
 * @param name
 *   [in]    .
 * @param double_var
 *   [out]    double,   ,
 *        .
 * @return 
 *        0   .
 *       ,  
 *     GetLastError().
 * @note : 
 *         4 
 *      ,  
 *     .
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/globals/globalvariableget
 */
bool  GlobalVariableGet(
   string  name,              // 
   double& double_var         //     
   );
/**
 *   GlobalVariableName
 *         .
 * @param index
 *   [in]       .
 *        0  ,
 *    GlobalVariablesTotal() .
 * @return 
 *          
 *    .     
 *        GetLastError().
 * @note : 
 *         4 
 *      ,  
 *     .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/globals/globalvariablename
 */
string  GlobalVariableName(
   int  index      //     
   );
/**
 *   GlobalVariablesDeleteAll
 *       .
 * @param prefix_name=NULL
 *   [in]      .
 *      NULL   ,  
 *        
 *    ,     
 * @param limit_data=0
 *   [in]          .
 *     ,   
 *     .    ,   
 *     ,  
 *     ( ).
 * @return 
 *     .
 * @note : 
 *        (prefix_name=NULL  limit_data=0),
 *        .
 *      ,   
 *    ,   
 *     .  
 *        4   
 *     ,  
 *     .
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/globals/globalvariablesdeleteall
 */
int  GlobalVariablesDeleteAll(
   string     prefix_name = NULL,     //   ,     
   datetime   limit_data = 0          //   ,      
   );
/**
 *   GlobalVariableSet
 *       .
 *      ,    
 *     .
 * @param name
 *   [in]    .
 * @param value
 *   [in]    .
 * @return 
 *       
 *     ,  0.  
 *      ,  
 *     GetLastError().
 * @note : 
 *         4 
 *      ,  
 *     .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/globals/globalvariableset
 */
datetime  GlobalVariableSet(
   string  name,      // 
   double  value      //  
   );
/**
 *   GlobalVariableSetOnCondition
 *        ,
 *         
 *     check_value.    ,
 *      ERR_GLOBALVARIABLE_NOT_FOUND
 *   (4501)   false.
 * @param name
 *   [in]    .
 * @param value
 *   [in]   .
 * @param check_value
 *   [in]         .
 * @return 
 *        true,  false.
 *    ,     , 
 *      GetLastError().   
 *        check_value,
 *     false.
 * @note : 
 *         ,
 *          
 *       
 *         
 *    .
 * @date : 2011.03.03
 * @see www.mql5.com/ru/docs/globals/globalvariablesetoncondition
 */
bool  GlobalVariableSetOnCondition(
   string  name,            // 
   double  value,           //    
   double  check_value      //  
   );
/**
 *   GlobalVariablesFlush
 *          . 
 * @return 
 *     .
 * @note : 
 *           ,
 *           .
 *        
 *         
 *    .
 * @date : 2010.08.16
 * @see www.mql5.com/ru/docs/globals/globalvariablesflush
 */
void  GlobalVariablesFlush();
/**
 *   GlobalVariablesTotal
 *         .
 * @return 
 *     .
 * @note : 
 *         4 
 *      ,  
 *     .   
 *          
 *   ,      .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/globals/globalvariablestotal
 */
int  GlobalVariablesTotal();
/**
 *   GlobalVariableTemp
 *        .
 *      ,    
 *      .
 * @param name
 *   [in]     .
 * @return 
 *        true,  false.
 *       ,  
 *     GetLastError().
 * @note : 
 *            ,
 *        .
 *      GlobalVariablesFlush() 
 *         .
 *          
 *         ,    
 *       .
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/globals/globalvariabletemp
 */
bool  GlobalVariableTemp(
   string  name      // 
   );
/**
 *   GlobalVariableTime
 *         . 
 * @param name
 *   [in]    .
 * @return 
 *          .
 *          
 *   .     ,  
 *     GetLastError().
 * @note : 
 *         4 
 *      ,  
 *     .
 * @note  : 
 *   GlobalVariableCheck()
 * @date : 2010.02.11
 * @see www.mql5.com/ru/docs/globals/globalvariabletime
 */
datetime  GlobalVariableTime(
   string  name      // 
   );

/**
 *   iAC
 *         
 *   Accelerator Oscillator    .  
 *    .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]        
 *    ENUM_TIMEFRAMES, 0   .
 * @return 
 *       ,  
 *      INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iac
 */
int  iAC(
   string           symbol,     //  
   ENUM_TIMEFRAMES  period      // 
   );
/**
 *   iAD
 *      Accumulation/Distribution.   .
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param applied_volume
 *   [in]    .     ENUM_APPLIED_VOLUME.
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iad
 */
int  iAD(
   string               symbol,             //  
   ENUM_TIMEFRAMES      period,             // 
   ENUM_APPLIED_VOLUME  applied_volume      //    
   );
/**
 *   iADX
 *      Average Directional Movement Index.
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]        
 *     ENUM_TIMEFRAMES, 0  
 *    .
 * @param adx_period
 *   [in]     .
 * @note : 
 *    : 0 - MAIN_LINE, 1 - PLUSDI_LINE, 2 - MINUSDI_LINE.
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iadx
 */
int  iADX(
   string           symbol,         //  
   ENUM_TIMEFRAMES  period,         // 
   int              adx_period      //  
   );
/**
 *   iADXWilder
 *      Average Directional Movement Index by Welles Wilder.
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]        
 *     ENUM_TIMEFRAMES, 0  
 *    .
 * @param adx_period
 *   [in]     .
 * @note : 
 *    : 0 - MAIN_LINE, 1 - PLUSDI_LINE, 2 - MINUSDI_LINE.
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iadxwilder
 */
int  iADXWilder(
   string           symbol,         //  
   ENUM_TIMEFRAMES  period,         // 
   int              adx_period      //  
   );
/**
 *   iAlligator
 *      Alligator.
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param jaw_period
 *   [in]      ( ).
 * @param jaw_shift
 *   [in]       . 
 * @param teeth_period
 *   [in]      ( ).
 * @param teeth_shift
 *   [in]       . 
 * @param lips_period
 *   [in]      ( ).
 * @param lips_shift
 *   [in]       . 
 * @param ma_method
 *   [in]   .       ENUM_MA_METHOD.
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @note : 
 *    : 0 - GATORJAW_LINE, 1 - GATORTEETH_LINE, 2 - GATORLIPS_LINE.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ialligator
 */
int  iAlligator(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 jaw_period,        //    
   int                 jaw_shift,         //    
   int                 teeth_period,      //    
   int                 teeth_shift,       //    
   int                 lips_period,       //    
   int                 lips_shift,        //    
   ENUM_MA_METHOD      ma_method,         //  
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iAMA
 *      Adaptive Moving Average.   .
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]        
 *    ENUM_TIMEFRAMES, 0   .
 * @param ama_period
 *   [in]   ,    
 *    .
 * @param fast_ma_period
 *   [in]           .
 * @param slow_ma_period
 *   [in]          .
 * @param ama_shift
 *   [in]      .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iama
 */
int  iAMA(
   string              symbol,             //  
   ENUM_TIMEFRAMES     period,             // 
   int                 ama_period,         //  AMA
   int                 fast_ma_period,     //   
   int                 slow_ma_period,     // ;?  
   int                 ama_shift,          //    
   ENUM_APPLIED_PRICE  applied_price       //    handle
   );
/**
 *   iAO
 *      Awesome oscillator.   .
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]          ENUM_TIMEFRAMES,
 *   0   .
 * @return 
 *       ,
 *       INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iao
 */
int  iAO(
   string           symbol,     //  
   ENUM_TIMEFRAMES  period      // 
   );
/**
 *   iATR
 *      Average True Range.   .
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]          ENUM_TIMEFRAMES,
 *   0   .
 * @param ma_period
 *   [in]      .
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iatr
 */
int  iATR(
   string           symbol,        //  
   ENUM_TIMEFRAMES  period,        // 
   int              ma_period      //  
   );
/**
 *   iBands
 *      Bollinger Bands.
 * @param symbol
 *   [in]    ,   
 *     . NULL   .
 * @param period
 *   [in]        
 *    ENUM_TIMEFRAMES, 0   .
 * @param bands_period
 *   [in]      .
 * @param bands_shift
 *   [in]      .
 * @param deviation
 *   [in]     .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,  
 *     INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @note : 
 *    : 0 - BASE_LINE, 1 - UPPER_BAND, 2 - LOWER_BAND
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ibands
 */
int  iBands(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 bands_period,      //     
   int                 bands_shift,       //    
   double              deviation,         // -  
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iBearsPower
 *      Bears Power.   .
 * @param symbol
 *   [in]    ,   
 *     . NULL   .
 * @param period
 *   [in]        
 *     ENUM_TIMEFRAMES, 0  
 *    .
 * @param ma_period
 *   [in]      .
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ibearspower
 */
int  iBearsPower(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period         //  
   );
/**
 * @param iBullsPower
 *      Bulls Power.   .
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]      .
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ibullspower
 */
int  iBullsPower(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period         //  
   );
/**
 *   iBWMFI
 *      Market Facilitation Index.   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]        
 *     ENUM_TIMEFRAMES, 0  
 *    .
 * @param applied_volume
 *   [in]   .       ENUM_APPLIED_VOLUME.
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ibwmfi
 */
int  iBWMFI(
   string               symbol,             //  
   ENUM_TIMEFRAMES      period,             // 
   ENUM_APPLIED_VOLUME  applied_volume      //    
   );
/**
 *   iCCI
 *      Commodity Channel Index.   .
 * @param symbol
 *   [in]    ,      . NULLNULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]      .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/icci
 */
int  iCCI(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period,         //  
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iChaikin
 *      Chaikin Oscillator.   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]        
 *    ENUM_TIMEFRAMES, 0   .
 * @param fast_ma_period
 *   [in]       .
 * @param slow_ma_period
 *   [in]       .
 * @param ma_method
 *   [in]   .      ENUM_MA_METHOD.
 * @param applied_volume
 *   [in]   .      ENUM_APPLIED_VOLUME.
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ichaikin
 */
int  iChaikin(
   string               symbol,             //  
   ENUM_TIMEFRAMES      period,             // 
   int                  fast_ma_period,     //  
   int                  slow_ma_period,     //  
   ENUM_MA_METHOD       ma_method,          //  
   ENUM_APPLIED_VOLUME  applied_volume      //  
   );
/**
 *   iCustom
 *       .
 * @param symbol
 *   [in]    ,   
 *     . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param name
 *   [in]    ,   
 *      (MQL5/Indicators/).
 *       , 
 *   ,  MQL5/Indicators/Examples,    
 *    ,    "Examples\\_"
 *   (    
 *        ).
 * @param ...
 *   [in]  input-  ,  .
 *         .
 *      ,   
 *    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @note : 
 *        (   EX5)
 *       MQL5/Indicators 
 *       .  
 *    ? ?????? 
 *         iCustom(),
 *        .
 *      (
 *     IndicatorCreate()   
 *      ,   ) 
 *      #property tester_indicator: 
 *        ,   
 *        "Parameters"
 *          
 *    .   "Apply to"   
 *   ,       
 *    "Close".
 *        mql5-
 *    Applied_Price     
 *        
 *       .
 * @note  : 
 *    ,     , IndicatorCreate(), IndicatorRelease()
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/icustom
 */
int  iCustom(
   string           symbol,     //  
   ENUM_TIMEFRAMES  period,     // 
   string           name,       // /_ 
   ...                          //    
   );
/**
 *   iDEMA
 *      Double Exponential Moving Average.   .
 * @param symbol
 *   [in]    ,   
 *     . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]  ( )   .
 * @param ma_shift
 *   [in]      .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/idema
 */
int  iDEMA(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period,         //  
   int                 ma_shift,          //    
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iDeMarker
 *      DeMarker.   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]      .
 * @return 
 *       ,  
 *     INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/idemarker
 */
int  iDeMarker(
   string           symbol,        //  
   ENUM_TIMEFRAMES  period,        // 
   int              ma_period      //  
   );
/**
 *   iEnvelopes
 *      Envelopes.
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]          ENUM_TIMEFRAMES,
 *   0   .
 * @param ma_period
 *   [in]      .
 * @param ma_shift
 *   [in]      .
 * @param ma_method
 *   [in]   .        ENUM_MA_METHOD.
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @param deviation
 *   [in]       .
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @note : 
 *    : 0 - UPPER_LINE, 1 - LOWER_LINE.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ienvelopes
 */
int  iEnvelopes(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period,         //     
   int                 ma_shift,          //    
   ENUM_MA_METHOD      ma_method,         //  
   ENUM_APPLIED_PRICE  applied_price,     //    handle
   double              deviation          //     
   );
/**
 *   iForce
 *      Force Index.   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]      .
 * @param ma_method
 *   [in]   .       ENUM_MA_METHOD.
 * @param applied_volume
 *   [in]   .       ENUM_APPLIED_VOLUME.
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iforce
 */
int  iForce(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period,         //  
   ENUM_MA_METHOD      ma_method,         //  
   ENUM_APPLIED_VOLUME applied_volume     //    
   );
/**
 *   iFractals
 *      Fractals.
 * @param symbol
 *   [in]    ,   
 *     . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @note : 
 *    : 0 - UPPER_LINE, 1 - LOWER_LINE.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ifractals
 */
int  iFractals(
   string           symbol,     //  
   ENUM_TIMEFRAMES  period      // 
   );
/**
 *   iFrAMA
 *      Fractal Adaptive Moving Average.   .
 * @param symbol
 *   [in]    ,   
 *     . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]  ( )   .
 * @param ma_shift
 *   [in]      .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iframa
 */
int  iFrAMA(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period,         //  
   int                 ma_shift,          //    
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iGator
 *      Gator.          ( )        ( ).
 * @param symbol
 *   [in]    ,   
 *     . NULL   .
 * @param period
 *   [in]        
 *    ENUM_TIMEFRAMES, 0   .
 * @param jaw_period
 *   [in]      ( ).
 * @param jaw_shift
 *   [in]        .
 *         
 *     .
 * @param teeth_period
 *   [in]      ( ).
 * @param teeth_shift
 *   [in]        .
 *         
 *     .
 * @param lips_period
 *   [in]      ( ).
 * @param lips_shift
 *   [in]        .
 *         
 *     .
 * @param ma_method
 *   [in]   .      ENUM_MA_METHOD.
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @note : 
 *    : 0 - UPPER_HISTOGRAM, 1-    ,
 *   2 - LOWER_HISTOGRAM, 3-    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/igator
 */
int  iGator(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 jaw_period,        //    
   int                 jaw_shift,         //    
   int                 teeth_period,      //    
   int                 teeth_shift,       //    
   int                 lips_period,       //    
   int                 lips_shift,        //    
   ENUM_MA_METHOD      ma_method,         //  
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iIchimoku
 *      Ichimoku Kinko Hyo.
 * @param symbol
 *   [in]    ,   
 *     . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param tenkan_sen
 *   [in]    Tenkan Sen.
 * @param kijun_sen
 *   [in]    Kijun Sen.
 * @param senkou_span_b
 *   [in]    Senkou Span B.
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @note : 
 *    : 0 - TENKANSEN_LINE, 1 - KIJUNSEN_LINE, 2 - SENKOUSPANA_LINE,
 *   3 - SENKOUSPANB_LINE, 4 - CHINKOUSPAN_LINE.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iichimoku
 */
int  iIchimoku(
   string           symbol,            //  
   ENUM_TIMEFRAMES  period,            // 
   int              tenkan_sen,        //  Tenkan-sen
   int              kijun_sen,         //  Kijun-sen
   int              senkou_span_b      //  Senkou Span B
   );
/**
 *   iMA
 *       .   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]       .
 * @param ma_shift
 *   [in]      .
 * @param ma_method
 *   [in]   .      ENUM_MA_METHOD.
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease()IndicatorRelease(),
 *      ??  
 *   ? ????? .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ima
 */
int  iMA(
   string               symbol,            //  
   ENUM_TIMEFRAMES      period,            // 
   int                  ma_period,         //  
   int                  ma_shift,          //    
   ENUM_MA_METHOD       ma_method,         //  
   ENUM_APPLIED_PRICE   applied_price      //    handle
   );
/**
 *   iMACD
 *      Moving Averages Convergence/Divergence.
 *     ,  s   MACD, 
 *         .  
 *     /  
 *       .
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param fast_ema_period
 *   [in]        .
 * @param slow_ema_period
 *   [in]        .
 * @param signal_period
 *   [in]       .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,
 *       INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @note : 
 *    : 0 - MAIN_LINE, 1 - SIGNAL_LINE.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/imacd
 */
int  iMACD(
   string              symbol,              //  
   ENUM_TIMEFRAMES     period,              // 
   int                 fast_ema_period,     //   
   int                 slow_ema_period,     //   
   int                 signal_period,       //   
   ENUM_APPLIED_PRICE  applied_price        //    handle
   );
/**
 *   iMFI
 *    Money Flow Index.
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]  ( )   .
 * @param applied_volume
 *   [in]   .     ENUM_APPLIED_VOLUME.
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/imfi
 */
int  iMFI(
   string               symbol,             //  
   ENUM_TIMEFRAMES      period,             // 
   int                  ma_period,          //  
   ENUM_APPLIED_VOLUME  applied_volume      //    
   );
/**
 *   iMomentum
 *      Momentum.   .
 * @param symbol
 *   [in]    ,    
 *     . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param mom_period
 *   [in]  ( )    .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,  
 *     INVALID_HANDLE.  
 *         
 *      IndicatorRelease(),
 *       .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/imomentum
 */
int  iMomentum(
   string               symbol,            //  
   ENUM_TIMEFRAMES      period,            // 
   int                  mom_period,        //  
   ENUM_APPLIED_PRICE   applied_price      //    handle
   );
/**
 *   iOBV
 *      On Balance Volume.   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]        
 *     ENUM_TIMEFRAMES, 0  
 *    .
 * @param applied_volume
 *   [in]   .       ENUM_APPLIED_VOLUME.
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iobv
 */
int  iOBV(
   string                symbol,             //  
   ENUM_TIMEFRAMES       period,             // 
   ENUM_APPLIED_VOLUME   applied_volume      //    
   );
/**
 *   iOsMA
 *      Moving Average of Oscillator.  OsMA     MACD    .   .
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param fast_ema_period
 *   [in]        .
 * @param slow_ema_period
 *   [in]        .
 * @param signal_period
 *   [in]       .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @note : 
 *          MACD.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iosma
 */
int  iOsMA(
   string              symbol,              //  
   ENUM_TIMEFRAMES     period,              // 
   int                 fast_ema_period,     //   
   int                 slow_ema_period,     //   
   int                 signal_period,       //   
   ENUM_APPLIED_PRICE  applied_price        //    handle
   );
/**
 *   iRSI
 *      Relative Strength Index.   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]      .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/irsi
 */
int  iRSI(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period,         //  
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iRVI
 *      Relative Vigor Index.
 * @param symbol
 *   [in]    ,   
 *     . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]      .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @note : 
 *    : 0 - MAIN_LINE, 1 - SIGNAL_LINE.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/irvi
 */
int  iRVI(
   string           symbol,        //  
   ENUM_TIMEFRAMES  period,        // 
   int              ma_period      //  
   );
/**
 *   iSAR
 *      Parabolic Stop and Reverse system.   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param step
 *   [in]    ,  0.02.
 * @param maximum
 *   [in]    ,  0.2.
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/isar
 */
int  iSAR(
   string           symbol,      //  
   ENUM_TIMEFRAMES  period,      // 
   double           step,        //    - 
   double           maximum      //     
   );
/**
 *   iStdDev
 *      Standard Deviation.   .
 * @param symbol
 *   [in]    ,     
 *   . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]      .
 * @param ma_shift
 *   [in]      .
 * @param ma_method
 *   [in]   .      ENUM_MA_METHOD.
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/istddev
 */
int  iStdDev(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period,         //  
   int                 ma_shift,          //    
   ENUM_MA_METHOD      ma_method,         //  
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iStochastic
 *      Stochastic Oscillator.
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param Kperiod
 *   [in]  K-( )    %K.
 * @param Dperiod
 *   [in]       %D.
 * @param slowing
 *   [in]   .
 * @param ma_method
 *   [in]   .      ENUM_MA_METHOD.
 * @param price_field
 *   [in]      .      ENUM_STO_PRICE.
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @note : 
 *    : 0 - MAIN_LINE, 1 - SIGNAL_LINE.
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/istochastic
 */
int  iStochastic(
   string           symbol,          //  
   ENUM_TIMEFRAMES  period,          // 
   int              Kperiod,         // K- (   )
   int              Dperiod,         // D- (  )
   int              slowing,         //  
   ENUM_MA_METHOD   ma_method,       //  
   ENUM_STO_PRICE   price_field      //   
   );
/**
 *   iTEMA
 *      Triple Exponential Moving Average.   .
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]  ( )   .
 * @param ma_shift
 *   [in]      .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/itema
 */
int  iTEMA(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period,         //  
   int                 ma_shift,          //    
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iTriX
 *      Triple Exponential Moving Averages Oscillator.   .
 * @param symbol
 *   [in]    ,      .
 *   NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param ma_period
 *   [in]  ( )   .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/itrix
 */
int  iTriX(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 ma_period,         //  
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iVIDyA
 *      Variable Index Dynamic Average.   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param cmo_period
 *   [in]  ( )   Chande Momentum Oscillator.
 * @param ema_period
 *   [in]  ( ) EMA    .
 * @param ma_shift
 *   [in]      .
 * @param applied_price
 *   [in]   .      
 *   ENUM_APPLIED_PRICE    .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ividya
 */
int  iVIDyA(
   string              symbol,            //  
   ENUM_TIMEFRAMES     period,            // 
   int                 cmo_period,        //  Chande Momentum
   int                 ema_period,        //   
   int                 ma_shift,          //    
   ENUM_APPLIED_PRICE  applied_price      //    handle
   );
/**
 *   iVolumes
 *     ,   .   .
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param applied_volume
 *   [in]   .       ENUM_APPLIED_VOLUME.
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/ivolumes
 */
int  iVolumes(
   string               symbol,             //  
   ENUM_TIMEFRAMES      period,             // 
   ENUM_APPLIED_VOLUME  applied_volume      //  
   );
/**
 *   iWPR
 *      Larry Williams' Percent Range.   . 
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param calc_period
 *   [in]  ( )   .
 * @return 
 *       ,   
 *    INVALID_HANDLE.    
 *        
 *     IndicatorRelease(),    
 *    .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/indicators/iwpr
 */
int  iWPR(
   string           symbol,          //  
   ENUM_TIMEFRAMES  period,          // 
   int              calc_period      //  
   );

/**
 *   MarketBookAdd
 *         ,
 *         
 *       .
 * @param symbol
 *   [in]   ,          .
 * @return 
 *    true    ,  false.
 * @note : 
 *   ,       OnInit()
 *      .    
 *          void
 *   OnBookEvent(string& symbol).
 * @note  : 
 *   ,    
 * @date : 2009.09.22
 * @see www.mql5.com/ru/docs/marketinformation/marketbookadd
 */
bool  MarketBookAdd(
   string  symbol      // 
   );
/**
 *   MarketBookGet
 *      MqlBookInfo,      .
 * @param symbol
 *   [in]   .
 * @param book[]
 *   [out]       .
 *         
 *     .    
 *        ,  
 *        .
 * @return 
 *    true   ,  false.
 * @note : 
 *          MarketBookAdd().
 * @note  : 
 *   ,    
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/marketinformation/marketbookget
 */
bool  MarketBookGet(
   string        symbol,     // 
   MqlBookInfo&  book[]      //   
   );
/**
 *   MarketBookRelease
 *         ,
 *           
 *     .
 * @param symbol
 *   [in]   .
 * @return 
 *    true    ,  false.
 * @note : 
 *          OnDeinit()
 *     ,    OnInit()  
 *      MarketBookAdd().  
 *       ,    
 *        MarketBookAdd().
 * @note  : 
 *   ,    
 * @date : 2009.09.22
 * @see www.mql5.com/ru/docs/marketinformation/marketbookrelease
 */
bool  MarketBookRelease(
   string  symbol      //  
   );
/**
 *   SymbolInfoDouble
 *       .
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false       .
 *           
 *    ,     .
 *
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .    
 *      ENUM_SYMBOL_INFO_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.    
 *      e  
 *       GetLastError(): 
 *       GetLastError():  ~ 5040   
 *         ,
 *    ~ 4301    ( ), ~
 *    4302      " " (
 *      ),  ~ 4303  
 *      .
 * @note : 
 *           ,
 *      SymbolInfoTick().  ,
 *          
 *           .  
 *        .
 *       
 *     SymbolInfoTick(),   
 *        Ask, Bid, Last, Volume  
 *      .
 * @date : 2013.03.05
 * @see www.mql5.com/ru/docs/marketinformation/symbolinfodouble
 */
double  SymbolInfoDouble(
   string                  name,         // 
   ENUM_SYMBOL_INFO_DOUBLE prop_id       //  
   );
/**
 *   SymbolInfoDouble
 *       .
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false       .
 *           
 *    ,     .
 *
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .    
 *      ENUM_SYMBOL_INFO_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.    
 *      e  
 *       GetLastError(): 
 *       GetLastError():  ~ 5040   
 *         ,
 *    ~ 4301    ( ), ~
 *    4302      " " (
 *      ),  ~ 4303  
 *      .
 * @note : 
 *           ,
 *      SymbolInfoTick().  ,
 *          
 *           .  
 *        .
 *       
 *     SymbolInfoTick(),   
 *        Ask, Bid, Last, Volume  
 *      .
 * @date : 2013.03.05
 * @see www.mql5.com/ru/docs/marketinformation/symbolinfodouble
 */
bool  SymbolInfoDouble(
   string                   name,        // 
   ENUM_SYMBOL_INFO_DOUBLE  prop_id,     //  
   double&                  double_var   //    
   );
/**
 *   SymbolInfoInteger
 *       .
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false      .
 *          
 *    ,     .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .      
 *    ENUM_SYMBOL_INFO_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *     long.    
 *      e  
 *       GetLastError():  ~ 5040   
 *         ,
 *    ~ 4301    ( ), ~
 *    4302      " " (
 *      ),  ~ 4303   
 *      .
 * @note : 
 *           ,
 *      SymbolInfoTick().  ,
 *          
 *           .  
 *        .
 *       
 *     SymbolInfoTick(),   
 *        Ask, Bid, Last, Volume  
 *      .
 * @date : 2013.03.05
 * @see www.mql5.com/ru/docs/marketinformation/symbolinfointeger
 */
long  SymbolInfoInteger(
   string                    name,      // 
   ENUM_SYMBOL_INFO_INTEGER  prop_id    //  
   );
/**
 *   SymbolInfoInteger
 *       .
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false      .
 *          
 *    ,     .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .      
 *    ENUM_SYMBOL_INFO_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *     long.    
 *      e  
 *       GetLastError():  ~ 5040   
 *         ,
 *    ~ 4301    ( ), ~
 *    4302      " " (
 *      ),  ~ 4303   
 *      .
 * @note : 
 *           ,
 *      SymbolInfoTick().  ,
 *          
 *           .  
 *        .
 *       
 *     SymbolInfoTick(),   
 *        Ask, Bid, Last, Volume  
 *      .
 * @date : 2013.03.05
 * @see www.mql5.com/ru/docs/marketinformation/symbolinfointeger
 */
bool  SymbolInfoInteger(
   string                    name,      // 
   ENUM_SYMBOL_INFO_INTEGER  prop_id,   //  
   long&                     long_var   //    
   );
/**
 *   SymbolInfoSessionQuote
 *         
 *          
 *    .
 * @param name
 *   [in]   .
 * @param day_of_week
 *   [in]   ,    ENUM_DAY_OF_WEEK.
 * @param session_index
 *   [in]    ,    
 *       .   
 *     0.
 * @param from
 *   [out]        00  00 ,
 *        .
 * @param to
 *   [out]         00  00 ,
 *        .
 * @return 
 *       ,     ,
 *     true,   ,  
 *    true,   ,     false.
 * @note  : 
 *     , TimeToStruct,  
 * @date : 2010.07.19
 * @see www.mql5.com/ru/docs/marketinformation/symbolinfosessionquote
 */
bool  SymbolInfoSessionQuote(
   string            name,                //  
   ENUM_DAY_OF_WEEK  day_of_week,         //  
   uint              session_index,       //  
   datetime&         from,                //   
   datetime&         to                   //   
   );
/**
 *   SymbolInfoSessionTrade
 *            
 *         .
 * @param name
 *   [in]   .
 * @param day_of_week
 *   [in]   ,    ENUM_DAY_OF_WEEK.
 * @param session_index
 *   [in]    ,     
 *      .     0.
 * @param from
 *   [out]        00  00 ,
 *        .
 * @param to
 *   [out]         00  00 ,
 *        .
 * @return 
 *       ,     ,
 *     true,   false.
 * @note  : 
 *     , TimeToStruct,  
 * @date : 2010.07.19
 * @see www.mql5.com/ru/docs/marketinformation/symbolinfosessiontrade
 */
bool  SymbolInfoSessionTrade(
   string            name,                //  
   ENUM_DAY_OF_WEEK  day_of_week,         //  
   uint              session_index,       //  
   datetime&         from,                //   
   datetime&         to                   //   
   );
/**
 *   SymbolInfoString
 *       .
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false      .
 *          
 *   ,     .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .    
 *      ENUM_SYMBOL_INFO_STRING.
 * @param string_var
 *   [out]    string,     .
 *         e  
 *      GetLastError(): ~ 5040   
 *          ,  ~ 4301
 *      (  ),  ~ 4302
 *        " " (    
 *   ),  ~ 4303          .
 * @note : 
 *           ,
 *      SymbolInfoTick().  ,
 *          
 *           .  
 *        .
 *       
 *     SymbolInfoTick(),   
 *        Ask, Bid, Last, Volume  
 *      .
 * @return 
 *     string.
 * @date : 2013.03.05
 * @see www.mql5.com/ru/docs/marketinformation/symbolinfostring
 */
string  SymbolInfoString(
   string                   name,      // 
   ENUM_SYMBOL_INFO_STRING  prop_id    //  
   );
/**
 *   SymbolInfoString
 *       .
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false      .
 *          
 *   ,     .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .   
 *       ENUM_SYMBOL_INFO_STRING.
 * @param string_var
 *   [out]    string,     .
 *         e  
 *      GetLastError(): ~ 5040   
 *          ,  ~ 4301
 *      (  ),  ~ 4302
 *        " " (    
 *   ),  ~ 4303          .
 * @note : 
 *           ,
 *      SymbolInfoTick().  ,
 *          
 *           .  
 *        .
 *       
 *     SymbolInfoTick(),   
 *        Ask, Bid, Last, Volume  
 *      .
 * @return 
 *     string.
 * @date : 2013.03.05
 * @see www.mql5.com/ru/docs/marketinformation/symbolinfostring
 */
bool  SymbolInfoString(
   string  name,                      // 
   ENUM_SYMBOL_INFO_STRING  prop_id,  //  
   string& string_var                 //    
   );
/**
 *   SymbolInfoTick
 *             MqlTick.
 * @param symbol
 *   [in]   .
 * @param tick
 *   [out]      MqlTick,    
 *         .
 * @return 
 *    true   ,  false.
 * @date : 2012.07.04
 * @see www.mql5.com/ru/docs/marketinformation/symbolinfotick
 */
bool  SymbolInfoTick(
   string    symbol,     // 
   MqlTick&  tick        //   
   );
/**
 *   SymbolIsSynchronized
 *         
 *         
 * @param name
 *   [in]   .
 * @return 
 *     ,  true,   false.
 * @note  : 
 *   SymbolInfoInteger,     
 * @date : 2010.03.11
 * @see www.mql5.com/ru/docs/marketinformation/symbolissynchronized
 */
bool  SymbolIsSynchronized(
   string  name       //  
   );
/**
 *   SymbolName
 *      .
 * @param pos
 *   [in]     .
 * @param selected
 *   [in]   .   true,     
 *     MarketWatch.   false,  
 *       .
 * @return 
 *     string c  .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/marketinformation/symbolname
 */
string  SymbolName(
   int   pos,          //   
   bool  selected      // true     MarketWatch
   );
/**
 *   SymbolSelect
 *       MarketWatch     .
 * @param name
 *   [in]   .
 * @param select
 *   [in]  .   false,    
 *      MarketWatch,     
 *        MarketWatch.     
 *   ,        
 *         .
 * @return 
 *        false.
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/marketinformation/symbolselect
 */
bool  SymbolSelect(
   string  name,       //  
   bool    select      //   
   );
/**
 *   SymbolsTotal
 *      (  MarketWatch  ) .
 * @param selected
 *   [in]   .    true  false.
 * @return 
 *     selected  true,   
 *     MarketWatch .   false,
 *        .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/marketinformation/symbolstotal
 */
int  SymbolsTotal(
   bool  selected      // true     MarketWatch
   );

/**
 *   MathAbs
 *      (  )   .
 * @param value
 *   [in]   .
 * @return 
 *     double,    .
 * @note : 
 *     MathAbs()    fabs().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/mathabs
 */
double  MathAbs(
   double  value      // 
   );
/**
 *   MathArccos
 *      x   0  pi  .
 * @param val
 *   [in]   val  -1  1,     .
 * @return 
 *      .  val  -1   1,
 *     NaN ( ).
 * @note : 
 *     MathArccos()    acos(). 
 * @note  : 
 *     (double, float)
 * @date : 2009.09.17
 * @see www.mql5.com/ru/docs/math/matharccos
 */
double  MathArccos(
   double  val     // -1<val<1
   );
/**
 *   MathArcsin
 *     x    -pi/2  pi/2 .
 * @param val
 *   [in]    val  -1  1,     .
 * @return 
 *     val      -pi/2  pi/2
 *   .  val  -1   1,  
 *    NaN ( ).
 * @note : 
 *     MathArcsin()    asin().
 * @note  : 
 *     (double, float)
 * @date : 2009.07.22
 * @see www.mql5.com/ru/docs/math/matharcsin
 */
double  MathArcsin(
   double  val      // -1<value<1
   );
/**
 *   MathArctan
 *     x.  x  0,   0.
 * @param value
 *   [in]  ,  .
 * @return 
 *   MathArctan      -pi/2  pi/2 .
 * @note : 
 *     MathArctan()    atan().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/matharctan
 */
double  MathArctan(
   double  value      // 
   );
/**
 *   MathCeil
 *        .
 * @param val
 *   [in]   .
 * @return 
 *    ,    ,     val.
 * @note : 
 *     MathCeil()    ceil().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/mathceil
 */
double  MathCeil(
   double  val      // 
   );
/**
 *   MathCos
 *      .
 * @param value
 *   [in]    .
 * @return 
 *     double    -1  1.
 * @note : 
 *     MathCos()    cos().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/mathcos
 */
double  MathCos(
   double  value      // 
   );
/**
 *   MathExp
 *      e   d.
 * @param value
 *   [in]  ,  .
 * @return 
 *     double.     INF (),
 *       MathExp  0.
 * @note : 
 *     MathExp()    exp().
 * @note  : 
 *     (double, float)
 * @date : 2009.09.17
 * @see www.mql5.com/ru/docs/math/mathexp
 */
double  MathExp(
   double  value      //    e
   );
/**
 *   MathFloor
 *        .
 * @param val
 *   [in]   .
 * @return 
 *    ,    ,     val.
 * @note : 
 *     MathFloor()    floor().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/mathfloor
 */
double  MathFloor(
   double  val     // </span
   );
/**
 *   MathIsValidNumber
 *      
 * @param number
 *   [in]   .
 * @return 
 *    true,     
 *    .     
 *      ,  " " (NaN - not a
 *   number),   false.
 * @note  : 
 *   (double,float)
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/math/mathisvalidnumber
 */
bool  MathIsValidNumber(
   double  number      //  ?nbsp;??? 
   );
/**
 *   MathLog
 *     .
 * @param val
 *   [in]  ,     .
 * @return 
 *     val   .   val ,
 *     NaN ( ).  val
 *    0,   INF () .
 * @note : 
 *     MathLog()    log().
 * @note  : 
 *     (double, float)
 * @date : 2009.07.22
 * @see www.mql5.com/ru/docs/math/mathlog
 */
double  MathLog(
   double  val      //    
   );
/**
 *   MathLog
 *        10.
 * @param val
 *   [in]  ,      .
 * @return 
 *     val   .   val ,
 *     NaN ( ).  val
 *    0,   INF () .
 * @note : 
 *     MathLog10()    log10().
 * @note  : 
 *     (double, float)
 * @date : 2009.07.22
 * @see www.mql5.com/ru/docs/math/mathlog10
 */
double  MathLog10(
   double  val      //    
   );
/**
 *   MathMax
 *         .
 * @param value1
 *   [in]    .
 * @param value2
 *   [in]    .
 * @return 
 *      .
 * @note : 
 *     MathMax()    fmax().
 *    fmax(), fmin(), MathMax(), MathMin()  
 *           double. 
 *        ,  
 *          .
 *        .
 *       ,  
 *      .
 * @date : 2010.02.17
 * @see www.mql5.com/ru/docs/math/mathmax
 */
double  MathMax(
   double  value1,     //  
   double  value2      //  
   );
/**
 *   MathMin
 *         .
 * @param value1
 *   [in]    .
 * @param value2
 *   [in]    .
 * @return 
 *      .
 * @note : 
 *     MathMin()    fmin().
 *    fmax(), fmin(), MathMax(), MathMin()  
 *           double. 
 *        ,  
 *          .
 *        .
 *       ,  
 *      .
 * @date : 2010.02.17
 * @see www.mql5.com/ru/docs/math/mathmin
 */
double  MathMin(
   double  value1,     //  
   double  value2      //  
   );
/**
 *   MathMod
 *         .
 * @param value
 *   [in]   .
 * @param value2
 *   [in]   .
 * @return 
 *    MathMod    f  val / y  ,
 *    val = i * y + f ,  i   , f 
 *      ,   val,    f ,
 *      y.
 * @note : 
 *     MathMod()    fmod().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/mathmod
 */
double  MathMod(
   double  value,      // 
   double  value2      // 
   );
/**
 *   MathPow
 *       .
 * @param base
 *   [in]  .
 * @param exponent
 *   [in]   .
 * @return 
 *    ,    .
 * @note : 
 *     MathPow()    pow().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/mathpow
 */
double  MathPow(
   double  base,         // 
   double  exponent      //  
   );
/**
 *   MathRand
 *          0  32767.
 * @return 
 *        0  32767.
 * @note : 
 *          MathSrand,
 *         
 *    .
 * @note : 
 *     MathRand()    rand().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/mathrand
 */
int  MathRand();
/**
 *   MathRound
 *    ,        .
 * @param value
 *   [in]     .
 * @return 
 *   ,     .
 * @note : 
 *     MathRound()    round().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/mathround
 */
double  MathRound(
   double  value      //  
   );
/**
 *   MathSin
 *      .
 * @param value
 *   [in]    .
 * @return 
 *    ,   .      -1  1.
 * @note : 
 *     MathSin()    sin().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/math/mathsin
 */
double  MathSin(
   double  value      //   
   );
/**
 *   MathSqrt
 *      .
 * @param value
 *   [in]    .
 * @return 
 *      value.  value ,
 *   MathSqrt  NaN ( ).
 * @note : 
 *     MathSqrt()    sqrt().
 * @note  : 
 *     (double, float)
 * @date : 2009.07.22
 * @see www.mql5.com/ru/docs/math/mathsqrt
 */
double  MathSqrt(
   double  value      //  
   );
/**
 *   MathSrand
 *           .
 * @param seed
 *   [in]       .
 * @return 
 *     .
 * @note : 
 *    MathRand()    
 *    .  MathSrand()  
 *         
 *         .
 *      
 *      
 *    MathSrand(GetTickCount()),   
 *    GetTickCount()    
 *           49 
 *   ,      .
 *    MathSrand(TimeCurrent())  
 *     ,   TimeCurrent()  
 *      ,     
 *    , ,   .  
 *        MathSrand() 
 *           
 *    OnInit(),     
 *       OnTick()  OnCalculate().
 *     MathSrand()  
 *     srand().
 * @date : 2012.04.25
 * @see www.mql5.com/ru/docs/math/mathsrand
 */
void  MathSrand(
   int  seed      //  
   );
/**
 *   MathTan
 *     .
 * @param rad
 *   [in]    .
 * @return 
 *     rad.  rad    263     -263,
 *         
 *     .
 * @note : 
 *     MathTan()    tan().
 * @note  : 
 *     (double, float)
 * @date : 2009.09.17
 * @see www.mql5.com/ru/docs/math/mathtan
 */
double  MathTan(
   double  rad      //   
   );

/**
 *   ObjectCreate
 *       ,    
 *      .    
 *     30 .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .        ,   .
 * @param type
 *   [in]   .        ENUM_OBJECT.
 * @param sub_window
 *   [in]    . 0    .
 *      ,   
 *      false.
 * @param time1
 *   [in]     .
 * @param price1
 *   [in]      .
 * @param timeN=0
 *   [in]    N-  . 
 * @param priceN=0
 *   [in]    N-  .
 * @param time30=0
 *   [in]      . 
 * @param price30=0
 *   [in]      .
 * @return 
 *    true  false        .
 *        ,
 *      GetLastError().   
 *      ,     
 *    .
 * @note : 
 *      (      )
 *     1.       
 *     0.     ( 30-)
 *       .     
 *       30-    
 *        ,   
 *          64.
 *       
 *       ,   
 *         OnChartEvent():
 *        ;  
 *        .
 *          
 *       : ...
 * @date : 2012.06.28
 * @see www.mql5.com/ru/docs/objects/objectcreate
 */
bool  ObjectCreate(
   long         chart_id,      //  
   string       name,          //  
   ENUM_OBJECT  type,          //  
   int          sub_window,    //  
   datetime     time1,         //    
   double       price1,        //    
   ...
   datetime     timeN = 0,       //  N-  
   double       priceN = 0,      //  N-  
   ...
   datetime     time30 = 0,      //  30-  
   double       price30 = 0      //  30- 
   );
/**
 *   ObjectDelete
 *          .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]    .
 * @return 
 *    true     ,
 *      false.   
 *      ,  
 *     GetLastError().
 * @note : 
 *           ,
 *           OnChartEvent():
 * @date : 2010.06.17
 * @see www.mql5.com/ru/docs/objects/objectdelete
 */
bool  ObjectDelete(
   long    chart_id,     // ?????? 
   string  name          //  
   );
/**
 *   ObjectsDeleteAll
 *        ,    ,  .
 * @param chart_id
 *   [in]   . 0   .
 * @param sub_window=-1
 *   [in]    . 0    ,
 *   -1    ,   .
 * @param type=-1
 *   [in]   .        ENUM_OBJECT. -1   .
 * @return 
 *      .
 *         
 *       GetLastError().
 * @date : 2012.06.04
 * @see www.mql5.com/ru/docs/objects/objectdeleteall
 */
int  ObjectsDeleteAll(
   long  chart_id,           //  
   int   sub_window = -1,      //  
   int   type = -1             //    
   );
/**
 *   ObjectFind
 *            .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]    .
 * @return 
 *          (0    ),
 *       .    
 *   ,     .  
 *       ,  
 *     GetLastError().
 * @note : 
 *           ,
 *          
 *    OnChartEvent(): ~   
 *      ; ~   
 *       .
 * @date : 2010.06.17
 * @see www.mql5.com/ru/docs/objects/objectfind
 */
int  ObjectFind(
   long    chart_id,     //  
   string  name          //  
   );
/**
 *   ObjectGetDouble
 *       .
 *        double.   2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_DOUBLE.
 * @param prop_modifier
 *   [in]    .
 *          
 *    0.     . 
 *           
 *      .   
 *     .
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double    . 
 *        true,
 *          
 *      double_var,   false. 
 *        , 
 *      GetLastError().
 * @date : 2010.05.20<10.05.20
 * @see www.mql5.com/ru/docs/objects/objectgetdouble
 */
double  ObjectGetDouble(
   long    chart_id,          //  
   string  name,              //  
   int     prop_id,           //  
   int     prop_modifier = 0    //  ,  
   );
/**
 *   ObjectGetDouble
 *       .
 *        double.   2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_DOUBLE.
 * @param prop_modifier
 *   [in]    .
 *          
 *    0.     . 
 *           
 *      .   
 *     .
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double    . 
 *        true,
 *          
 *      double_var,   false. 
 *        , 
 *      GetLastError().
 * @date : 2010.05.20<10.05.20
 * @see www.mql5.com/ru/docs/objects/objectgetdouble
 */
bool  ObjectGetDouble(
   long    chart_id,          //  
   string  name,              //  
   int     prop_id,           //  
   int     prop_modifier,     //  
   double& double_var         //    
   );
/**
 *   ObjectGetInteger
 *       .
 *       
 *   datetime,int,color,boolchar.  2 
 *   . ~ 1.    
 *  . ~ 2.  true  false
 *       
 *          ,
 *       .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .     
 *     ENUM_OBJECT_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .     
 *      0. 
 *       .   
 *           
 *    .     .
 * @param long_var
 *   [out]    long,     .
 * @return 
 *     long    . 
 *        true,    
 *         long_var, 
 *     false.   
 *      ,  
 *     GetLastError().
 * @date : 201: 201010.05.20
 * @see www.mql5.com/ru/docs/objects/objectgetinteger
 */
long  ObjectGetInteger(
   long    chart_id,          //  
   string  name,              //  
   int     prop_id,           //  
   int     prop_modifier = 0    //  ,  
   );
/**
 *   ObjectGetInteger
 *       .
 *       
 *   datetime,int,color,boolchar.  2 
 *   . ~ 1.    
 *  . ~ 2.  true  false
 *       
 *          ,
 *       .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .     
 *     ENUM_OBJECT_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .     
 *      0. 
 *       .   
 *           
 *    .     .
 * @param long_var
 *   [out]    long,     .
 * @return 
 *     long    . 
 *        true,    
 *         long_var, 
 *     false.   
 *      ,  
 *     GetLastError().
 * @date : 201: 201010.05.20
 * @see www.mql5.com/ru/docs/objects/objectgetinteger
 */
bool  ObjectGetInteger(
   long    chart_id,          //  
   string  name,              //  
   int     prop_id,           //  
   int     prop_modifier,     //  
   long&   long_var           //    
   );
/**
 *   ObjectGetString
 *       .
 *        string.  2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_STRING.
 * @param prop_modifier
 *   [in]    .
 *          
 *    0.     . 
 *           
 *      .   
 *     .
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string    .
 *        true,   
 *         
 *    string_var,   false.  
 *       ,  
 *     GetLastError().
 * @note : 
 *       
 *     ,   
 *         OnChartEvent(): ~
 *        ; ~  
 *        .
 * @date : 2010.06.17
 * @see www.mql5.com/ru/docs/objects/objectgetstring
 */
string  ObjectGetString(
   long    chart_id,          //  
   string  name,              //  
   int     prop_id,           //  
   int     prop_modifier = 0    //  ,  
   );
/**
 *   ObjectGetString
 *       .
 *        string.  2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_STRING.
 * @param prop_modifier
 *   [in]    .
 *          
 *    0.     . 
 *           
 *      .   
 *     .
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string    .
 *        true,   
 *         
 *    string_var,   false.  
 *       ,  
 *     GetLastError().
 * @note : 
 *       
 *     ,   
 *         OnChartEvent(): ~
 *        ; ~  
 *        .
 * @date : 2010.06.17
 * @see www.mql5.com/ru/docs/objects/objectgetstring
 */
bool  ObjectGetString(
   long    chart_id,          //  
   string  name,              //  
   int     prop_id,           //  
   int     prop_modifier,     //  
   string& string_var         //    
   );
/**
 *   ObjectGetTimeByValue
 *           .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param value
 *   [in]   .
 * @param line_id 
 *   [in]   .
 * @return 
 *          .
 * @note : 
 *             ,
 *       .   
 *       :  
 *    (OBJ_TREND) *     
 *    (OBJ_TRENDBYANGLE) *   (OBJ_GANNLINE) *
 *     (OBJ_CHANNEL) - 2  
 *       (OBJ_REGRESSION) - 3  
 *      (OBJ_STDDEVCHANNEL) - 3 
 *      (OBJ_ARROWED_LINE)
 * @note  : 
 *    
 * @date : 2010.09.24
 * @see www.mql5.com/ru/docs/objects/objectgettimebyvalue
 */
datetime  ObjectGetTimeByValue(
   long    chart_id,     //  
   string  name,         //  
   double  value,        // 
   int     line_id       //  
   );
/**
 *   ObjectGetValueByTime
 *          .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param time
 *   [in]   .
 * @param line_id
 *   [in]   .
 * @return 
 *         .
 * @note : 
 *             ,
 *       .   
 *       :  
 *    (OBJ_TREND)      
 *    (OBJ_TRENDBYANGLE)    (OBJ_GANNLINE)
 *     (OBJ_CHANNEL) - 2  
 *       (OBJ_REGRESSION) - 3  
 *      (OBJ_STDDEVCHANNEL) - 3 
 *       (OBJ_ARROWED_LINE)
 * @note  : 
 *    
 * @date : 2010.09.24
 * @see www.mql5.com/ru/docs/objects/objectgetvaluebytime
 */
double  ObjectGetValueByTime(
   long      chart_id,     //  
   string    name,         //  
   datetime  time,         // 
   int       line_id       //  
   );
/**
 *   ObjectMove
 *        .
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param point_index
 *   [in]    .       .
 * @param time
 *   [in]      .
 * @param price
 *   [in]      .
 * @return 
 *       true,    false.
 *        ,
 *      GetLastError().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/objects/objectmove
 */
bool  ObjectMove(
   long      chart_id,        //  
   string    name,            //  
   int       point_index,     //  
   datetime  time,            // 
   double    price            // 
   );
/**
 *   ObjectName
 *         ,
 *      ,  .
 * @param chart_id
 *   [in]   . 0   .
 * @param pos
 *   [in]            .
 * @param sub_window=-1
 *   [in]    . 0    ,
 *   -1    ,   .
 * @param type=-1
 *   [in]   .        ENUM_OBJECT. -1   .
 * @return 
 *       .
 * @note : 
 *       
 *     ,   
 *         OnChartEvent():
 * @date : 2012.06.04
 * @see www.mql5.com/ru/docs/objects/objectname
 */
string  ObjectName(
   long  chart_id,           //  
   int   pos,                //    
   int   sub_window = -1,      //  
   int   type = -1             //  
   );
/**
 *   ObjectSetDouble
 *       . 
 *        double.  2 
 *    . ~   ,  
 *     ~     
 *    
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_DOUBLE.
 * @param prop_modifier
 *   [in]    .
 *           
 *      .   
 *     .
 * @param prop_value 
 *   [in]   .
 * @return 
 *    true    ,
 *         
 *      ,   false. 
 *        , 
 *      GetLastError().
 * @note  : 
 *    ,  
 * @date : 2010.11.02
 * @see www.mql5.com/ru/docs/objects/objectsetdouble
 */
bool  ObjectSetDouble(
   long    chart_id,          //  
   string  name,              // 
   int     prop_id,           // 
   double  prop_value         // 
   );
/**
 *   ObjectSetDouble
 *       . 
 *        double.  2 
 *    . ~   ,  
 *     ~     
 *    
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_DOUBLE.
 * @param prop_modifier
 *   [in]    .
 *           
 *      .   
 *     .
 * @param prop_value 
 *   [in]   .
 * @return 
 *    true    ,
 *         
 *      ,   false. 
 *        , 
 *      GetLastError().
 * @note  : 
 *    ,  
 * @date : 2010.11.02
 * @see www.mql5.com/ru/docs/objects/objectsetdouble
 */
bool  ObjectSetDouble(
   long    chart_id,          //  
   string  name,              // 
   int     prop_id,           // 
   int     prop_modifier,     // 
   double  prop_value         // 
   );
/**
 *   ObjectSetInteger
 *       .
 *       
 *    datetime,int,color,boolchar.  2 
 *    . ~   ,  
 *     ~     
 *    
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .
 *           
 *      .   
 *     .
 * @param prop_value 
 *   [in]   .
 * @return 
 *    true    ,
 *         
 *      ,   false. 
 *        , 
 *      GetLastError().
 * @note  : 
 *    ,  
 * @date : 2011.11.28
 * @see www.mql5.com/ru/docs/objects/objectsetinteger
 */
bool  ObjectSetInteger(
   long    chart_id,          //  
   string  name,              // 
   int     prop_id,           // 
   long    prop_value         // 
   );
/**
 *   ObjectSetInteger
 *       .
 *       
 *   datetime,int,color,boolchar.  2 
 *   . ~   ,  
 *    ~     
 *   
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_INTEGER.
 * @param prop_modifier
 *   [in]    .
 *           
 *      .   
 *     .
 * @param prop_value 
 *   [in]   .
 * @return 
 *    true    ,
 *         
 *      ,   false. 
 *        , 
 *      GetLastError().
 * @note  : 
 *    ,  
 * @date : 2011.11.28
 * @see www.mql5.com/ru/docs/objects/objectsetinteger
 */
bool  ObjectSetInteger(
   long    chart_id,          //  
   string  name,              // 
   int     prop_id,           // 
   int     prop_modifier,     // 
   long    prop_value         // 
   );
/**
 *   ObjectSetString
 *       .
 *        string.  2
 *    . ~   ,  
 *     ~     
 *    
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_STRING.
 * @param prop_modifier
 *   [in]    .
 *           
 *      .   
 *     .
 * @param prop_value 
 *   [in]   .
 * @return 
 *    true    ,
 *         
 *      ,   false. 
 *        , 
 *      GetLastError().
 * @note : 
 *           ,
 *          
 *    OnChartEvent(): ~      ;
 *   ~       .
 * @date : 2010.11.02
 * @see www.mql5.com/ru/docs/objects/objectsetstring
 */
bool  ObjectSetString(
   long    chart_id,          //  
   string  name,              // 
   int     prop_id,           // 
   string  prop_value         // 
   );
/**
 *   ObjectSetString
 *       .
 *        string.  2
 *    . ~   ,  
 *     ~     
 *    
 * @param chart_id
 *   [in]   . 0   .
 * @param name
 *   [in]   .
 * @param prop_id
 *   [in]    .
 *         
 *    ENUM_OBJECT_PROPERTY_STRING.
 * @param prop_modifier
 *   [in]    .
 *           
 *      .   
 *     .
 * @param prop_value 
 *   [in]   .
 * @return 
 *    true    ,
 *         
 *      ,   false. 
 *        , 
 *      GetLastError().
 * @note : 
 *           ,
 *          
 *    OnChartEvent(): ~      ;
 *   ~       .
 * @date : 2010.11.02
 * @see www.mql5.com/ru/docs/objects/objectsetstring
 */
bool  ObjectSetString(
   long    chart_id,          //  
   string  name,              // 
   int     prop_id,           // 
   int     prop_modifier,     // 
   string  prop_value         // 
   );
/**
 *   ObjectsTotal
 *        ,
 *      ,  .
 * @param chart_id
 *   [in]   . 0   .
 * @param nwin=-1
 *   [in]    . 0    ,
 *   -1    ,   .
 * @param type=-1
 *   [in]   .        ENUM_OBJECT. -1   .
 * @return 
 *    .
 * @date : 2012.06.04
 * @see www.mql5.com/ru/docs/objects/objectstotal
 */
int  ObjectsTotal(
   long  chart_id,           //  
   int   sub_window = -1,      //  
   int   type = -1             //  
   );
/**
 *   TextGetSize
 *           .
 * @param text
 *   [in]        .
 * @param width
 *   [out]      .
 * @param height
 *   [out]      .
 * @return 
 *    true    ,  false.   :
 *   ERR_INTERNAL_ERROR(4001) -     .
 * @note  : 
 *   , ResourceCreate(), ResourceSave(), TextSetFont(), TextOut()
 * @date : 2012.12.20
 * @see www.mql5.com/ru/docs/objects/textgetsize
 */
bool  TextGetSize(
   const string       text,          //  
   uint&               width,        //    
   uint&               height        //    
   );
/**
 *   TextOut
 *        ()
 *        .  
 *        .
 * @param text
 *   [in]   ,     .     .
 * @param x
 *   [in]  a X     .
 * @param y
 *   [in]  a Y     .
 * @param anchor
 *   [in]     9  
 *        .
 *         
 *         
 *      .   
 *     .
 * @param data[]
 *   [in]  ,    .       .
 * @param width
 *   [in]      ().
 * @param height
 *   [in]      ().
 * @param color
 *   [in]   .
 * @param color_format
 *   [in]   ,     ENUM_COLOR_FORMAT.
 * @return 
 *    true    ,  false.
 * @note : 
 *    ,   anchor,
 *       
 *        .  
 *      : ~ TA_LEFT     
 *        ~ TA_CENTER
 *           
 *       ~ TA_RIGHT
 *          
 *          :
 *   ~ TA_TOP       
 *       ~ TA_VCENTER
 *           
 *      ~ TA_BOTTOM
 *         
 *     
 *    
 *             .
 *    
 * @note  : 
 *   , ResourceCreate(), ResourceSave(), TextGetSize(),
 *   TextSetFont()
 * @date : 2013.02.07
 * @see www.mql5.com/ru/docs/objects/textout
 */
bool  TextOut(
   const string       text,          //  
   int                x,             // a X
   int                y,             // a Y
   uint               anchor,        //  
   uint& data[],       //   
   uint               width,         //    
   uint               height,        //    
   uint               color,         //  
   ENUM_COLOR_FORMAT  color_format   //    
   );
/**
 *   TextSetFont
 *         
 *        .  
 *      Arial   -120 (12 pt).
 * @param name
 *   [in]     ,   ,  ,       .
 * @param size
 *   [in]   ,     
 *    .    
 *           
 *      .   
 *           
 *          ("
 *    "  " ").    
 *        .
 * @param flags
 *   [in]   ,   .
 * @param orientation
 *   [in]         X,    0.1 .
 *     orientation=450   ? ? ? ?? 45
 *   .
 * @return 
 *    true      
 *   ,  false.   : ~
 *   ERR_INVALID_PARAMETER(4003) - name  NULL
 *     "" ( ), ~ ERR_INTERNAL_ERROR(4001) -
 *       (,  
 *      ).
 * @note : 
 *        "::",      EX5.
 *      name   ,  
 *      ,      
 *     "\"  "/",      MQL5,
 *       EX5-, 
 *     TextSetFont(). 
 *      
 *      ,
 *           
 *      ( ). ~  
 *       ,    
 *         
 *          
 *        ()   
 *            
 *   .       , 
 *          
 *    ,     TextOut(),  ,
 *           OBJ_LABEL
 *   ("  "). TextOut(),  , 
 *            OBJ_LABEL ("
 *     "). ~      
 *    ,       
 *           ( -350 
 *    35   )    10,
 *            
 *        ()
 *       
 *        .  
 *            ,    
 *    OBJ_LABEL,       
 *          -10.   
 *               ,
 *     .   
 *       .      
 * @note  : 
 *   , ResourceCreate(), ResourceSave(), TextOut()
 * @date : 2013.02.19
 * @see www.mql5.com/ru/docs/objects/textsetfont
 */
bool  TextSetFont(
   const string  name,            //         
   int           size,            //  
   uint          flags,           //  
   int           orientation = 0    //   
   );

/**
 *   CLBufferCreate
 *     OpenCL     .
 * @param context
 *   [in]    context OpenCL.
 * @param size
 *   [in]     .
 * @param flags
 *   [in]   ,    :
 *   CL_MEM_READ_WRITE, CL_MEM_WRITE_ONLY, CL_MEM_READ_ONLY,
 *   CL_MEM_ALLOC_HOST_PTR.
 * @return 
 *      OpenCL   .
 *       -1.  
 *         GetLastError().
 * @note : 
 *         : ~
 *   ERR_OPENCL_INVALID_HANDLE  -    
 *    OpenCL, ~ ERR_NOT_ENOUGH_MEMORY
 *     , ~ ERR_OPENCL_BUFFER_CREATE
 *       .
 *    
 * @date : 2012.03.28
 * @see www.mql5.com/ru/docs/opencl/clbuffercreate
 */
int  CLBufferCreate(
   int   context,     //    OpenCL
   uint  size,        //  
   uint  flags        //  ,   
   );
/**
 *   CLBufferFree
 *     OpenCL.
 * @param buffer
 *   [in]     OpenCL.
 * @return 
 *   .       _LastError.
 *        
 *     GetLastError().
 * @date : 2012.03.28
 * @see www.mql5.com/ru/docs/opencl/clbufferfree
 */
void  CLBufferFree(
   int   buffer     //    OpenCL
   );
/**
 *   CLBufferRead
 *     OpenCL       .
 * @param buffer
 *   [in]    OpenCL.
 * @param data[]
 *   [in]        OpenCL.   .
 * @param buffer_offset
 *   [in]    OpenCL   ,    .
 *         .
 * @param data_offset
 *   [in]          OpenCL.
 *          
 *      .
 * @param data_count
 *   [in]   ,   .      OpenCL.
 * @return 
 *     ,     0.
 *       0.  
 *    ?   ???  
 *      GetLastError().
 * @note : 
 *       ,    
 *      OpenCL,    
 *    AS_SERIES.      
 *       .    data_offset
 *      ,   
 *     ,      
 *    .
 * @date : 2012.04.02
 * @see www.mql5.com/ru/docs/opencl/clbufferread
 */
uint  CLBufferRead(
   int          buffer,                    //    OpenCL</spap;OpenCL
   const void&  data[],                    //  
   uint         buffer_offset = 0,           //   OpenCL   ,   0
   uint         data_offset = 0,             //     ,   0
   uint         data_count = WHOLE_ARRAY     //      ,    
   );
/**
 *   CLBufferWrite
 *       OpenCL     .
 * @param buffer
 *   [in]    OpenCL.
 * @param data[]
 *   [in]   ,      OpenCL.   .
 * @param buffer_offset
 *   [in]    OpenCL   ,    .
 *          .
 * @param data_offset
 *   [in]     ,     
 *        OpenCL .   
 *        .
 * @param data_count
 *   [in]   ,   .     .
 * @return 
 *     ,     0.
 *        
 *     GetLastError().
 * @note : 
 *       ,     
 *       OpenCL,    
 *    AS_SERIES.      
 *      .    data_offset
 *      ,   
 *     ,      
 *    .
 * @date : 2012.04.02
 * @see www.mql5.com/ru/docs/opencl/clbufferwrite
 */
uint  CLBufferWrite(
   int          buffer,                    //    OpenCL
   const void&  data[],                    //  
   uint         buffer_offset = 0,           //   OpenCL   ,   0
   uint         data_offset = 0,             //     ,   0
   uint         data_count = WHOLE_ARRAY     //      ,    
   );
/**
 *   CLContextCreate
 *     OpenCL     .
 * @param device
 *   [in]   OpenCL-    .
 *          :
 *   CL_USE_ANY     
 *       OpenCL; CL_USE_GPU_ONLY
 *     OpenCL    
 *         OpenCL
 *   ().
 * @return 
 *      OpenCL   ,  -1   .
 *        
 *     GetLastError().
 * @date : 2012.04.02
 * @see www.mql5.com/ru/docs/opencl/clcontextcreate
 */
int  CLContextCreate(
   int  device     //   OpenCL   
   );
/**
 *   CLContextFree
 *     OpenCL.
 * @param context
 *   [in]   ? ???? OpenCL.
 * @return 
 *   .       _LastError.
 *        
 *     GetLastError().
 * @date : 2012.03.28
 * @see www.mql5.com/ru/docs/opencl/clcontextfree
 */
void  CLContextFree(
   int  context     //    OpenCL
   );
/**
 *   CLExecute
 *    OpenCL .  3  :
 *   ~ 1.   kernel    
 *   ~ 2.    kernel (OpenCL )
 *      
 *   ~ 3.    kernel (OpenCL )
 *          
 *       
 * @param 
 *   kernel
 *   [in]     OpenCL.
 * @param work_dim
 *   [in]    .
 * @param global_work_offset[]
 *   [in]      .
 * @param global_work_size[]
 *   [in]    .
 * @param local_work_size[]
 *   [in]       .
 * @return 
 *    true   ,    false.
 *        
 *     GetLastError().
 * @note : 
 *       :
 *    ~ work_dim    work_items[],
 *    .  work_dim=3,   3-
 *     work_items[N1, N2, N3].  ~ global_work_size[]
 *    ,    work_items[].
 *      work_dim=3,  , 
 *    global_work_size[3]   {40, 100, 320}. 
 *     work_items[40, 100, 320].   
 *      40  100  320 = 1 280 000.
 *    ~ local_work_size[]   ,
 *        OpenCL
 *   .     work_items[]
 *           
 *        . , 
 *     local_work_size[]    
 *    ,      work_items[]
 *       .   
 *     local_work_size[3]={10, 10, 10},  
 *    work_items[40, 100, 320]    
 *      local_items[10, 10, 10].
 * @date : 2013.02.01
 * @see www.mql5.com/ru/docs/opencl/clexecute
 */
bool  CLExecute(
   int          kernel                    //    OpenCL 
   );
/**
 *   CLExecute
 *    OpenCL .  3  :
 *   ~ 1.   kernel    
 *   ~ 2.    kernel (OpenCL )
 *      
 *   ~ 3.    kernel (OpenCL )
 *          
 *       
 * @param 
 *   kernel
 *   [in]     OpenCL.
 * @param work_dim
 *   [in]    .
 * @param global_work_offset[]
 *   [in]      .
 * @param global_work_size[]
 *   [in]    .
 * @param local_work_size[]
 *   [in]       .
 * @return 
 *    true   ,    false.
 *        
 *     GetLastError().
 * @note : 
 *       :
 *    ~ work_dim    work_items[],
 *    .  work_dim=3,   3-
 *     work_items[N1, N2, N3].  ~ global_work_size[]
 *    ,    work_items[].
 *      work_dim=3,  , 
 *    global_work_size[3]   {40, 100, 320}. 
 *     work_items[40, 100, 320].   
 *      40  100  320 = 1 280 000.
 *    ~ local_work_size[]   ,
 *        OpenCL
 *   .     work_items[]
 *           
 *        . , 
 *     local_work_size[]    
 *    ,      work_items[]
 *       .   
 *     local_work_size[3]={10, 10, 10},  
 *    work_items[40, 100, 320]    
 *      local_items[10, 10, 10].
 * @date : 2013.02.01
 * @see www.mql5.com/ru/docs/opencl/clexecute
 */
bool  CLExecute(
   int          kernel,                   //    OpenCL 
   uint         work_dim,                 //   
   const uint&  global_work_offset[],     //     
   const uint&  global_work_size[]        //   
   );
/**
 *   CLExecute
 *    OpenCL .  3  :
 *   ~ 1.   kernel    
 *   ~ 2.    kernel (OpenCL )
 *      
 *   ~ 3.    kernel (OpenCL )
 *          
 *       
 * @param 
 *   kernel
 *   [in]     OpenCL.
 * @param work_dim
 *   [in]    .
 * @param global_work_offset[]
 *   [in]      .
 * @param global_work_size[]
 *   [in]    .
 * @param local_work_size[]
 *   [in]       .
 * @return 
 *    true   ,    false.
 *        
 *     GetLastError().
 * @note : 
 *       :
 *    ~ work_dim    work_items[],
 *    .  work_dim=3,   3-
 *     work_items[N1, N2, N3].  ~ global_work_size[]
 *    ,    work_items[].
 *      work_dim=3,  , 
 *    global_work_size[3]   {40, 100, 320}. 
 *     work_items[40, 100, 320].   
 *      40  100  320 = 1 280 000.
 *    ~ local_work_size[]   ,
 *        OpenCL
 *   .     work_items[]
 *           
 *        . , 
 *     local_work_size[]    
 *    ,      work_items[]
 *       .   
 *     local_work_size[3]={10, 10, 10},  
 *    work_items[40, 100, 320]    
 *      local_items[10, 10, 10].
 * @date : 2013.02.01
 * @see www.mql5.com/ru/docs/opencl/clexecute
 */
bool  CLExecute(
   int          kernel,                   //    OpenCL 
   uint         work_dim,                 //   
   const uint&  global_work_offset[],     //     
   const uint&  global_work_size[],       //   
   const uint&  local_work_size[]         //     
   );
/**
 *   CLGetInfoInteger
 *        OpenCL-  .
 * @param handle
 *   [in]     OpenCL   OpenCL .  OpenCL    .
 * @param prop
 *   [in]       ENUM_OPENCL_PROPERTY_INTEGER,
 *      .
 * @return 
 *          -1   .
 *        
 *     GetLastError(). ENUM_OPENCL_PROPERTY_INTEGER
 *    ENUM_CL_DEVICE_TYPE   
 *       OpenCL.   
 *           
 *              
 *     ??  OpenCL   
 *    CLGetInfoInteger(handle_or_deviceN, CL_DEVICE_TYPE).
 * @date : 2012.10.30
 * @see www.mql5.com/ru/docs/opencl/clgetinfointeger
 */
long  CLGetInfoInteger(
   int  handle,                           //   OpenCL   OpenCL 
   ENUM_OPENCL_PROPERTY_INTEGER  prop     //  
   );
/**
 *   CLGetInfoString
 *        OpenCL-  .
 * @param handle
 *   [in]     OpenCL   OpenCL .  OpenCL    .
 * @param prop
 *   [in]       ENUM_OPENCL_PROPERTY_STRING,
 *      .
 * @param value
 *   [out]      .
 * @return 
 *   true     false   .
 *        
 *     GetLastError(). ENUM_OPENCL_PROPERTY_STRING
 * @date : 2012.10.30
 * @see www.mql5.com/ru/docs/opencl/clgetinfostring
 */
bool  CLGetInfoString(
   int  handle,                           //   OpenCL &nCL &n?  OpenCL 
   ENUM_OPENCL_PROPERTY_STRING  prop,     //  
   string&  value                         //   
   );
/**
 *   CLHandleType
 *     OpenCL       ENUM_OPENCL_HANDLE_TYPE.
 * @param handle
 *   [in]     OpenCL: , ,    OpenCL.
 * @return 
 *     OpenCL      ENUM_OPENCL_HANDLE_TYPE.
 *   ENUM_OPENCL_HANDLE_TYPE
 * @date : 2012.03.28
 * @see www.mql5.com/ru/docs/opencl/clhandletype
 */
ENUM_OPENCL_HANDLE_TYPE  CLHandleType(
   int  handle     //   OpenCL
   );
/**
 *   CLKernelCreate
 *        OpenCL     .
 * @param program
 *   [in]      OpenCL.
 * @param kernel_name
 *   [in]    ,        OpenCL ,
 *      . 
 * @return 
 *      OpenCL   .     -1.
 *        
 *     GetLastError().
 * @note : 
 *         : ~
 *   ERR_OPENCL_INVALID_HANDLE -    program
 *   OpenCL, ~ ERR_INVALID_PARAMETER -  
 *    , ~ ERR_OPENCL_TOO_LONG_KERNEL_NAME - 
 *       127 , ~
 *   ERR_OPENCL_KERNEL_CREATE -      
 *     OpenCL.
 * @date : 2012.03.28
 * @see www.mql5.com/ru/docs/opencl/clkernelcreate
 */
int  CLKernelCreate(
   int           program,        //    OpenCL
   const string  kernel_name     //  
   );
/**
 *   CLKernelFree
 *      OpenCL.
 * @param kernel_name
 *   [in]  ??  . 
 * @return 
 *   .       _LastError.
 *        
 *     GetLastError().
 * @date : 2012.03.26
 * @see www.mql5.com/ru/docs/opencl/clkernelfree
 */
void  CLKernelFree(
   int  kernel     //    OpenCL 
   );
/**
 *   CLProgramCreate
 *    OpenCL    .
 * @param context
 *   [in]    OpenCL.
 * @param source
 *   [in]      OpenCL .
 * @return 
 *      OpenCL   .     -1.
 *        
 *     GetLastError().
 * @note : 
 *         : ~
 *   ERR_OPENCL_INVALID_HANDLE     context
 *   OpenCL, ~ ERR_INVALID_PARAMETER   
 *    , ~ ERR_NOT_ENOUGH_MEMORY
 *        ,
 *   ~ERR_OPENCL_PROGRAM_CREATE    OpenCL
 *     .
 * @date : 2012.03.28
 * @see www.mql5.com/ru/docs/opencl/clprogramcreate
 */
int  CLProgramCreate(
   int           context,     //     OpenCL
   const string  source       //  
   );
/**
 *   CLProgramFree
 *    OpenCL .
 * @param program
 *   [in]    OpenCL.
 * @return 
 *   .       _LastError.
 *        
 *     GetLastError().
 * @date : 2012.03.28
 * @see www.mql5.com/ru/docs/opencl/clprogramfree
 */
void  CLProgramFree(
   int  program     //    OpenCL
   );
/**
 *   CLSetKernelArg
 *       OpenCL.
 * @param kernel
 *   [in]      OpenCL.
 * @param arg_index
 *   [in]    ,    .
 * @param arg_value
 *   [in]    .
 * @return 
 *    true   ,    false.
 *        
 *     GetLastError().
 * @note : 
 *         : ~
 *   ERR_INVALID_PARAMETER, ~ ERR_OPENCL_INVALID_HANDLE
 *        OpenCL, ~
 *   ERR_OPENCL_SET_KERNEL_PARAMETER -  
 *    OpenCL.
 * @date : 2012.03.28
 * @see www.mql5.com/ru/docs/opencl/clsetkernelarg
 */
bool  CLSetKernelArg(
   int   kernel,        //    OpenCL 
   uint  arg_index,     //  ?????? OpenCL 
   void  arg_value      //  
   );
/**
 *   CLSetKernelArgMem
 *     OpenCL     OpenCL.
 * @param kernel
 *   [in]      OpenCL.
 * @param arg_index
 *   [in]    ,    .
 * @param cl_mem_handle
 *   [in]     OpenCL.
 * @return 
 *    true   ,    false.
 *        
 *     GetLastError().
 * @date : 2012.03.28
 * @see www.mql5.com/ru/docs/opencl/clsetkernelargmem
 */
bool  CLSetKernelArgMem(
   int   kernel,           //    OpenCL ?CL ??????
   uint  arg_index,        //   OpenCL 
   int   cl_mem_handle     //   OpenCL
   );

/**
 *   FrameAdd
 *      .  2  . ~
 *   1.     ~ 2.   
 *      
 * @param name
 *   [in]    .       FrameFilter().
 * @param id
 *   [in]    .       FrameFilter().
 * @param value
 *   [in]       .
 *         
 *     OnTester().
 * @param filename
 *   [in]   ,        .
 *        MQL5/Files.
 * @param data
 *   [in]        .   .
 * @return 
 *    true   ,  false.
 *       ,  
 *     GetLastError().
 * @date : 2012.03.26
 * @see www.mql5.com/ru/docs/optimization_frames/frameadd
 */
bool  FrameAdd(
   const string  name,        //  /
   long          id,          //  id
   double        value,       // 
   const string  filename     //    
   );
/**
 *   FrameAdd
 *      .  2  . ~
 *   1.     ~ 2.   
 *      
 * @param name
 *   [in]    .       FrameFilter().
 * @param id
 *   [in]    .       FrameFilter().
 * @param value
 *   [in]       .
 *         
 *     OnTester().
 * @param filename
 *   [in]   ,        .
 *        MQL5/Files.
 * @param data
 *   [in]        .   .
 * @return 
 *    true   ,  false.
 *       ,  
 *     GetLastError().
 * @date : 2012.03.26
 * @see www.mql5.com/ru/docs/optimization_frames/frameadd
 */
bool  FrameAdd(
   const string  name,        //  /
   long          id,          //  id
   double        value,       // 
   const void&   data[]       //   
   );
/**
 *   FrameFilter
 *           .
 * @return 
 *    true   ,  false.
 *       ,  
 *     GetLastError().
 * @note : 
 *        ?  ?
 *   ? ?  ,     
 *      ,     
 *       id.    
 *      ULONG_MAX,    
 *    .  FrameFilter("", ULONG_MAX)  
 *    FrameFirst(),     .
 * @date : 2012.03.26
 * @see www.mql5.com/ru/docs/optimization_frames/framefilter
 */
bool  FrameFilter(
   const string  name,         //  /
   long          id            //  id
   );
/**
 *   FrameFirst
 *             . 
 * @return 
 *    true   ,  false.
 *       ,  
 *     GetLastError().
 * @date : 2012.03.21
 * @see www.mql5.com/ru/docs/optimization_frames/framefirst
 */
bool  FrameFirst();
/**
 *   FrameInputs
 *    input-,        .
 * @param pass
 *   [out]        .
 * @param parameters
 *   [out]         
 * @param parameters_count
 *   [out]      parameters[].
 * @return 
 *    true   ,  false.
 *       ,  
 *     GetLastError().
 * @note : 
 *      parameters_count   parameters[],
 *         .
 *          
 *      .
 * @date : 2012.03.26
 * @see www.mql5.com/ru/docs/optimization_frames/frameinputs
 */
bool  FrameInputs(
   ulong    pass,                //    
   string&  parameters[],        //    "parameterN=valueN"
   uint&    parameters_count     //   
   );
/**
 *   FrameNext
 *          .
 *    2  . ~ 1.    
 *      ~ 2.     
 *    
 * @param pass
 *   [out]        .
 * @param name
 *   [out]   .
 * @param id
 *   [out]   .
 * @param value
 *   [out]    .
 * @param data
 *   [out]    .
 * @return 
 *    true   ,  false.
 *       ,  
 *     GetLastError().
 * @note : 
 *        
 *         data[].
 * @date : 2012.03.21
 * @see www.mql5.com/ru/docs/optimization_frames/framenext
 */
bool  FrameNext(
   ulong&   pass,      //    ,    
   string&  name,      //  /
   long&    id,        //  id
   double&  value      // 
   );
/**
 *   FrameNext
 *          .
 *    2  . ~ 1.    
 *      ~ 2.     
 *    
 * @param pass
 *   [out]        .
 * @param name
 *   [out]   .
 * @param id
 *   [out]   .
 * @param value
 *   [out]    .
 * @param data
 *   [out]    .
 * @return 
 *    true   ,  false.
 *       ,  
 *     GetLastError().
 * @note : 
 *        
 *         data[].
 * @date : 2012.03.21
 * @see www.mql5.com/ru/docs/optimization_frames/framenext
 */
bool  FrameNext(
   ulong&   pass,      //    ,    
   string&  name,      //  /
   long&    id,        //  id
   double&  value,     // 
   void&    data[]     //   
   );
/**
 *   ParameterGetRange
 *     input-    
 *           
 *    .   2  . ~ 1. 
 *      input-   ~ 2. 
 *      input-  .
 * @param name
 *   [in]   input-.
 *        ,
 *           
 *      .
 * @param enable
 *   [out]   ,       
 *         . 
 * @param value
 *   [out]   .
 * @param start
 *   [out]      .
 * @param step
 *   [out]        .
 * @param stop
 *   [out]      .
 * @return 
 *    true    ,  false.
 *        
 *     GetLastError().
 * @note : 
 *         
 *    OnTesterInit(), OnTesterPass()  OnTesterDeinit().
 *         
 *         
 *     .    OnTesterInit() 
 *          
 *      input-
 *        ParameterSetRange().   
 *       Start, Stop, Step   
 *      
 *          .
 *         
 *        ,
 *         
 *          .
 * @date : 2013.04.03
 * @see www.mql5.com/ru/docs/optimization_frames/parametergetrange
 */
bool  ParameterGetRange(
   const string  name,          //   (input-)
   bool&         enable,        //   
   long&         value,         //  
   long&         start,         //  
   long&         step,          //  
   long&         stop           //  
   );
/**
 *   ParameterGetRange
 *     input-    
 *           
 *    .   2  . ~ 1. 
 *      input-   ~ 2. 
 *      input-  .
 * @param name
 *   [in]   input-.
 *        ,
 *           
 *      .
 * @param enable
 *   [out]   ,       
 *         . 
 * @param value
 *   [out]   .
 * @param start
 *   [out]      .
 * @param step
 *   [out]        .
 * @param stop
 *   [out]      .
 * @return 
 *    true    ,  false.
 *        
 *     GetLastError().
 * @note : 
 *         
 *    OnTesterInit(), OnTesterPass()  OnTesterDeinit().
 *         
 *         
 *     .    OnTesterInit() 
 *          
 *      input-
 *        ParameterSetRange().   
 *       Start, Stop, Step   
 *      
 *          .
 *         
 *        ,
 *         
 *          .
 * @date : 2013.04.03
 * @see www.mql5.com/ru/docs/optimization_frames/parametergetrange
 */
bool  ParameterGetRange(
   const string  name,          //   (input-)
   double&       enable,        //   
   double&       value,         //  
   double&       start,         //  
   double&       step,          //  
   double&       stop           //  
   );
/**
 *   ParameterSetRange
 *      input- 
 *        : ,
 *    ,    .   2
 *    . ~ 1.   
 *    input-   ~ 2.   
 *    input-  
 * @param name
 *   [in]    input  sinput.
 *        ,
 *        .
 * @param enable
 *   [in]             . 
 * @param value
 *   [in]   .
 * @param start
 *   [in]      .
 * @param step
 *   [in]        .
 * @param stop
 *   [in]      .
 * @return 
 *    true    ,  false.
 *        
 *     GetLastError().
 * @note : 
 *          OnTesterInit()
 *        . 
 *          ,
 *           
 *     ,     
 *    .   
 *       , 
 *     sinput.  ParameterSetRange()
 *     
 *         
 *         ,
 *          
 *     ,     
 *     .
 * @date : 2012.08.07
 * @see www.mql5.com/ru/docs/optimization_frames/parametersetrange
 */
bool  ParameterSetRange(
   const string  name,          //   (input-)
   bool          enable,        //   
   long          value,         //  
   long          start,         //  
   long          step,          //  
   long          stop           //  
   );
/**
 *   ParameterSetRange
 *      input- 
 *        : ,
 *    ,    .   2
 *    . ~ 1.   
 *    input-   ~ 2.   
 *    input-  
 * @param name
 *   [in]    input  sinput.
 *        ,
 *        .
 * @param enable
 *   [in]             . 
 * @param value
 *   [in]   .
 * @param start
 *   [in]      .
 * @param step
 *   [in]        .
 * @param stop
 *   [in]      .
 * @return 
 *    true    ,  false.
 *        
 *     GetLastError().
 * @note : 
 *          OnTesterInit()
 *        . 
 *          ,
 *           
 *     ,     
 *    .   
 *       , 
 *     sinput.  ParameterSetRange()
 *     
 *         
 *         ,
 *          
 *     ,     
 *     .
 * @date : 2012.08.07
 * @see www.mql5.com/ru/docs/optimization_frames/parametersetrange
 */
bool  ParameterSetRange(
   const string  name,          //   (input-)
   double        enable,        //   
   double        value,         //  
   double        start,         //  
   double        step,          //  
   double        stop           //  
   );

/**
 *   Bars
 *         
 *     .  2  . ~ 
 *         ~  
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   ??  ? ??????.
 * @return 
 *      start_time  stop_time,
 *          .
 *       ,   
 *      .
 * @note : 
 *            
 *   Bars()     ,  
 *          
 *      ,     .
 * @note  : 
 *     
 * @date : 2012.09.05
 * @see www.mql5.com/ru/docs/series/bars
 */
int  Bars(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe        // 
   );
/**
 *   Bars
 *         
 *     .  2  . ~ 
 *         ~  
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   ??  ? ??????.
 * @return 
 *      start_time  stop_time,
 *          .
 *       ,   
 *      .
 * @note : 
 *            
 *   Bars()     ,  
 *          
 *      ,     .
 * @note  : 
 *     
 * @date : 2012.09.05
 * @see www.mql5.com/ru/docs/series/bars
 */
int  Bars(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   datetime         start_time,      //   
   datetime         stop_time        //   
   );
/**
 *   BarsCalculated
 *         .
 * @param indicator_handle
 *   [in]   ,    .
 * @return 
 *         
 *    -1    (   ).
 * @note : 
 *       ,     
 *       (  ).
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/series/barscalculated
 */
int  BarsCalculated(
   int       indicator_handle,     //&nbsbsp;handle 
   );
/**
 *   CopyBuffer
 *      buffer    
 *      .   
 *    (    buffer_num)  
 *        ,   
 *    ,  0,     (
 *       ).   
 *      
 *       - buffer[]
 *       ,  
 *     CopyBuffer()   
 *          . 
 *        buffer[] 
 *      (,   
 *         SetIndexBufer()),
 *       .   
 *        Awesome_Oscillator.mq5
 *       .  
 *         
 *        (  ),    
 *        ,
 *       .     
 *    -   
 *           
 *     .      
 *     ,    
 *        ,  
 *       . ,  
 *        - as_series=true 
 *    as_series=false,     ,
 *             
 *    ,   .  3 
 *    .       
 *          
 *           
 *         
 * @param indicator_handle
 *   [in]   ,    .
 * @param buffer_num
 *   [in]    .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param buffer[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *       ,      
 *        ,   
 *     -1,      /
 *     .      
 *    ,     ,
 *         , 
 *       ,   
 *       ,     .
 *       ,   
 *       .   
 *       
 *         
 *       /.    
 *          
 *    .     ,  
 *      iFractals   1000
 *             
 *       .    
 *      ,    
 *          :
 * @note  : 
 *   , SetIndexBuffer
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/series/copybuffer
 */
int  CopyBuffer(
   int       indicator_handle,     // handle 
   int       buffer_num,           //   
   int       start_pos,            //  
   int       count,                //  
   double    buffer[]              // ,    
   );
/**
 *   CopyBuffer
 *      buffer    
 *      .   
 *    (    buffer_num)  
 *        ,   
 *    ,  0,     (
 *       ).   
 *      
 *       - buffer[]
 *       ,  
 *     CopyBuffer()   
 *          . 
 *        buffer[] 
 *      (,   
 *         SetIndexBufer()),
 *       .   
 *        Awesome_Oscillator.mq5
 *       .  
 *         
 *        (  ),    
 *        ,
 *       .     
 *    -   
 *           
 *     .      
 *     ,    
 *        ,  
 *       . ,  
 *        - as_series=true 
 *    as_series=false,     ,
 *             
 *    ,   .  3 
 *    .       
 *          
 *           
 *         
 * @param indicator_handle
 *   [in]   ,    .
 * @param buffer_num
 *   [in]    .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param buffer[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *       ,      
 *        ,   
 *     -1,      /
 *     .      
 *    ,     ,
 *         , 
 *       ,   
 *       ,     .
 *       ,   
 *       .   
 *       
 *         
 *       /.    
 *          
 *    .     ,  
 *      iFractals   1000
 *             
 *       .    
 *      ,    
 *          :
 * @note  : 
 *   , SetIndexBuffer
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/series/copybuffer
 */
int  CopyBuffer(
   int       indicator_handle,     // handle 
   int       buffer_num,           //   
   datetime  start_time,           //   
   int       count,                //  
   double    buffer[]<              // ,    
                      );
/**
 *   CopyBuffer
 *      buffer    
 *      .   
 *    (    buffer_num)  
 *        ,   
 *    ,  0,     (
 *       ).   
 *      
 *       - buffer[]
 *       ,  
 *     CopyBuffer()   
 *          . 
 *        buffer[] 
 *      (,   
 *         SetIndexBufer()),
 *       .   
 *        Awesome_Oscillator.mq5
 *       .  
 *         
 *        (  ),    
 *        ,
 *       .     
 *    -   
 *           
 *     .      
 *     ,    
 *        ,  
 *       . ,  
 *        - as_series=true 
 *    as_series=false,     ,
 *             
 *    ,   .  3 
 *    .       
 *          
 *           
 *         
 * @param indicator_handle
 *   [in]   ,    .
 * @param buffer_num
 *   [in]    .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param buffer[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *       ,      
 *        ,   
 *     -1,      /
 *     .      
 *    ,     ,
 *         , 
 *       ,   
 *       ,     .
 *       ,   
 *       .   
 *       
 *         
 *       /.    
 *          
 *    .     ,  
 *      iFractals   1000
 *             
 *       .    
 *      ,    
 *          :
 * @note  : 
 *   , SetIndexBuffer
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/series/copybuffer
 */
int  CopyBuffer(
   int       indicator_handle,     // handle 
   int       buffer_num,           //   
   datetime  start_time,           //   
   datetime  stop_time,            //   
   double    buffer[]              // ,    
   );
/**
 *   CopyClose
 *       close_array     
 *      -   .
 *    ,     
 *         ,
 *      ,  0,   .
 *        
 *       ?  
 *         ???  
 *       ,    
 *       ( ),   ,
 *       
 *      ,    
 *      .    
 *       ,    
 *        ,  
 *       . ,  
 *        - as_series=true 
 *    as_series=false,     ,
 *             
 *    ,   .  3 
 *    .       
 *          
 *           
 *         
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param close_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *     ? ?  
 *        ,
 *      -1.     
 *      TERMINAL_MAXBARS ( 
 *      ),    -1.  
 *      ,    
 *           ,
 *       -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *        ,  
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_  <span
 *    class="f_FunctionRemark" style="fo?_
 *     stop_time=_   0,   
 *         
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.  
 *           
 *     .     ,  
 *       iFractals   1000
 *              
 *        .    
 *       ,    
 *           
 *    : ~ DRAW_SECTION, ~ DRAW_ARROW, ~ DRAW_ZIGZAG, ~
 *    DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyclose
 */
int  CopyClose(
   string           symbol_name,       //  
   ENUM_TIMEFRAMES  timeframe,         // 
   int              start_pos,         //  
   int              count,             //  
   double           close_array[]      //     
   );
/**
 *   CopyClose
 *       close_array     
 *      -   .
 *    ,     
 *         ,
 *      ,  0,   .
 *        
 *       ?  
 *         ???  
 *       ,    
 *       ( ),   ,
 *       
 *      ,    
 *      .    
 *       ,    
 *        ,  
 *       . ,  
 *        - as_series=true 
 *    as_series=false,     ,
 *             
 *    ,   .  3 
 *    .       
 *          
 *           
 *         
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param close_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *     ? ?  
 *        ,
 *      -1.     
 *      TERMINAL_MAXBARS ( 
 *      ),    -1.  
 *      ,    
 *           ,
 *       -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *        ,  
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_  <span
 *    class="f_FunctionRemark" style="fo?_
 *     stop_time=_   0,   
 *         
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.  
 *           
 *     .     ,  
 *       iFractals   1000
 *              
 *        .    
 *       ,    
 *           
 *    : ~ DRAW_SECTION, ~ DRAW_ARROW, ~ DRAW_ZIGZAG, ~
 *    DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyclose
 */
int  CopyClose(
   string           symbol_name,       //  
   ENUM_TIMEFRAMES  timeframe,         // 
   datetime         start_time,        //   
   int              count,             //  
   double           close_array[]      //     
   );
/**
 *   CopyClose
 *       close_array     
 *      -   .
 *    ,     
 *         ,
 *      ,  0,   .
 *        
 *       ?  
 *         ???  
 *       ,    
 *       ( ),   ,
 *       
 *      ,    
 *      .    
 *       ,    
 *        ,  
 *       . ,  
 *        - as_series=true 
 *    as_series=false,     ,
 *             
 *    ,   .  3 
 *    .       
 *          
 *           
 *         
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param close_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *     ? ?  
 *        ,
 *      -1.     
 *      TERMINAL_MAXBARS ( 
 *      ),    -1.  
 *      ,    
 *           ,
 *       -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *        ,  
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_  <span
 *    class="f_FunctionRemark" style="fo?_
 *     stop_time=_   0,   
 *         
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.  
 *           
 *     .     ,  
 *       iFractals   1000
 *              
 *        .    
 *       ,    
 *           
 *    : ~ DRAW_SECTION, ~ DRAW_ARROW, ~ DRAW_ZIGZAG, ~
 *    DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyclose
 */
int  CopyClose(
   string           symbol_name,       // ? 
   ENUM_TIMEFRAMES  timeframe,         // 
   datetime         start_time,        //   
   datetime         stop_time,         //   
   double           close_array[]      //     
   );
/**
 *   CopyHigh
 *       high_array  
 *         -
 *     .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *    ?  ? ? 
 *         
 *     ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param high_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *     ?? ?? ???  
 *        ,
 *      -1.  ,   
 *      TERMINAL_MAXBARS ( 
 *      ),     -1.  
 *      ,    
 *           ,
 *        -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *          
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .  ,   
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time)  
 *       .  ,   
 *      ,      
 *         
 *     start_time=_
 *     start_time=_  stop_time=_
 *       0,      
 *         ,   
 *           .
 *       ,  
 *      ,    
 *         start_pos=0  count=1. 
 *          
 *         .  
 *       ,    
 *     iFractalsiFractals   1000   
 *           
 *     ?bsp;   
 *     ?? ???????  
 *      .     
 *      ,    
 *           
 *    : ~ DRAW_SECTION, ~ DRAW_ARROW, ~ DRAW_ZIGZAG, ~
 *    DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyhigh
 */
int  CopyHigh(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   int              start_pos,        //  
   int              count,            //  
   double           high_array[]      //     
   );
/**
 *   CopyHigh
 *       high_array  
 *         -
 *     .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *    ?  ? ? 
 *         
 *     ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param high_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *     ?? ?? ???  
 *        ,
 *      -1.  ,   
 *      TERMINAL_MAXBARS ( 
 *      ),     -1.  
 *      ,    
 *           ,
 *        -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *          
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .  ,   
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time)  
 *       .  ,   
 *      ,      
 *         
 *     start_time=_
 *     start_time=_  stop_time=_
 *       0,      
 *         ,   
 *           .
 *       ,  
 *      ,    
 *         start_pos=0  count=1. 
 *          
 *         .  
 *       ,    
 *     iFractalsiFractals   1000   
 *           
 *     ?bsp;   
 *     ?? ???????  
 *      .     
 *      ,    
 *           
 *    : ~ DRAW_SECTION, ~ DRAW_ARROW, ~ DRAW_ZIGZAG, ~
 *    DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyhigh
 */
int  CopyHigh(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   datetime         start_time,       //   
   int              count,            //  
   double           high_array[]      //     
   );
/**
 *   CopyHigh
 *       high_array  
 *         -
 *     .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *    ?  ? ? 
 *         
 *     ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param high_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *     ?? ?? ???  
 *        ,
 *      -1.  ,   
 *      TERMINAL_MAXBARS ( 
 *      ),     -1.  
 *      ,    
 *           ,
 *        -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *          
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .  ,   
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time)  
 *       .  ,   
 *      ,      
 *         
 *     start_time=_
 *     start_time=_  stop_time=_
 *       0,      
 *         ,   
 *           .
 *       ,  
 *      ,    
 *         start_pos=0  count=1. 
 *          
 *         .  
 *       ,    
 *     iFractalsiFractals   1000   
 *           
 *     ?bsp;   
 *     ?? ???????  
 *      .     
 *      ,    
 *           
 *    : ~ DRAW_SECTION, ~ DRAW_ARROW, ~ DRAW_ZIGZAG, ~
 *    DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyhigh
 */
int  CopyHigh(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   datetime         start_time,       //   
   datetime         stop_time,        //   
   double           high_array[]      //     
   );
/**
 *   CopyLow
 *       low_array 
 *          -
 *      .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *         
 *     ? ?  ? 
 *     ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param low_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *          
 *     ,   ?  
 *     ,   ?,
 *     ? ? -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *         ,    
 *     -1,      / 
 *     .      
 *     ,     ,
 *          , 
 *        ,   
 *        ,     .
 *        ,   
 *        ,    
 *     ,     
 *         .   
 *          
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_
 *     stop_time=_stop_time=_
 *       0,    ? 0,   
 *     ??  ? ? ??    
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.  
 *           
 *     .     ,  
 *       iFractals   1000
 *              
 *        .    
 *       ,    
 *           
 *    : ~ DRAW_SECTION, ~ DRAW_ARROW, ~ DRAW_ZIGZAG, ~
 *    DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @note  : 
 *   CopyHigh
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copylow
 */
int  CopyLow(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   int              start_pos,       //  
   int              count,           //  
   double           low_array[]      //     
   );
/**
 *   CopyLow
 *       low_array 
 *          -
 *      .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *         
 *     ? ?  ? 
 *     ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param low_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *          
 *     ,   ?  
 *     ,   ?,
 *     ? ? -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *         ,    
 *     -1,      / 
 *     .      
 *     ,     ,
 *          , 
 *        ,   
 *        ,     .
 *        ,   
 *        ,    
 *     ,     
 *         .   
 *          
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_
 *     stop_time=_stop_time=_
 *       0,    ? 0,   
 *     ??  ? ? ??    
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.  
 *           
 *     .     ,  
 *       iFractals   1000
 *              
 *        .    
 *       ,    
 *           
 *    : ~ DRAW_SECTION, ~ DRAW_ARROW, ~ DRAW_ZIGZAG, ~
 *    DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @note  : 
 *   CopyHigh
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copylow
 */
int  CopyLow(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   datetime         start_time,      //   
   int              count,           //  
   double           low_array[]      //     
   );
/**
 *   CopyLow
 *       low_array 
 *          -
 *      .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *         
 *     ? ?  ? 
 *     ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param low_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *          
 *     ,   ?  
 *     ,   ?,
 *     ? ? -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *         ,    
 *     -1,      / 
 *     .      
 *     ,     ,
 *          , 
 *        ,   
 *        ,     .
 *        ,   
 *        ,    
 *     ,     
 *         .   
 *          
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_
 *     stop_time=_stop_time=_
 *       0,    ? 0,   
 *     ??  ? ? ??    
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.  
 *           
 *     .     ,  
 *       iFractals   1000
 *              
 *        .    
 *       ,    
 *           
 *    : ~ DRAW_SECTION, ~ DRAW_ARROW, ~ DRAW_ZIGZAG, ~
 *    DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @note  : 
 *   CopyHigh
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copylow
 */
int  CopyLow(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   datetime         start_time,      //   
   datetime         stop_time,       //   
   double           low_array[]      //     
   );
/**
 *   CopyOpen
 *       open_array  
 *         -
 *     .  ,  
 *          
 *    ,    ,  0, 
 *     .
 *        
 *         
 *     ,     
 *    ( ),   ,
 *         
 *    ,      
 *    .      
 *     ,     
 *       ,    
 *     . ,    
 *      - as_series=true   as_series=false,
 *       ,   
 *            ,
 *     .  3   .
 *          
 *           
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param open_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *         
 *      ,    -1.
 *          <a
 *   href="../constants/envi -1.  
 *         <a
 *   href="../constants/envi?  TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,    
 *    -1,      / 
 *    .      
 *    ,     ,
 *         , 
 *       ,   
 *       ,     .
 *       ,   
 *       ,    
 *    ,     
 *        .   
 *         
 *       , 
 *      ()   .
 *          
 *     .      , 
 *       (, , 
 *     ,  Open, High, Low, Close  
 *     Time),     .
 *         
 *      ,   
 *    ,      
 *       .     
 *    ,     (, ,
 *      ,  Open, High, Low, Close
 *      Time),    
 *    .  ,    
 *    ,       
 *       start_time=_
 *    stop_time=_   0,   
 *        
 *      ,    0,  
 *         
 *      ,  
 *      , ?  ,
 *   ?, ?, ?      
 *      .    ,
 *      ,  
 *          start_pos=0
 *    count=1.     
 *        .  
 *      ,    
 *    iFractals   1000     
 *             .
 *         ,
 *         
 *        :
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyopen
 */
int  CopyOpen(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   int              start_pos,       //  
   int              count,           //  
   double           open_array[]     //     nbsp; ??
   );
/**
 *   CopyOpen
 *       open_array  
 *         -
 *     .  ,  
 *          
 *    ,    ,  0, 
 *     .
 *        
 *         
 *     ,     
 *    ( ),   ,
 *         
 *    ,      
 *    .      
 *     ,     
 *       ,    
 *     . ,    
 *      - as_series=true   as_series=false,
 *       ,   
 *            ,
 *     .  3   .
 *          
 *           
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param open_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *         
 *      ,    -1.
 *          <a
 *   href="../constants/envi -1.  
 *         <a
 *   href="../constants/envi?  TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,    
 *    -1,      / 
 *    .      
 *    ,     ,
 *         , 
 *       ,   
 *       ,     .
 *       ,   
 *       ,    
 *    ,     
 *        .   
 *         
 *       , 
 *      ()   .
 *          
 *     .      , 
 *       (, , 
 *     ,  Open, High, Low, Close  
 *     Time),     .
 *         
 *      ,   
 *    ,      
 *       .     
 *    ,     (, ,
 *      ,  Open, High, Low, Close
 *      Time),    
 *    .  ,    
 *    ,       
 *       start_time=_
 *    stop_time=_   0,   
 *        
 *      ,    0,  
 *         
 *      ,  
 *      , ?  ,
 *   ?, ?, ?      
 *      .    ,
 *      ,  
 *          start_pos=0
 *    count=1.     
 *        .  
 *      ,    
 *    iFractals   1000     
 *             .
 *         ,
 *         
 *        :
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyopen
 */
int  CopyOpen(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   datetime         start_time,      //   
   int              count,           //  
   double           open_array[]     //     
   );
/**
 *   CopyOpen
 *       open_array  
 *         -
 *     .  ,  
 *          
 *    ,    ,  0, 
 *     .
 *        
 *         
 *     ,     
 *    ( ),   ,
 *         
 *    ,      
 *    .      
 *     ,     
 *       ,    
 *     . ,    
 *      - as_series=true   as_series=false,
 *       ,   
 *            ,
 *     .  3   .
 *          
 *           
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param open_array[]
 *   [out]    double.
 * @return 
 *        -1   .
 * @note : 
 *         
 *      ,    -1.
 *          <a
 *   href="../constants/envi -1.  
 *         <a
 *   href="../constants/envi?  TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,    
 *    -1,      / 
 *    .      
 *    ,     ,
 *         , 
 *       ,   
 *       ,     .
 *       ,   
 *       ,    
 *    ,     
 *        .   
 *         
 *       , 
 *      ()   .
 *          
 *     .      , 
 *       (, , 
 *     ,  Open, High, Low, Close  
 *     Time),     .
 *         
 *      ,   
 *    ,      
 *       .     
 *    ,     (, ,
 *      ,  Open, High, Low, Close
 *      Time),    
 *    .  ,    
 *    ,       
 *       start_time=_
 *    stop_time=_   0,   
 *        
 *      ,    0,  
 *         
 *      ,  
 *      , ?  ,
 *   ?, ?, ?      
 *      .    ,
 *      ,  
 *          start_pos=0
 *    count=1.     
 *        .  
 *      ,    
 *    iFractals   1000     
 *             .
 *         ,
 *         
 *        :
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyopen
 */
int  CopyOpen(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   datetime         start_time,      //   
   datetime         stop_time,       //   
   double           open_array[]     //     
   );
/**
 *   CopyRates
 *      rates_array   
 *   MqlRates  -   .
 *          
 *    ,    ,  0, 
 *     .
 *         
 *         
 *   ,       ( ),
 *     ,    
 *      ,   
 *       .  
 *        ,  
 *         ,  
 *      . ,  
 *       - as_series=true 
 *    as_series=false,     ,
 *            
 *    ,   .  3 
 *    .      
 *         
 *          
 *        
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_time
 *   [in]   ,   .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param stop_time
 *   [in]   ,   .
 * @param rates_array[]
 *   [out]    MqlRates.
 * @return 
 *        -1   .
 * @note : 
 *          
 *     ,    -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,   
 *     -1,      /
 *     .      
 *    ,     ,
 *         , 
 *       ,   
 *       ,     .
 *       ,   
 *       ,    
 *    ,     
 *        .   
 *         
 *       , 
 *      ()   .
 *          
 *     .      , 
 *       (, , 
 *     ,  Open, High, Low, Close  
 *     Time),     .
 *         
 *      ,   
 *    ,      
 *       .     
 *    ,     (, ,
 *      ,  Open, High, Low, Close
 *      Time),    
 *    .  ,    
 *    ,    ??,  
 *     ?? ??????? 
 *        
 *    start_time=_  stop_time=_
 *      0,      
 *        ,   
 *          .
 *      ,  
 *     ,    
 *        start_pos=0  count=1. 
 *         
 *         
 *    .  .   ??
 *      ,    
 *    iFractals   1000     
 *             .
 *         ,
 *         
 *        :
 * @note  : 
 *     ,  TimeToString, StringFormat
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyrates
 */
int  CopyRates(
   string           symbol_name,       //  
   ENUM_TIMEFRAMES  timeframe,         // 
   int              start_pos,         //  
   int              count,             // &nbsp 
   MqlRates         rates_array[]      // ,    
   );
/**
 *   CopyRates
 *      rates_array   
 *   MqlRates  -   .
 *          
 *    ,    ,  0, 
 *     .
 *         
 *         
 *   ,       ( ),
 *     ,    
 *      ,   
 *       .  
 *        ,  
 *         ,  
 *      . ,  
 *       - as_series=true 
 *    as_series=false,     ,
 *            
 *    ,   .  3 
 *    .      
 *         
 *          
 *        
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_time
 *   [in]   ,   .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param stop_time
 *   [in]   ,   .
 * @param rates_array[]
 *   [out]    MqlRates.
 * @return 
 *        -1   .
 * @note : 
 *          
 *     ,    -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,   
 *     -1,      /
 *     .      
 *    ,     ,
 *         , 
 *       ,   
 *       ,     .
 *       ,   
 *       ,    
 *    ,     
 *        .   
 *         
 *       , 
 *      ()   .
 *          
 *     .      , 
 *       (, , 
 *     ,  Open, High, Low, Close  
 *     Time),     .
 *         
 *      ,   
 *    ,      
 *       .     
 *    ,     (, ,
 *      ,  Open, High, Low, Close
 *      Time),    
 *    .  ,    
 *    ,    ??,  
 *     ?? ??????? 
 *        
 *    start_time=_  stop_time=_
 *      0,      
 *        ,   
 *          .
 *      ,  
 *     ,    
 *        start_pos=0  count=1. 
 *         
 *         
 *    .  .   ??
 *      ,    
 *    iFractals   1000     
 *             .
 *         ,
 *         
 *        :
 * @note  : 
 *     ,  TimeToString, StringFormat
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyrates
 */
int  CopyRates(
   string           symbol_name,       //  
   ENUM_TIMEFRAMES  timeframe,         // 
   datetime         start_time,        //   
   int              count,             //  
   MqlRates         rates_array[]      // ,    
   );
/**
 *   CopyRates
 *      rates_array   
 *   MqlRates  -   .
 *          
 *    ,    ,  0, 
 *     .
 *         
 *         
 *   ,       ( ),
 *     ,    
 *      ,   
 *       .  
 *        ,  
 *         ,  
 *      . ,  
 *       - as_series=true 
 *    as_series=false,     ,
 *            
 *    ,   .  3 
 *    .      
 *         
 *          
 *        
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_time
 *   [in]   ,   .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param stop_time
 *   [in]   ,   .
 * @param rates_array[]
 *   [out]    MqlRates.
 * @return 
 *        -1   .
 * @note : 
 *          
 *     ,    -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,   
 *     -1,      /
 *     .      
 *    ,     ,
 *         , 
 *       ,   
 *       ,     .
 *       ,   
 *       ,    
 *    ,     
 *        .   
 *         
 *       , 
 *      ()   .
 *          
 *     .      , 
 *       (, , 
 *     ,  Open, High, Low, Close  
 *     Time),     .
 *         
 *      ,   
 *    ,      
 *       .     
 *    ,     (, ,
 *      ,  Open, High, Low, Close
 *      Time),    
 *    .  ,    
 *    ,    ??,  
 *     ?? ??????? 
 *        
 *    start_time=_  stop_time=_
 *      0,      
 *        ,   
 *          .
 *      ,  
 *     ,    
 *        start_pos=0  count=1. 
 *         
 *         
 *    .  .   ??
 *      ,    
 *    iFractals   1000     
 *             .
 *         ,
 *         
 *        :
 * @note  : 
 *     ,  TimeToString, StringFormat
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyrates
 */
int  CopyRates(
   string           symbol_name,       //  
   ENUM_TIMEFRAMES  timeframe,         // 
   datetime         start_time,        //   
   datetime         stop_time,         //   
   MqlRates         rates_array[]      // ,    
   );
/**
 *   CopyRealVolume
 *       volume_array  
 *        -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *       ,  
 *        ( ),  
 *    ,     
 *     ,    
 *      .    
 *      ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param volume_array[]
 *   [out]     long.
 * @return 
 *        -1   .
 * @note : 
 *        
 *       ,    -1.
 *         
 *    TERMINAL_MAXBARS ( 
 *      ),    -1.  
 *      ,    
 *           ,
 *       -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *        ,  
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *           
 *     ?   ? ?
 *      start_time=_
 *     stop_time=_   0,   
 *         
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.   
 *           
 *      .     ,
 *        iFractals  
 *     1000          
 *         .   
 *        ,   
 *            
 *     : ~ DRAW_SECTION, ~ DRAW_ARROW, ~
 *    DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyrealvolume
 */
int  CopyRealVolume(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   int              start_pos,        //  
   int              count,            // ????? 
   long             volume_array[]    //    
   );
/**
 *   CopyRealVolume
 *       volume_array  
 *        -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *       ,  
 *        ( ),  
 *    ,     
 *     ,    
 *      .    
 *      ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param volume_array[]
 *   [out]     long.
 * @return 
 *        -1   .
 * @note : 
 *        
 *       ,    -1.
 *         
 *    TERMINAL_MAXBARS ( 
 *      ),    -1.  
 *      ,    
 *           ,
 *       -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *        ,  
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *           
 *     ?   ? ?
 *      start_time=_
 *     stop_time=_   0,   
 *         
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.   
 *           
 *      .     ,
 *        iFractals  
 *     1000          
 *         .   
 *        ,   
 *            
 *     : ~ DRAW_SECTION, ~ DRAW_ARROW, ~
 *    DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyrealvolume
 */
int  CopyRealVolume(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   datetime         start_time,       //   
   int              count,            //  
   long             volume_array[]    //    
   );
/**
 *   CopyRealVolume
 *       volume_array  
 *        -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *       ,  
 *        ( ),  
 *    ,     
 *     ,    
 *      .    
 *      ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param volume_array[]
 *   [out]     long.
 * @return 
 *        -1   .
 * @note : 
 *        
 *       ,    -1.
 *         
 *    TERMINAL_MAXBARS ( 
 *      ),    -1.  
 *      ,    
 *           ,
 *       -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *        ,  
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *           
 *     ?   ? ?
 *      start_time=_
 *     stop_time=_   0,   
 *         
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.   
 *           
 *      .     ,
 *        iFractals  
 *     1000          
 *         .   
 *        ,   
 *            
 *     : ~ DRAW_SECTION, ~ DRAW_ARROW, ~
 *    DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyrealvolume
 */
int  CopyRealVolume(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   datetime         start_time,       //   
   datetime         stop_time,        //   
   long             volume_array[]    //    
   );
/**
 *   CopySpread
 *       spread_array  
 *       -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *     ?     
 *      ?  ?
 *     ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]   .
 * @param timeframe
 *   [in]  
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param spread_array[]
 *   [out]    int.
 * @return 
 *        -1   .
 * @note : 
 *           
 *   ?     ?  ?
 *    ? ???? ,    -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,    
 *     -1,      / 
 *     .      
 *     ,     ,
 *          , 
 *        ,   
 *        ,     .
 *        ,   
 *        ,    
 *     ,     
 *         .   
 *          
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_
 *     stop_time=_stop_time=_
 *     ????  0,      
 *         ,   
 *           .
 *       ,  
 *      ,    
 *         start_pos=0  count=1. 
 *          
 *         .  
 *       ,    
 *     iFractals   1000     
 *              .
 *          ,
 *              
 *         .   
 *        ,  ?
 *          ,
 *     ?  ,  ,  
 *     ??     
 *         : ~ DRAW_SECTION, ~
 *    DRAW_ARROW, ~ DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~
 *    DRAW_COLOR_ARROW, ~ DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyspread
 */
int  CopySpread(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   int              start_pos,        //  
   int              count,            //  
   int              spread_array[]    //    
   );
/**
 *   CopySpread
 *       spread_array  
 *       -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *     ?     
 *      ?  ?
 *     ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]   .
 * @param timeframe
 *   [in]  
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param spread_array[]
 *   [out]    int.
 * @return 
 *        -1   .
 * @note : 
 *           
 *   ?     ?  ?
 *    ? ???? ,    -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,    
 *     -1,      / 
 *     .      
 *     ,     ,
 *          , 
 *        ,   
 *        ,     .
 *        ,   
 *        ,    
 *     ,     
 *         .   
 *          
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_
 *     stop_time=_stop_time=_
 *     ????  0,      
 *         ,   
 *           .
 *       ,  
 *      ,    
 *         start_pos=0  count=1. 
 *          
 *         .  
 *       ,    
 *     iFractals   1000     
 *              .
 *          ,
 *              
 *         .   
 *        ,  ?
 *          ,
 *     ?  ,  ,  
 *     ??     
 *         : ~ DRAW_SECTION, ~
 *    DRAW_ARROW, ~ DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~
 *    DRAW_COLOR_ARROW, ~ DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyspread
 */
int  CopySpread(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   datetime         start_time,       //   
   int              count,            //  
   int              spread_array[]    //    
   );
/**
 *   CopySpread
 *       spread_array  
 *       -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *     ?     
 *      ?  ?
 *     ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]   .
 * @param timeframe
 *   [in]  
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param spread_array[]
 *   [out]    int.
 * @return 
 *        -1   .
 * @note : 
 *           
 *   ?     ?  ?
 *    ? ???? ,    -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,    
 *     -1,      / 
 *     .      
 *     ,     ,
 *          , 
 *        ,   
 *        ,     .
 *        ,   
 *        ,    
 *     ,     
 *         .   
 *          
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_
 *     stop_time=_stop_time=_
 *     ????  0,      
 *         ,   
 *           .
 *       ,  
 *      ,    
 *         start_pos=0  count=1. 
 *          
 *         .  
 *       ,    
 *     iFractals   1000     
 *              .
 *          ,
 *              
 *         .   
 *        ,  ?
 *          ,
 *     ?  ,  ,  
 *     ??     
 *         : ~ DRAW_SECTION, ~
 *    DRAW_ARROW, ~ DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~
 *    DRAW_COLOR_ARROW, ~ DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copyspread
 */
int  CopySpread(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   datetime         start_time,       //   
   datetime         stop_time,        //   
   int              spread_array[]    //    
   );
/**
 *   CopyTickVolume
 *       volume_array   
 *       -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *       ,  
 *        ( ),  
 *    ,     
 *     ,    
 *      .    
 *      ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param volume_array[]
 *   [out]    long.
 * @return 
 *        -1   .
 * @note : 
 *          
 *     ,    -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,    
 *    -1,      / 
 *     .      
 *     ,     ,
 *          , 
 *        ,   
 *        ,     .
 *        ,   
 *        ,    
 *     ,     
 *         .   
 *          
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *          <span
 *    class="f_FunctionRemark?    
 *     <span class="f_FunctionRemarkstart_time=_
 *      stop_time=_   0,  
 *          
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.   
 *           
 *      .     ,
 *        iFractals  
 *     1000          
 *         .   
 *        ,   
 *            
 *     : ~ DRAW_SECTION, ~ DRAW_ARROW, ~
 *    DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copytickvolume
 */
int  CopyTickVolume(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   int              start_pos,        //  
   int              count,            //  
   long             volume_array[]    //     
   );
/**
 *   CopyTickVolume
 *       volume_array   
 *       -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *       ,  
 *        ( ),  
 *    ,     
 *     ,    
 *      .    
 *      ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param volume_array[]
 *   [out]    long.
 * @return 
 *        -1   .
 * @note : 
 *          
 *     ,    -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,    
 *    -1,      / 
 *     .      
 *     ,     ,
 *          , 
 *        ,   
 *        ,     .
 *        ,   
 *        ,    
 *     ,     
 *         .   
 *          
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *          <span
 *    class="f_FunctionRemark?    
 *     <span class="f_FunctionRemarkstart_time=_
 *      stop_time=_   0,  
 *          
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.   
 *           
 *      .     ,
 *        iFractals  
 *     1000          
 *         .   
 *        ,   
 *            
 *     : ~ DRAW_SECTION, ~ DRAW_ARROW, ~
 *    DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copytickvolume
 */
int  CopyTickVolume(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   datetime         start_time,       //   
   int              count,            //  
   long             volume_array[]    //     
   );
/**
 *   CopyTickVolume
 *       volume_array   
 *       -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *         
 *       ,  
 *        ( ),  
 *    ,     
 *     ,    
 *      .    
 *      ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param volume_array[]
 *   [out]    long.
 * @return 
 *        -1   .
 * @note : 
 *          
 *     ,    -1.  
 *         TERMINAL_MAXBARS
 *   (    ),  
 *     -1.     ,
 *         
 *        ,    
 *    -1,      / 
 *     .      
 *     ,     ,
 *          , 
 *        ,   
 *        ,     .
 *        ,   
 *        ,    
 *     ,     
 *         .   
 *          
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time),  
 *       .  ,   
 *      ,     
 *          <span
 *    class="f_FunctionRemark?    
 *     <span class="f_FunctionRemarkstart_time=_
 *      stop_time=_   0,  
 *          
 *       ,     
 *        .   
 *     ,   
 *     ,      
 *      start_pos=0  count=1.   
 *           
 *      .     ,
 *        iFractals  
 *     1000          
 *         .   
 *        ,   
 *            
 *     : ~ DRAW_SECTION, ~ DRAW_ARROW, ~
 *    DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copytickvolume
 */
int  CopyTickVolume(
   string           symbol_name,      //  
   ENUM_TIMEFRAMES  timeframe,        // 
   datetime         start_time,       //   
   datetime         stop_time,        //   
   long             volume_array[]    //     
   );
/**
 *   CopyTime
 *       time_array   
 *        -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *          
 *      ?    
 *      ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param time_array[]
 *   [out]    datetime.
 * @return 
 *        -1   .
 * @note : 
 *          
 *       ? 
 *    ? ??  ,   
 *    -1.       
 *    TERMINAL_MAXBARS ( 
 *      ),    -1.  
 *      ,    
 *           ,
 *        -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *        ,  
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time)  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_
 *     stop_time=_stop_time=_
 *     ?  0,      
 *         ,   
 *           .
 *       ,  
 *      ,    
 *         start_pos=0  count=1. 
 *           
 *      .     ,
 *        iFractals  
 *     1000          
 *         .   
 *        ,   
 *            
 *     : ~ DRAW_SECTION, ~ DRAW_ARROW, ~
 *    DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copytime
 */
int  CopyTime(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   int              start_pos,       //  
   int              count,           //  
   datetime         time_array[]     //     
   );
/**
 *   CopyTime
 *       time_array   
 *        -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *          
 *      ?    
 *      ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param time_array[]
 *   [out]    datetime.
 * @return 
 *        -1   .
 * @note : 
 *          
 *       ? 
 *    ? ??  ,   
 *    -1.       
 *    TERMINAL_MAXBARS ( 
 *      ),    -1.  
 *      ,    
 *           ,
 *        -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *        ,  
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time)  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_
 *     stop_time=_stop_time=_
 *     ?  0,      
 *         ,   
 *           .
 *       ,  
 *      ,    
 *         start_pos=0  count=1. 
 *           
 *      .     ,
 *        iFractals  
 *     1000          
 *         .   
 *        ,   
 *            
 *     : ~ DRAW_SECTION, ~ DRAW_ARROW, ~
 *    DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copytime
 */
int  CopyTime(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   datetime         start_time,      //   
   int              count,           //  
   datetime         time_array[]     //     
   );
/**
 *   CopyTime
 *       time_array   
 *        -  
 *    .  ,  
 *          
 *    ,    ,  0, 
 *     .    
 *          
 *      ?    
 *      ,    
 *      ( ),   ,
 *        
 *    ,     
 *    .     
 *     ,    
 *       ,   
 *     . ,   
 *      - as_series=true  as_series=false,
 *       ,   
 *           ,
 *     .  3  . 
 *         
 *          
 *          
 *       
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param start_pos
 *   [in]     .
 * @param count
 *   [in]    .
 * @param start_time
 *   [in]   ,   .
 * @param stop_time
 *   [in]   ,   .
 * @param time_array[]
 *   [out]    datetime.
 * @return 
 *        -1   .
 * @note : 
 *          
 *       ? 
 *    ? ??  ,   
 *    -1.       
 *    TERMINAL_MAXBARS ( 
 *      ),    -1.  
 *      ,    
 *           ,
 *        -1,     
 *     /  .  
 *         ,  
 *       ,      
 *     ,     ,
 *          ,   
 *      .     ,
 *          ,
 *        ,  
 *         
 *       .      
 *       
 *        , 
 *       ()   .
 *           
 *      .      , 
 *        (, , 
 *      ,  Open, High, Low, Close  
 *      Time),     .
 *          
 *       ,   
 *     ,      
 *        .     
 *     ,     (, ,
 *       ,  Open, High, Low,
 *    Close    Time)  
 *       .  ,   
 *      ,     
 *         
 *     start_time=_
 *     stop_time=_stop_time=_
 *     ?  0,      
 *         ,   
 *           .
 *       ,  
 *      ,    
 *         start_pos=0  count=1. 
 *           
 *      .     ,
 *        iFractals  
 *     1000          
 *         .   
 *        ,   
 *            
 *     : ~ DRAW_SECTION, ~ DRAW_ARROW, ~
 *    DRAW_ZIGZAG, ~ DRAW_COLOR_SECTION, ~ DRAW_COLOR_ARROW, ~
 *    DRAW_COLOR_ZIGZAG.
 * @date : 2012.07.09
 * @see www.mql5.com/ru/docs/series/copytime
 */
int  CopyTime(
   string           symbol_name,     //  
   ENUM_TIMEFRAMES  timeframe,       // 
   datetime         start_time,      //   
   datetime         stop_time,       //   
   datetime         time_array[]     //     
   );
/**
 *   IndicatorCreate
 *       ,
 *         MqlParam.
 * @param symbol
 *   [in]    ,    
 *    . NULL   .
 * @param period
 *   [in]         
 *   ENUM_TIMEFRAMES, 0   .
 * @param indicator_type
 *   [in]   ,       ENUM_INDICATOR.
 * @param parameters_cnt
 *   [in]   , , ??
 *     parameters_array[].   
 *       MqlParam.   
 *     -   .   
 *     ,   parameters_array
 *    .     256
 *   .
 * @param parameters_array[]=NULL
 *   [in]    MqlParam,      
 *       .
 * @return 
 *       ,     INVALID_HANDLE.
 * @note : 
 *        IND_CUSTOM,   type  
 *      parameters_array
 *       TYPE_STRING  
 *    ENUM_DATATYPE,   string_value   
 *       .
 *        (
 *     EX5)  
 *      MQL5/Indicators   
 *     .   
 *        
 *     iCustom(),    
 *     .    (
 *     IndicatorCreate()IndicatorCreate() 
 *        ,
 *     ) ?,  
 *    )  ) ) ??
 *      #property tester_indicator: 
 *       
 *     ,     
 *          
 *       .   "Apply to"
 *     ,    
 *       PRICE_CLOSE.
 * @date : 2012.06.04
 * @see www.mql5.com/ru/docs/series/indicatorcreate
 */
int  IndicatorCreate(
   string           symbol,                            //  
   ENUM_TIMEFRAMES  period,                            // 
   ENUM_INDICATOR   indicator_type,                    //     ENUM_INDICATOR
   int              parameters_cnt = 0,                  //  
   const MqlParam&  parameters_array[] = NULL,           //  
   );
/**
 *   IndicatorParameters
 *          ,
 *         .
 * @param indicator_handle
 *   [in]   ,      ,    .
 * @param indicator_type
 *   [out]     ENUM_INDICATOR,      .
 * @param parameters[]
 *   [out]         MqlParam,  
 *       .  
 *       IndicatorParameters().
 * @return 
 *         ,
 *       -1.  
 *      ,  
 *     GetLastError().
 * @note  : 
 *   ChartIndicatorGet()
 * @date : 2012.06.15
 * @see www.mql5.com/ru/docs/series/indicatorparameters
 */
int  IndicatorParameters(
   int               indicator_handle,     //  
   ENUM_INDICATOR&   indicator_type,       //     
   MqlParam&         parameters[]          //    
   );
/**
 *   IndicatorRelease
 *          ,      .
 * @return 
 *    true   ,  false.
 * @note : 
 *       ,     ,
 *        .  
 *     ,    
 *        
 *    (     ).
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/series/indicatorrelease
 */
bool  IndicatorRelease(
   int       indicator_handle     // handle 
   );
/**
 *   SeriesInfoInteger
 *        .  2  .
 *      .
 *    true  false      . 
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param prop_id
 *   [in]    ,   ENUM_SERIES_INFO_INTEGER.
 * @param long_var
 *   [out]  ,      .
 * @return 
 *     long    . 
 *        true,   
 *         
 *    long_var,   false.  
 *       ,  
 *     GetLastError().
 * @date : 2012.09.05
 * @see www.mql5.com/ru/docs/series/seriesinfointeger
 */
long  SeriesInfoInteger(
   string                     symbol_name,     //  
   ENUM_TIMEFRAMES            timeframe,       // 
   ENUM_SERIES_INFO_INTEGER   prop_id,         //  
   );
/**
 *   SeriesInfoInteger
 *        .  2  .
 *      .
 *    true  false      . 
 * @param symbol_name
 *   [in]  .
 * @param timeframe
 *   [in]  .
 * @param prop_id
 *   [in]    ,   ENUM_SERIES_INFO_INTEGER.
 * @param long_var
 *   [out]  ,      .
 * @return 
 *     long    . 
 *        true,   
 *         
 *    long_var,   false.  
 *       ,  
 *     GetLastError().
 * @date : 2012.09.05
 * @see www.mql5.com/ru/docs/series/seriesinfointeger
 */
bool  SeriesInfoInteger(
   string                     symbol_name,     //  
   ENUM_TIMEFRAMES            timeframe,       // 
   ENUM_SERIES_INFO_INTEGER   prop_id,         //  
   long&                      long_var         //    
   );

/**
 *   StringAdd
 *          .
 * @param string_var
 *   [in][out]  ,   .
 * @param add_substring
 *   [in]  ,       .
 * @return 
 *        true,  false.
 *        
 *     GetLastError().
 * @note  : 
 *   StringConcatenate
 * @date : 2013.02.19
 * @see www.mql5.com/ru/docs/strings/stringadd
 */
bool  StringAdd(
   string&  string_var,        // ,&nbsp?,   
   string   add_substring      //  
   );
/**
 *   StringBufferLen
 *     ,   .
 * @param string_var
 *   [in]  .
 * @return 
 *    0 ,      
 *     . -1 ,   
 *          
 *       .
 * @note : 
 *       16.
 * @note  : 
 *   StringAdd, StringInit, StringLen, StringFill
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/strings/stringbufferlen
 */
int  StringBufferLen(
   string  string_var      // 
   );
/**
 *   StringCompare
 *               .
 * @param string1
 *   [in]   .
 * @param string2
 *   [in]   .
 * @param case_sensitive=true
 *   [in]     .    true,  "A">"a".
 *      false,  "A"="a".   
 *      true.
 * @return 
 *   ~ -1 ( ),  string1<string2 ~ 0 (),
 *    string1=string2 ~ 1 (),  string1>string2
 * @note : 
 *     ,   
 *         
 *    .
 * @note  : 
 *    string, CharToString(), ShortToString(), StringToCharArray(),
 *   StringToShortArray(), StringGetCharacter(), 
 *     
 * @date : 2010.12.23
 * @see www.mql5.com/ru/docs/strings/stringcompare
 */
int  StringCompare(
   const string&  string1,                 //  ?????? 
   const string&  string2,                 //   
   bool           case_sensitive = true      //      
   );
/**
 *   StringConcatenate
 *          
 *    .     .
 *         2   
 *     64.
 * @param string_var
 *   [out]  ,      .
 * @param argumentN
 *   [in]   ,  .  2  63    .
 * @return 
 *     ,        string .        ,     Print()  Comment().
 * @note  : 
 *   StringAdd
 * @date : 2013.04.12
 * @see www.mql5.com/ru/docs/strings/stringconcatenate
 */
int  StringConcatenate(
   string& string_var,     //   
   void argument1,         //     
   void argument2,         //     
   ...                     //     
   );
/**
 *   StringFill
 *         .
 * @param string_var
 *   [in][out]  ,     .
 * @param character
 *   [in]  ,    .
 * @return 
 *        true,  false.
 *        
 *     GetLastError().
 * @note : 
 *       ,   
 *         
 *       .    
 *         .
 * @note  : 
 *   StringBufferLen, StringLen, StringInit
 * @date : 2010.11.19
 * @see www.mql5.com/ru/docs/strings/stringfill
 */
bool  StringFill(
   string&   string_var,       //   </?</?</?
   ushort    character         // ,    
   );
/**
 *   StringFind
 *      .
 * @param string_value
 *   [in]  ,    .
 * @param match_substring
 *   [in]   .
 * @param start_pos=0
 *   [in]    ,      .
 * @return 
 *       ,    
 *   ,  -1,    .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/strings/stringfind
 */
int  StringFind(
   string  string_value,        // ,   
   string  match_substring,     //  
   int     start_pos = 0          //     
   );
/**
 *   StringGetCharacter
 *     ,     .
 * @param string_value
 *   [in]  .
 * @param pos
 *   [in]     .    0  StringLen(text) -1.
 * @return 
 *       0   - .
 *        
 *     GetLastError().
 * @date : 2010.02.01
 * @see www.mql5.com/ru/docs/strings/stringgetcharacter
 */
ushort  StringGetCharacter(
   string  string_value,     // 
   int     pos               //    
   );
/**
 *   StringInit
 *            .
 * @param string_var
 *   [in][out]  ,      .
 * @param new_len=0
 *   [in]     .  =0,
 *     ,  ,  
 *        .
 * @param character=0
 *   [in]     .
 * @return 
 *        true,  false.
 *        
 *     GetLastError().
 * @note : 
 *     character=0   new_len>0,    
 *        .  
 *      ,     
 *     .
 * @note  : 
 *   StringBufferLen, StringLen
 * @date : 2010.11.19
 * @see www.mql5.com/ru/docs/strings/stringinit
 */
bool  StringInit(
   string&   string_var,       //   
   int       new_len = 0,        //     
   ushort    character = 0       // ,    
   );
/**
 *   StringLen
 *       .
 * @param string_value
 *   [in]     .
 * @return 
 *          .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/strings/stringlen
 */
int  StringLen(
   string  string_value      // 
   );
/**
 *   StringReplace
 *             .
 * @param str
 *   [in][out]  ,     .
 * @param find
 *   [in]     .
 * @param replacement
 *   [in]  ,     .
 * @return 
 *        ,    -1.
 *        
 *     GetLastError().
 * @note : 
 *      ,    
 *   (   ),   0.
 *         str  find
 *   (   , . StringInit() ).
 *    ,  ,    
 *      .
 * @note  : 
 *   StringSetCharacter(), StringSubstr()
 * @date : 2010.11.29
 * @see www.mql5.com/ru/docs/strings/stringreplace
 */
int  StringReplace(
   string&         str,              // ,     
   const string    find,             //  
   const string    replacement       // ,      
   );
/**
 *   StringSetCharacter
 *            .
 * @param string_var
 *   [in][out]  .
 * @param pos
 *   [in]     .    0  StringLen(text).
 * @param character
 *   [in]    Unicode.
 * @note : 
 *     pos        = 0,
 *      (  ,  
 *      ).  
 *       pos.  
 *     pos    ,
 *         ,  
 *         .
 * @note  : 
 *   StringBufferLen, StringLen, StringFill, StringInit
 * @date : 2010.08.05
 * @see www.mql5.com/ru/docs/strings/stringsetcharacter
 */
bool  StringSetCharacter(
   string&   string_var,       // 
   int       pos,              // 
   ushort    character         // 
   );
/**
 *   StringSplit
 *          
 *       .
 * @param string_value
 *   [in]  ,     .      .
 * @param pos
 *   [in]    .       StringGetCharacter().
 * @param result[]
 *   [out]   ,     .
 * @return 
 *        result[].  
 *       ,     
 *       .   string_value
 *     NULL,    .   
 *      -1.      
 *     GetLastError().
 * @note  : 
 *   StringReplace(), StringSubstr(), StringConcatenate()
 * @date : 2011.09.12
 * @see www.mql5.com/ru/docs/strings/stringsplit
 */
int  StringSplit(
   const string   string_value,       //    
   const ushort   separator,          // ,       
   string& result[]          // ,   ,    
   );
/**
 *   StringSubstr
 *       ,  c  .
 * @param string_value
 *   [in]  ,      .
 * @param start_pos
 *   [in]    .    0  StringLen(text) -1.
 * @param length=-1
 *   [in]    .     -1 
 *     ,    , 
 *          .
 * @return 
 *     ,  ,    .
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/strings/stringsubstr
 */
string  StringSubstr(
   string  string_value,     // 
   int     start_pos,        //    
   int     length = -1         //   
   );
/**
 *   StringToLower
 *          ()  .
 * @param string_var
 *   [in][out]  .
 * @return 
 *        true,  false.
 *        
 *     GetLastError().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/strings/stringtolower
 */
bool  StringToLower(
   string&  string_var      //   
   );
/**
 *   StringToUpper
 *          ()  .
 * @param string_var
 *   [in][out]  .
 * @return 
 *        true,  false.
 *        
 *     GetLastError().
 * @date : 2009.11.20
 * @see www.mql5.com/ru/docs/strings/stringtoupper
 */
bool  StringToUpper(
   string&  string_var      // ?  
   );
/**
 *   StringTrimLeft
 *      ,    
 *         . 
 *      .
 * @param string_var
 *   [in][out]  ,     .
 * @return 
 *      .
 * @date : 2010.04.01
 * @see www.mql5.com/ru/docs/strings/stringtrimleft
 */
int  StringTrimLeft(
   string&  string_varr      //   
   );
/**
 *   StringTrimRight
 *      ,   
 *          .
 *      .
 * @param string_var
 *   [in][out]  ,     .
 * @return 
 *      .
 * @date : 2010.04.01
 * @see www.mql5.com/ru/docs/strings/stringtrimright
 */
int  StringTrimRight(
   string&  string_var      //   
   );
/**
 *   HistoryDealGetDouble
 *      .  
 *       double.  2  .
 *   ~ 1.    . ~ 2.
 *    true  false
 *        .   
 *         
 *    ,     .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_DEAL_PROPERTY_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.
 * @note : 
 *        ,   .
 *        
 *    ,      
 *      .
 * @note  : 
 *   HistoryDealsTotal(), HistorySelect(), HistoryDealGetTicket(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/historydealgetdouble
 */
double  HistoryDealGetDouble(
   ulong                      ticket_number,     // 
   ENUM_DEAL_PROPERTY_DOUBLE  property_id        //  
   );
/**
 *   HistoryDealGetDouble
 *      .  
 *       double.  2  .
 *   ~ 1.    . ~ 2.
 *    true  false
 *        .   
 *         
 *    ,     .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_DEAL_PROPERTY_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.
 * @note : 
 *        ,   .
 *        
 *    ,      
 *      .
 * @note  : 
 *   HistoryDealsTotal(), HistorySelect(), HistoryDealGetTicket(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/historydealgetdouble
 */
bool  HistoryDealGetDouble(
   ulong                      ticket_number,     // 
   ENUM_DEAL_PROPERTY_DOUBLE  property_id,       //  
   double&                    double_var         //    
   );
/**
 *   HistoryDealGetInteger
 *      .  
 *       datetime, int.  2 
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .   
 *       ENUM_DEAL_PROPERTY_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *      long.
 * @note : 
 *        ,   .
 *        
 *    ,      
 *      .
 * @note  : 
 *   HistoryDealsTotal(), HistorySelect(), HistoryDealGetTicket(),  
 * @date : 2013.03.14
 * @see www.mql5.com/ru/docs/trading/historydealgetinteger
 */
long  HistoryDealGetInteger(
   ulong                       ticket_number,     // 
   ENUM_DEAL_PROPERTY_INTEGER  property_id        //  
   );
/**
 *   HistoryDealGetInteger
 *      .  
 *       datetime, int.  2 
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .   
 *       ENUM_DEAL_PROPERTY_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *      long.
 * @note : 
 *        ,   .
 *        
 *    ,      
 *      .
 * @note  : 
 *   HistoryDealsTotal(), HistorySelect(), HistoryDealGetTicket(),  
 * @date : 2013.03.14
 * @see www.mql5.com/ru/docs/trading/historydealgetinteger
 */
bool  HistoryDealGetInteger(
   ulong                       ticket_number,     // 
   ENUM_DEAL_PROPERTY_INTEGER  property_id,       //  
   long&                       long_var           //    
   );
/**
 *   HistoryDealGetString
 *      .  
 *       string.  2  .
 *   ~ 1.    . ~ 2.
 *    true  false
 *        .   
 *         
 *    ,     .
 * @param ticket_number
 *   [in]  T .
 * @param property_id
 *   [in]    .    
 *      ENUM_DEAL_PROPERTY_STRING.
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string.
 * @note : 
 *        ,   .   
 *      , 
 *          
 *    .
 * @note  : 
 *   HistoryDealsTotal(), HistorySelect(), HistoryDealGetTicket(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/historydealgetstring
 */
string  HistoryDealGetString(
   ulong                      ticket_number,     // 
   ENUM_DEAL_PROPERTY_STRING  property_id        //  
   );
/**
 *   HistoryDealGetString
 *      .  
 *       string.  2  .
 *   ~ 1.    . ~ 2.
 *    true  false
 *        .   
 *         
 *    ,     .
 * @param ticket_number
 *   [in]  T .
 * @param property_id
 *   [in]    .    
 *      ENUM_DEAL_PROPERTY_STRING.
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string.
 * @note : 
 *        ,   .   
 *      , 
 *          
 *    .
 * @note  : 
 *   HistoryDealsTotal(), HistorySelect(), HistoryDealGetTicket(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/historydealgetstring
 */
bool  HistoryDealGetString(
   ulong                      ticket_number,     // 
   ENUM_DEAL_PROPERTY_STRING  property_id,       //  
   string&                    string_var         //    
   );
/**
 *   HistoryDealGetTicket
 *             .
 *      HistoryDealGetTicket() 
 *        
 *      HistorySelect() 
 *    HistorySelectByPosition().
 * @param index
 *   [in]      .
 * @return 
 *     ulong.      0.
 * @note : 
 *        ,   .
 *        
 *    ,      
 *      .
 * @note  : 
 *   HistorySelect(), HistoryDealsTotal(), HistoryDealSelect(),  
 * @date : 2013.04.17
 * @see www.mql5.com/ru/docs/trading/historydealgetticket
 */
ulong  HistoryDealGetTicket(
   int  index      //  
   );
/**
 *   HistoryDealSelect
 *           
 *     .  true  
 *     .  false  
 *     .     
 *   ,    GetLastError().
 * @param ticket
 *   [in]   
 * @return 
 *    true   ,  false.
 * @note : 
 *        ,   .
 *        
 *    ,      
 *      .  HistoryDealSelect() 
 *     mql5-  ,   ,
 *         ,  
 *    HistoryDealSelect()  .  
 *      ,  
 *    HistorySelect(),   
 *     HistoryDealGetTicket().
 * @note  : 
 *   HistorySelect(), HistoryDealGetTicket(),  
 * @date : 2010.12.22
 * @see www.mql5.com/ru/docs/trading/historydealselect
 */
bool  HistoryDealSelect(
   ulong  ticket     //  
   );
/**
 *   HistoryDealsTotal
 *       .
 *      HistoryDealsTotal()  
 *       
 *      HistorySelect() 
 *    HistorySelectByPosition().
 * @return 
 *      int.
 * @note : 
 *        ,   .
 *        
 *    ,      
 *      .
 * @note  : 
 *   HistorySelect(), HistoryDealGetTicket(),  
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/historydealstotal
 */
int  HistoryDealsTotal();
/**
 *   HistoryOrderGetDouble
 *      .  
 *       double.  2  .
 *   ~ 1.    . ~ 2.
 *    true  false
 *        .
 *         
 *         ,   
 *       .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .     
 *     ENUM_ORDER_PROPERTY_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.
 * @note : 
 *             
 *    ,     "
 *   "   "".  ,
 *          
 *    ,      ""  
 *    ""  .
 * @note  : 
 *   HistorySelect(), HistoryOrdersTotal(), HistoryOrderSelect(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/historyordergetdouble
 */
double  HistoryOrderGetDouble(
   ulong                       ticket_number,     // 
   ENUM_ORDER_PROPERTY_DOUBLE  property_id        //  
   );
/**
 *   HistoryOrderGetDouble
 *      .  
 *       double.  2  .
 *   ~ 1.    . ~ 2.
 *    true  false
 *        .
 *         
 *         ,   
 *       .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .     
 *     ENUM_ORDER_PROPERTY_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.
 * @note : 
 *             
 *    ,     "
 *   "   "".  ,
 *          
 *    ,      ""  
 *    ""  .
 * @note  : 
 *   HistorySelect(), HistoryOrdersTotal(), HistoryOrderSelect(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/historyordergetdouble
 */
bool    HistoryOrderGetDouble(
   ulong                       ticket_number,     // 
   ENUM_ORDER_PROPERTY_DOUBLE  property_id,       //  
   double&                     double_var         //    
   );
/**
 *   HistoryOrderGetInteger
 *      .  
 *       datetime, int.  2 
 *    . ~ 1.    
 *   . ~ 2.  true  false
 *        .
 *          
 *     ,    
 *    .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .      
 *    ENUM_ORDER_PROPERTY_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *      long.
 * @note : 
 *           
 *      ,
 *       ""  
 *    "".  ,    
 *        ,  
 *       ""   "" 
 *    .
 * @note  : 
 *   HistorySelect(), HistoryOrdersTotal(), HistoryOrderSelect(),  
 * @date : 2013.03.14
 * @see www.mql5.com/ru/docs/trading/historyordergetinteger
 */
long  HistoryOrderGetInteger(
   ulong                        ticket_number,     // 
   ENUM_ORDER_PROPERTY_INTEGER  property_id        //  
   );
/**
 *   HistoryOrderGetInteger
 *      .  
 *       datetime, int.  2 
 *    . ~ 1.    
 *   . ~ 2.  true  false
 *        .
 *          
 *     ,    
 *    .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .      
 *    ENUM_ORDER_PROPERTY_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *      long.
 * @note : 
 *           
 *      ,
 *       ""  
 *    "".  ,    
 *        ,  
 *       ""   "" 
 *    .
 * @note  : 
 *   HistorySelect(), HistoryOrdersTotal(), HistoryOrderSelect(),  
 * @date : 2013.03.14
 * @see www.mql5.com/ru/docs/trading/historyordergetinteger
 */
bool  HistoryOrderGetInteger(
   ulong                        ticket_number,     // 
   ENUM_ORDER_PROPERTY_INTEGER  property_id,       //  
   long&                        long_var           //    
   );
/**
 *   HistoryOrderGetString
 *      .  
 *       string.  2  .
 *   ~ 1.    . ~ 2.
 *    true  false
 *        .   
 *         
 *    ,     .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .   
 *       ENUM_ORDER_PROPERTY_STRING.
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string.
 * @note : 
 *           
 *      ,
 *       ""  
 *    "".  ,    
 *        ,  
 *       ""   "" 
 *    .
 * @note  : 
 *   HistorySelect(), HistoryOrdersTotal(), HistoryOrderSelect(),  
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/trading/historyordergetstring
 */
string  HistoryOrderGetString(
   ulong                       ticket_number,     // 
   ENUM_ORDER_PROPERTY_STRING  property_id        //  
   );
/**
 *   HistoryOrderGetString
 *      .  
 *       string.  2  .
 *   ~ 1.    . ~ 2.
 *    true  false
 *        .   
 *         
 *    ,     .
 * @param ticket_number
 *   [in]   .
 * @param property_id
 *   [in]    .   
 *       ENUM_ORDER_PROPERTY_STRING.
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string.
 * @note : 
 *           
 *      ,
 *       ""  
 *    "".  ,    
 *        ,  
 *       ""   "" 
 *    .
 * @note  : 
 *   HistorySelect(), HistoryOrdersTotal(), HistoryOrderSelect(),  
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/trading/historyordergetstring
 */
bool  HistoryOrderGetString(<
                                ulong                       ticket_number,     // 
                                ENUM_ORDER_PROPERTY_STRING  property_id,       //  
                                string&                     string_var         //    
                            );
/**
 *   HistoryOrderGetTicket
 *        .
 *      HistoryOrderGetTicket() 
 *        
 *      HistorySelect() 
 *    HistorySelectByPosition().
 * @param index
 *   [in]      .
 * @return 
 *     ulong.      0.
 * @note : 
 *           
 *      ,
 *       "&qu ,
 *       "&qu  
 *    "&qu&qu&ququot;   "".
 *    ,     
 *      ,     
 *    ""   ""  .
 * @note  : 
 *   HistorySelect(), HistoryOrdersTotal(), HistoryOrderSelect(),  
 * @date : 2013.04.17
 * @see www.mql5.com/ru/docs/trading/historyordergetticket
 */
ulong  HistoryOrderGetTicket(
   int  index      //    
   );
/**
 *   HistoryOrderSelect
 *            
 *    .  true  
 *     .  false  
 *     .     
 *   ,    GetLastError().
 * @param ticket
 *   [in]   
 * @return 
 *    true   ,  false.
 * @note : 
 *           
 *      ,
 *       ""  
 *    "".  ,
 *   ???       
 *    ,      ""  
 *    ""  .
 *    HistoryOrderSelect()   mql5-
 *       ,   ,
 *         ,  
 *    HistoryOrderSelect()  .  
 *      ,  
 *    HistorySelect(),   
 *     HistoryOrderGetTicket().
 * @note  : 
 *   HistorySelect(), HistoryOrderGetTicket(),  
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/historyorderselect
 */
bool  HistoryOrderSelect(
   ulong  ticket      //  
   );
/**
 *   HistoryOrdersTotal
 *       .   
 *   HistoryOrdersTotal()    
 *        HistorySelect() 
 *    HistorySelectByPosition().
 * @return 
 *      int.
 * @note : 
 *           
 *      ,
 *       ""  
 *    "".  ,    
 *        ,  
 *       ""   "" 
 *    .
 * @note  : 
 *   HistorySelect(), HistoryOrderSelect(), HistoryOrderGetTicket(),  
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/historyorderstotal
 */
int  HistoryOrdersTotal();
/**
 *   HistorySelect
 *            .
 * @param from_date
 *   [in]    .
 * @param to_date
 *   [in]    .
 * @return 
 *    true   ,  false.
 * @note : 
 *    HistorySelect()   mql5-
 *          
 *         .
 *       
 *       HistoryDealsTotal(), 
 *         
 *     HistoryDealsTotal(),   
 *        HistoryOrdersTotal(). 
 *          
 *    HistoryOrderGetTicket(),    
 *       HistoryDealGetTicket().
 *      HistoryOrderSelect()
 *      ,  mql5-,
 *        ,
 *         .   
 *       ,  mql5-
 *       HistoryDealSelect()
 *          
 *      .
 * @note  : 
 *   HistoryOrderSelect(), HistoryDealSelect()
 * @date : 2011.10.08
 * @see www.mql5.com/ru/docs/trading/historyselect
 */
bool  HistorySelect(
   datetime  from_date,     //  
   datetime  to_date        //  
   );
/**
 *   HistorySelectByPosition
 *       ,    .
 * @param position_id
 *   [in]   ,          .
 * @return 
 *    true   ,  false.
 * @note : 
 *           
 *      ,
 *       ""  
 *    "".  ,
 *          
 *    ?    ? 
 *    ? ?????,     
 *    ""   ""  .
 *    HistorySelectByPosition()   mql5-
 *          
 *        
 *         .
 *       
 *       HistoryDealsTotal(), 
 *         
 *     HistoryOrdersTotal(). 
 *          
 *    HistoryOrderGetTicket(),    
 *       HistoryDealGetTicket().
 *      HistoryOrderSelect()
 *      ,  mql5-,
 *        ,
 *         .   
 *       ,  mql5-
 *       HistoryDealSelect()
 *          
 *      .
 * @note  : 
 *   HistorySelect(), HistoryOrderGetTicket(),  
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/historyselectbyposition
 */
bool  HistorySelectByPosition(
   long   position_id     //   - POSITION_IDENTIFIER
   );
/**
 *   OrderCalcMargin
 *     ,     
 *            
 *         .
 *         
 *    .     .
 *
 * @param action
 *   [in]   ,      ENUM_ORDER_TYPE. 
 * @param symbol
 *   [in]    .
 * @param volume
 *   [in]    .
 * @param price
 *   [in]   .
 * @param margin
 *   [out]  ,       
 *       . 
 *          
 *          . 
 *            
 *      .
 * @return 
 *    true   ,  false.
 *       ,  
 *     GetLastError().
 * @note  : 
 *   OrderSend(),  ,   
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/ordercalcmargin
 */
bool  OrderCalcMargin(
   ENUM_ORDER_TYPE       action,           //  
   string                symbol,           //  
   double                volume,           // 
   double                price,            //  
   double&               margin            //     
   );
/**
 *   OrderCalcProfit
 *          
 *       . 
 *         
 *   .     .
 * @param action
 *   [in]   ,      
 *    ENUM_ORDER_TYPE: ORDER_TYPE_BUY 
 *    ORDER_TYPE_SELL.
 * @param symbol
 *   [in]    .
 * @param volume
 *   [in]    .
 * @param price_open
 *   [in]   .
 * @param price_close
 *   [in]   .
 * @param profit
 *   [out]  ,       
 *       .  
 *            
 *      .
 * @return 
 *    true   ,  false.
 *       ,   false.
 *       ,  
 *     GetLastError().
 * @note  : 
 *   OrderSend(),  ,   
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/ordercalcprofit
 */
bool  OrderCalcProfit(
   ENUM_ORDER_TYPE       action,           //   (ORDER_TYPE_BUY  ORDER_TYPE_SELL)
   string                symbol,           //  
   double                volume,           // 
   double                price_open,       //  
   double                price_close,      //  
   double&               profit           //     
   );
/**
 *   OrderCheck
 *    OrderCheck()     
 *     .   
 *       MqlTradeCheckResult.
 * @param request
 *   [in]      MqlTradeRequest,     .
 * @param result
 *   [in,out]    ?  ?    MqlTradeCheckResult,
 *        .
 * @return 
 *          
 *     false.    
 *      ( )
 *    true      ,
 *       
 *     .    
 *         
 *     result.     ,
 *      GetLastError().
 * @note  : 
 *   OrderSend(),   ,   ,
 *       , 
 *      
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/ordercheck
 */
bool  OrderCheck(
   MqlTradeRequest&       request,      //  
   MqlTradeCheckResult&   result        //  
   );
/**
 *   OrderGetDouble
 *      ,
 *        OrderGetTicket
 *    OrderSelect.      double.
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false       .
 *           
 *    ,     .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_ORDER_PROPERTY_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.      0.
 * @note : 
 *            ,
 *        ""  
 *    ""  .   
 *            
 *    ,          
 *        .  
 *          
 *     OrderSelect()   
 *     .
 * @note  : 
 *   OrdersTotal(), OrderGetTicket(),  
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/trading/ordergetdouble
 */
double  OrderGetDouble(
   ENUM_ORDER_PROPERTY_DOUBLE  property_id        //  
   );
/**
 *   OrderGetDouble
 *      ,
 *        OrderGetTicket
 *    OrderSelect.      double.
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false       .
 *           
 *    ,     .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_ORDER_PROPERTY_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.      0.
 * @note : 
 *            ,
 *        ""  
 *    ""  .   
 *            
 *    ,          
 *        .  
 *          
 *     OrderSelect()   
 *     .
 * @note  : 
 *   OrdersTotal(), OrderGetTicket(),  
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/trading/ordergetdouble
 */
bool  OrderGetDouble(
   ENUM_ORDER_PROPERTY_DOUBLE  property_id,      //  
   double&                     double_var        //    
   );
/**
 *   OrderGetInteger
 *      ,
 *        OrderGetTicket
 *    OrderSelect.      datetime,
 *   int.  2  . ~ 1. 
 *      . ~ 2.  true 
 *    false       .
 *           
 *    ,     .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_ORDER_PROPERTY_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *      long.      0.
 * @note : 
 *            ,
 *        ""  
 *    ""  .   
 *            
 *    ,          
 *        .  
 *          
 *     OrderSelect()   
 *     .
 * @note  : 
 *   OrdersTotal(), OrderGetTicket(),  
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/trading/ordergetinteger
 */
long  OrderGetInteger(
   ENUM_ORDER_PROPERTY_INTEGER  property_id        //  
   );
/**
 *   OrderGetInteger
 *      ,
 *        OrderGetTicket
 *    OrderSelect.      datetime,
 *   int.  2  . ~ 1. 
 *      . ~ 2.  true 
 *    false       .
 *           
 *    ,     .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_ORDER_PROPERTY_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *      long.      0.
 * @note : 
 *            ,
 *        ""  
 *    ""  .   
 *            
 *    ,          
 *        .  
 *          
 *     OrderSelect()   
 *     .
 * @note  : 
 *   OrdersTotal(), OrderGetTicket(),  
 * @date : 2010.11.12
 * @see www.mql5.com/ru/docs/trading/ordergetinteger
 */
bool  OrderGetInteger(
   ENUM_ORDER_PROPERTY_INTEGER  property_id,      //  
   long&                long_var          //    
   );
/**
 *   OrderGetString
 *      ,
 *        OrderGetTicket
 *    OrderSelect.      string.
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false       .
 *           
 *    ,     .
 * @param property_id
 *   [in]    .    
 *      ENUM_ORDER_PROPERTY_STRING.
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string.
 * @note : 
 *            ,
 *        ""  
 *    ""  .   
 *            
 *    ,          
 *        .  
 *          
 *     OrderSelect()   
 *     .
 * @note  : 
 *   OrdersTotal(), OrderGetTicket(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/ordergetstring
 */
string  OrderGetString(
   ENUM_ORDER_PROPERTY_STRING  property_id        //  
   );
/**
 *   OrderGetString
 *      ,
 *        OrderGetTicket
 *    OrderSelect.      string.
 *    2  . ~ 1. 
 *      . ~ 2.  true 
 *    false       .
 *           
 *    ,     .
 * @param property_id
 *   [in]    .    
 *      ENUM_ORDER_PROPERTY_STRING.
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string.
 * @note : 
 *            ,
 *        ""  
 *    ""  .   
 *            
 *    ,          
 *        .  
 *          
 *     OrderSelect()   
 *     .
 * @note  : 
 *   OrdersTotal(), OrderGetTicket(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/ordergetstring
 */
bool  OrderGetString(
   ENUM_ORDER_PROPERTY_STRING  property_id,     & //  
   string&                     string_var        //    
   );
/**
 *   OrderGetTicket
 *        
 *           
 *    .
 * @param index
 *   [in]       .
 * @return 
 *     ulong.      0.
 * @note : 
 *            ,
 *        ""  
 *    "".      
 *     ? ?,    
 *       .     
 *           ,
 *              
 *      .  OrderGetTicket() 
 *         ,
 *      OrderGetDouble(), OrderGetInteger(),
 *   OrderGetString()    .
 *    ,         ( 
 *       ,  Stop Loss / Take
 *   Profit   ),      
 *    .     
 *         OrderGetTicket()
 *       .
 * @note  : 
 *   OrdersTotal(), OrderSelect(), OrderGetInteger()
 * @date : 2013.04.17
 * @see www.mql5.com/ru/docs/trading/ordergetticket
 */
ulong  OrderGetTicket(
   int  index      //    
   );
/**
 *   OrderSelect
 *         .
 *    true    . 
 *    false    .  
 *      ,  
 *     GetLastError().
 * @param ticket
 *   [in]   .
 * @return 
 *     bool.
 * @note : 
 *            ,
 *        ""  
 *    ""  .   
 *   ? .   ??????   
 *          ,   
 *             
 *     .  OrderSelect()  
 *        ,   
 *    OrderGetDouble(), OrderGetInteger(), OrderGetString()
 *      .  ,
 *           (   
 *      ,  Stop Loss / Take Profit
 *     ),      
 *    .     
 *         OrderSelect()
 *       .
 * @note  : 
 *   OrderGetInteger(), OrderGetDouble(), OrderGetString(), OrderCalcProfit(),
 *   OrderGetTicket(),  
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/orderselect
 */
bool  OrderSelect(
   ulong   ticket      //  
   );
/**
 *   OrderSend
 *    OrderSend()     
 *        .
 * @param request
 *   [in]      MqlTradeRequest,    .
 * @param result
 *   [in,out]      MqlTradeResult,
 *         
 *     ( true).
 * @return 
 *         ( )
 *    true -     
 *      .   
 *       
 *         result.
 * @note : 
 *           .
 *        
 *        request,   
 *           
 *   .     
 *      OrderSend()   true.
 *      
 *         .
 *        OrderCheck(),
 *         
 *      ,     
 *         
 *    : ~  ,    
 *     ; ~  ,   
 *       ; ~ 
 *     ,    
 *     ; ~   ,
 *        ; ~ 
 *    ,     ; ~
 *      ,  
 *        ; ~ 
 *    ,      
 *     ; ~    , 
 *    .
 *          ,  
 *      OrderSend()    
 *      .  
 *       result 
 *    retcode,     ,
 *       deal  order     
 *    .      
 *    ?   ?? ?? ????  
 *       ,      
 *      : ~   , ~
 *     , ~   
 *      , ~  
 *      .
 *          
 *        Trade,
 *       OnTrade().
 *        ,
 *     OrderSend()   
 *      OnTradeTransaction.
 *      ,    
 *        OnTradeTransaction
 *      . ,   
 *      ,  ,  
 *        , 
 *     ,     ,
 *      , 
 *      
 *        .  
 *          OnTradeTransaction.
 * @note  : 
 *     ,   , 
 *      ,  
 *     
 * @date : 2012.07.11
 * @see www.mql5.com/ru/docs/trading/ordersend
 */
bool  OrderSend(
   MqlTradeRequest&  request,      //  
   MqlTradeResult&   result        //  
   );
/**
 *   OrderSendAsync
 *    OrderSendAsync()    
 *         
 *      .   
 *     ,    
 *          
 *     .
 * @param request
 *   [in]      MqlTradeRequest,    .
 * @param result
 *   [in,out]      MqlTradeResult,
 *         
 *      (  true).
 * @return 
 *    true       .
 *       ,  false.
 *         result 
 *       TRADE_RETCODE_PLACED (
 *    10008)  " ".    
 *      ,     ,
 *            
 *    .     
 *         
 *        , 
 *    ,      Trade.
 *        ,
 *     OrderSendAsync()  
 *       OnTradeTransaction.
 *      ,    
 *        OnTradeTransaction
 *      . ,   
 *      ,  ,   
 *        , 
 *     ,     ,
 *      , 
 *      
 *        .  
 *        
 *     OnTradeTransaction.   
 *          
 *   : ~ trans -     
 *    MqlTradeTransaction,   ,
 *      ; ~ request -   
 *      MqlTradeRequest,  
 *    ,      
 *    ; ~ result -   
 *      MqlTradeResult,
 *       .
 * @note : 
 *         OrderSend(),
 *          ,
 *          
 *      .   
 *           
 *     .
 * @date : 2013.04.02
 * @see www.mql5.com/ru/docs/trading/ordersendasync
 */
bool  OrderSendAsync(
   MqlTradeRequest&  request,      //  
   MqlTradeResult&   result        //  
   );
/**
 *   OrdersTotal
 *      .
 * @return 
 *      int.
 * @note : 
 *            ,
 *        ""  
 *    "".      
 *     ,     
 *      .      
 *          ,   
 *             
 *     .
 * @note  : 
 *   OrderSelect(), OrderGetTicket(),  
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/orderstotal
 */
int  OrdersTotal();
/**
 *   PositionGetDouble
 *        ,
 *      
 *     PositionGetSymbol  PositionSelect. 
 *        double.   2 
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_POSITION_PROPERTY_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.      0.
 * @note : 
 *            
 *     ,     
 *     .      
 *      ,  
 *       ""  
 *    ""  .  
 *          
 *     PositionSelect()   
 *     .
 * @note  : 
 *   PositionGetSymbol(), PositionSelect(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/positiongetdouble
 */
double  PositionGetDouble(
   ENUM_POSITION_PROPERTY_DOUBLE  property_id      //  
   );
/**
 *   PositionGetDouble
 *        ,
 *      
 *     PositionGetSymbol  PositionSelect. 
 *        double.   2 
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_POSITION_PROPERTY_DOUBLE.
 * @param double_var
 *   [out]    double,     .
 * @return 
 *     double.      0.
 * @note : 
 *            
 *     ,     
 *     .      
 *      ,  
 *       ""  
 *    ""  .  
 *          
 *     PositionSelect()   
 *     .
 * @note  : 
 *   PositionGetSymbol(), PositionSelect(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/positiongetdouble
 */
bool  PositionGetDouble(
   ENUM_POSITION_PROPERTY_DOUBLE  property_id,     //  
   double&                        double_var       //    
   );
/**
 *   PositionGetInteger
 *        ,
 *      
 *     PositionGetSymbol  PositionSelect. 
 *        datetime, int.  2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param property_id
 *   [in]    .    
 *      ENUM_POSITION_PROPERTY_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *      long.      0.
 * @note : 
 *             
 *    ,     
 *     .      
 *      ,  
 *       ""  
 *    ""  .  
 *          
 *     PositionSelect()   
 *     .
 * @note  : 
 *   PositionGetSymbol(), PositionSelect(),  
 * @date : 2013.03.14
 * @see www.mql5.com/ru/docs/trading/positiongetinteger
 */
long  PositionGetInteger(
   ENUM_POSITION_PROPERTY_INTEGER  property_id      //  
   );
/**
 *   PositionGetInteger
 *        ,
 *      
 *     PositionGetSymbol  PositionSelect. 
 *        datetime, int.  2
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param property_id
 *   [in]    .    
 *      ENUM_POSITION_PROPERTY_INTEGER.
 * @param long_var
 *   [out]    long,     .
 * @return 
 *      long.      0.
 * @note : 
 *             
 *    ,     
 *     .      
 *      ,  
 *       ""  
 *    ""  .  
 *          
 *     PositionSelect()   
 *     .
 * @note  : 
 *   PositionGetSymbol(), PositionSelect(),  
 * @date : 2013.03.14
 * @see www.mql5.com/ru/docs/trading/positiongetinteger
 */
bool  PositionGetInteger(
   ENUM_POSITION_PROPERTY_INTEGER  property_id,     //  
   long&                           long_var         //    
   );
/**
 *   PositionGetString
 *        ,
 *      
 *     PositionGetSymbol  PositionSelect. 
 *        string.  2 
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_POSITION_PROPERTY_STRING.
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string.       .
 * @note : 
 *            
 *     ,     
 *     .      
 *      ,  
 *       ""  
 *    ""  .  
 *          
 *     PositionSelect()   
 *     .  ?? ???? PositionGetSymbol(),
 *   PositionSelect(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/positiongetstring
 */
string  PositionGetString(
   ENUM_POSITION_PROPERTY_STRING  property_id      //  
   );
/**
 *   PositionGetString
 *        ,
 *      
 *     PositionGetSymbol  PositionSelect. 
 *        string.  2 
 *    . ~ 1.   
 *    . ~ 2.  true  false
 *        .   
 *         
 *    ,     .
 * @param property_id
 *   [in]    .
 *         
 *    ENUM_POSITION_PROPERTY_STRING.
 * @param string_var
 *   [out]    string,     .
 * @return 
 *     string.       .
 * @note : 
 *            
 *     ,     
 *     .      
 *      ,  
 *       ""  
 *    ""  .  
 *          
 *     PositionSelect()   
 *     .  ?? ???? PositionGetSymbol(),
 *   PositionSelect(),  
 * @date : 2010.11.01
 * @see www.mql5.com/ru/docs/trading/positiongetstring
 */
bool  PositionGetString(
   ENUM_POSITION_PROPERTY_STRING  property_id,     //  
   string&                        string_var       //    
   );
/**
 *   PositionGetSymbol
 *       
 *           
 *       PositionGetDouble,
 *   PositionGetInteger, PositionGetString.
 * @param index
 *   [in]       .
 * @return 
 *     string.    ,    .
 *        
 *     GetLastError().
 * @note : 
 *   ???         
 *     ,     
 *     .      
 *      ,  
 *       ""   "
 *   ".        
 *        .
 * @note  : 
 *   PositionsTotal(), PositionSelect(),  
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/positiongetsymbol
 */
string  PositionGetSymbol(
   int  index      //    
   );
/**
 *   PositionSelect
 *          .
 *    true    . 
 *    false    .  
 *      ,  
 *     GetLastError().
 * @param symbol
 *   [in]    .
 * @return 
 *     bool.
 * @note : 
 *            
 *     ,     
 *     .      
 *      ,  
 *       ""  
 *    ""  .
 *    PositionSelect()    
 *     ,   
 *    PositionGetDouble(), PositionGetInteger()
 *    PositionGetString()   
 *    .  ,     
 *      (     , 
 *     ..),       
 *   .     
 *       
 *     PositionSelect()   
 *     .
 * @note  : 
 *   PositionGetSymbol(), PositionsTotal(),  
 * @date : 2010.08.12
 * @see www.mql5.com/ru/docs/trading/positionselect
 */
bool  PositionSelect(
   string  symbol     //  
   );
/**
 *   PositionsTotal
 *      .
 * @return 
 *     int.
 * @note : 
 *            
 *     ,     
 *     .      
 *      ,  
 *       ""   "
 *   ".        
 *           
 *     ?   .
 * @note  : 
 *   PositionGetSymbol(), PositionSelect(),  
 * @date : 2010.07.21
 * @see www.mql5.com/ru/docs/trading/positionstotal
 */
int  PositionsTotal();

